To retrieve molden source code:

ftp ftp.cmbi.kun.nl
Name: anonymous
Passord: your_email_address
ftp> binary
ftp> cd /pub/molgraph/molden
ftp> get molden3.7.tar.Z
ftp> quit

To build molden:

uncompress molden3.7.tar.Z
tar -xvf molden3.7.tar
cd molden3.6

# edit the makefile, activate the lines for your platform, deactivate
# silicon graphics

make >& make.log &

To build the opengl molden helper program (You may not have opengl support
on your system):

make moldenogl

To get ready to run executables for your platform (example for linux):

ftp ftp.cmbi.kun.nl
Name: anonymous
Passord: your_email_address
ftp> binary
ftp> cd /pub/molgraph/molden/bin
ftp> get molden3.7.linux
ftp> get moldenogl.linux
ftp> quit

molden3.7.linux is the molden executable and moldenogl.linux is the
molden opengl helper program.

Now move the molden executable to a directory that is in your search path,
say /usr/local/bin and call it molden.exe:

mv molden3.7.linux /usr/local/bin/molden.exe
mv moldenogl.linux /usr/local/bin/moldenogl

The proper setup of molden is to call a wrapper program of molden which
sets up the environment variables for the external program such as,
gamess, gaussian, mopac and tinker.

cat <<EOF > /usr/local/bin/molden
#!/bin/csh
#
setenv TA_ROOT /compchem/1/sybyl64
setenv TNK_ROOT /compchem/1/tinker
setenv MOPAC_ROOT /compchem/1/mopac93
setenv GAMESS_ROOT /compchem/1/gamess
setenv g98root /compchem/2
#
/usr/local/bin/molden.exe $argv
#
EOF

# remember to deactivate the external programs you dont have by putting
# a # in front of its line, make this file executable

chmod ugo+rx /usr/local/bin/molden

To run molden simply type:

molden

Or:

molden file1 file2 .. filen


The example is for linux, but there are many more unix platforms
and also windowsNT/windows95 and freebsd (molden_windows_nt_95.zip
and molden3.6-freebsd, moldenogl-freebsd)


NOTE: you will need to update the molden OpenGL helper program
      simultaneously with the upgrade from molden3.6 to molden3.7

      subroutine hcoodd(istat,ioatms,nstrt,
     &                  ipdbt,coo,ianz,iaton,iresid,iconn)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat

      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      integer*2 ipdbt
      logical hashy
      dimension tmp(3),ipdbt(*)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)

      istat = 1

c     nhbond in A.U. Atomic Units

      if (iatoms+ncalf.le.mxnat) then
         nhatm = iatoms
         do k=1,nchain
c
c           first residue
c
          if (iamino(ianf(k)).le.23.and.ianf(k).ge.nstrt) then
            hashy = .false.
            do n=1,iconn(1,icalf(2,ianf(k)))
               nn = abs(iconn(n+1,icalf(2,ianf(k))))
               if (ianz(nn).eq.1.and.nn.gt.ioatms) then
                  hashy = .true.
                  icalf(4,ianf(k)) = nn
                  iaton(nn) = 0
                  iresid(nn) = ianf(k)
               endif
            end do
            if (.not.hashy.and.iamino(ianf(k)).ne.15.and.
     &         iamino(ianf(k)).ne.0) then
               call bckok(ibckok,ianf(k),2)
               if (ibckok.eq.1) then
                  nhatm = nhatm + 1
                  icalf(4,ianf(k)) = nhatm
                  do j=1,3
                     tmp(j) = coo(j,icalf(1,ianf(k))) 
     &                      - coo(j,icalf(3,ianf(k)))
                  end do
                  tmpl = vlen(tmp)
                  do j=1,3
                     coo(j,nhatm) = coo(j,icalf(2,ianf(k))) 
     &                              +(tmp(j)/tmpl)*1.89d0
                  end do
                  iaton(nhatm) = 0
                  ianz(nhatm) = 1
                  iconn(1,nhatm) = 1
                  m = icalf(2,ianf(k))
                  iconn(2,nhatm) = m
                  iconn(1,m) = iconn(1,m) + 1
                  iconn(1+iconn(1,m),m) = nhatm
                  iresid(nhatm) = ianf(k)
                  ipdbt(nhatm) = 1
               endif
            endif
            ihb(1,ianf(k)) = 0
            ihb(2,ianf(k)) = 0
           endif
c
c           other residues
c
           if (ianf(k).ge.nstrt) then
            do i=ianf(k)+1,islu(k)
             if (iamino(i).le.23) then
               icalf(4,i) = 0
               hashy = .false.
               do n=1,iconn(1,icalf(2,i))
                  nn = abs(iconn(n+1,icalf(2,i)))
                  if (ianz(nn).eq.1.and.nn.gt.ioatms) then
                     hashy = .true.
                     icalf(4,i) = nn
                     iaton(nn) = 0
                     iresid(nn) = i
                  endif
               end do

               if (.not.hashy.and.iamino(i).ne.15) then

                  m = icalf(2,i)
                  idxc = icalf(3,i-1)
                  idxo = 0

                  do j=1,iconn(1,idxc)
                     kk = abs(iconn(j+1,idxc))
                     if (ianz(kk).eq.8.and.kk.gt.ioatms) idxo = kk
                  end do

                  call bckok(ibckok,i,2)

                  if (idxo.ne.0.and.ibckok.eq.1) then

                     nhatm = nhatm + 1
                     icalf(4,i) = nhatm

                     do j=1,3
                        tmp(j) = coo(j,idxc) - coo(j,idxo)
                     end do

                     tmpl = vlen(tmp)

                     do j=1,3
                        coo(j,nhatm) = coo(j,m) +
     &                             (tmp(j) / tmpl)*1.89d0
                     end do

                     iaton(nhatm) = 0
                     ianz(nhatm) = 1
                     iconn(1,nhatm) = 1
                     iconn(2,nhatm) = m
                     iconn(1,m) = iconn(1,m) + 1
                     iconn(1+iconn(1,m),m) = nhatm
                     iresid(nhatm) = i
                     ipdbt(nhatm) = 1
                  else
                     icalf(4,i) = 0
                  endif

               endif

               ihb(1,i) = 0
               ihb(2,i) = 0
              endif
            end do
           endif
         end do
         iatoms = nhatm
      else
         istat = 0
         do i=1,ncalf
            if (iamino(i).le.23) icalf(4,i) = 0
         end do
      endif

      return
      end

      double precision function phi(idx)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      real dihed
      dimension isel(4)

      phi = 0.0d0

      do i=1,nchain
        if (idx.eq.ianf(i)) return
      end do

      if (idx.le.ncalf.and.idx.gt.1) then
         call bckok(ibckok,idx,2)
         if (ibckok.eq.1) then
            isel(1) = icalf(3,idx-1)
            isel(2) = icalf(2,idx)
            isel(3) = icalf(1,idx)
            isel(4) = icalf(3,idx)
            call tomold(dihed,isel,4)
            phi = dihed
         endif
      endif

      return
      end

      double precision function psi(idx)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      real dihed
      dimension isel(4)

      psi = 0.0d0

      do i=1,nchain
        if (idx.eq.islu(i)) return
      end do

      if (idx.lt.ncalf.and.idx.ge.1) then
         isel(1) = icalf(2,idx)
         isel(2) = icalf(1,idx)
         isel(3) = icalf(3,idx)
         isel(4) = icalf(2,idx+1)
         call tomold(dihed,isel,4)
         psi = dihed
      endif

      return
      end

      subroutine hand(idx1,idx2,hang,coo,ianz,iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3),tem(3),coo(3,*),ianz(*),iconn(mxcon+1,*)

      idxc = icalf(3,idx1)
      idxo = 0
      do j=1,iconn(1,idxc)
         k = abs(iconn(j+1,idxc))
         if (ianz(k).eq.8) idxo = k
      end do
      if (idxo.eq.0) then
          print*,'subroutine hang: c without o'
          hang = 0.0d0
      else
         do j=1,3
            tmp(j) = coo(j,idxo) - coo(j,idxc)
         end do
   
         idxn = icalf(2,idx2)
         do j=1,3
            tem(j) = coo(j,idxn) - coo(j,icalf(4,idx2))
         end do

         call impsc(tmp,tem,cosb)
         hang = cosb
      endif
      
      return
      end

      integer function indhb(idx,distnw)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)

      dismax = 0.0d0
      do j=1,2
         if (ihb(j,idx).eq.0) then
            indhb = j
            return
         elseif (hbd(j,idx).gt.dismax) then
            dismax = hbd(j,idx)
            maxid = j
         endif
      end do
      indhb = -1
      if (distnw.lt.hbd(maxid,idx)) indhb = maxid

      return
      end

      subroutine hbodd(ioatms,nstrt,coo,ianz,iconn)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3),tem(3)
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)
  
      todeg=45.0d0/datan(1.0d0)

      do k=nstrt,ncalf
         dismin = 4.0d0/0.52917706d0
         do i=nstrt,ncalf
           if (icalf(4,i).ne.0.and.iamino(i).le.23) then
            idxc = icalf(3,k)
            idxo = 0
            do j=1,iconn(1,idxc)
               m = abs(iconn(j+1,idxc))
               if (ianz(m).eq.8.and.m.gt.ioatms) idxo = m
            end do
            do j=1,3
               tmp(j) = coo(j,idxo) - coo(j,icalf(4,i))
            end do
            dho = vlen(tmp)
            do j=1,3
               tem(j) = coo(j,idxo) - coo(j,icalf(2,i))
            end do
            dno = vlen(tem)
c check if angstrom
            if (dho.lt.6.6d0.and.dho.lt.dno.and.i.ne.k) then
               call hang(k,i,hand)
               cosb = hand
               if (dabs(dacos(cosb)*todeg).lt.95.d0.and.dho.lt.dismin
     &         .and.dho.lt.(5.1d0+1.89d0*dabs(cosb))) then
                  dismin = dho
                  i1 = indhb(k,dho)
                  if (i1.ne.-1) then
                     if (i1.eq.1.or.(i1.eq.2.and.ihb(1,k).ne.i)) then
                        ihb(i1,k) = i
                        hbd(i1,k) = dho
                     endif
                  endif
                  i2 = indhb(i,dho)
                  if (i2.ne.-1) then
                     if (i2.eq.1.or.(i2.eq.2.and.ihb(1,i).ne.k)) then
                        ihb(i2,i) = k
                        hbd(i2,i) = dho
                     endif
                  endif
               endif
            endif
          endif
         end do
      end do

      return
      end

      subroutine vadar(ioatms,nstrt)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      logical legitb

      phlast = 0.0d0

c hoe is isal geinitialiseerd -1 ?

c 0 Helix
c 1 Beta
c 2 RNA/DNA
c 3 Coil

      do i=nstrt,ncalf
        if (iamino(i).le.23) then
         ph = phi(i)
         ps = psi(i)
         if (ihb(1,i).ne.0) then
            if (legitb(i,0).and.ph.lt.-34.d0.and.ph.gt.-118.d0
     &          .and.ps.gt.-95.d0.and.ps.lt.6.d0) then
                isal(i) = 0
c hoe zit het met i=1, hieronder
                if (i.gt.1.and.isal(i-1).ne.0.and.isal(i-2).ne.
     &              0.and.phlast.lt.-55.d0.and.phlast.gt.-90.d0) 
     &              isal(i-1) = 0
                
            elseif (legitb(i,4).and.isal(i-1).eq.0) then
                isal(i) = 0
            elseif (legitb(i,1).and.ph.lt.-45.d0.and.ph.gt.-180.d0
     &          .and.((ps.gt.95.d0.and.ps.lt.180.d0).or.
     &          (ps.lt.-170.d0.and.ps.gt.-180.d0))) then
                isal(i) = 1
                if (i.gt.1.and.isal(i-1).ne.1.and.isal(i-2).ne.
     &          1.and.phlast.lt.-100.d0) isal(i-1) = 1
            elseif (legitb(i,5).and.ph.lt.-95.d0) then
                isal(i) = 1
            else
                if (i.gt.1.and.isal(i-1).eq.0.and.ph.lt.-55.d0
     &              .and.ph.gt.-100.d0) then
                    isal(i) = 0
                else
                    isal(i) = 3
                endif
            endif
         else
            isal(i) = 3
         endif
         phlast = ph
        else
           isal(i) = 2
        endif
      end do

c     smoothing

      do i=nstrt+2,ncalf-1
         if (isal(i-1).eq.1.and.isal(i).eq.3.and.isal(i+1).eq.1)
     &       isal(i) = 1
      end do
      do i=nstrt+2,ncalf-1
         if (isal(i-1).ne.1.and.isal(i).eq.1.and.isal(i+1).ne.1)
     &       isal(i) = 3
      end do
      do i=nstrt+2,ncalf-1
         if (isal(i-1).ne.0.and.isal(i).eq.0.and.isal(i+1).ne.0)
     &       isal(i) = 3
      end do

c     filter

      icount = 1
      ilast = 0
      do i=nstrt+2,ncalf
         if (isal(i).eq.isal(i-1)) then
            icount = icount + 1
         else
            if (ilast.eq.0.and.icount.lt.4) then
               do j=i-1,i-icount,-1
                  isal(j) = 3
               end do
            endif
            if (ilast.eq.1.and.icount.lt.4) then
               do j=i-1,i-icount,-1
                  isal(j) = 3
               end do
            endif
            icount = 1
         endif
         ilast = isal(i)
      end do

c      do i=1,nchain
c         if (iamino(ianf(i)).gt.23) isal(ianf(i)) = 3
c      end do

      return
      end

      logical function legitb(idx,itype)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      logical b3, b4

      b3 = .false.
      b4 = .false.
      
      legitb = .true.
      do i=1,2
         idist = abs(ihb(i,idx) - idx)
         if (ihb(i,idx).eq.0) idist = 0

         if (itype.eq.0) then
            if (idist.gt.2.and.idist.lt.6) return
         elseif (itype.eq.4) then
            if (idist.eq.3) b3 = .true.
            if (idist.eq.4) b4 = .true.
            if (b3.and.b4) return
         elseif (itype.eq.1) then
            if (idist.gt.2) return
         elseif (itype.eq.5) then
            if (idist.ge.6) return
         endif

      end do

      legitb = .false.

      return
      end

      subroutine acthd(iopt,hbfilt,coo,iconn,ianz)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3)
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*)

      do i=1,ncalf
        if (icalf(4,i).ne.0) then
         if (ihb(1,i).ne.0.and.hbd(1,i).lt.hbfilt) then

            m = icalf(4,i)
            idxc = icalf(3,ihb(1,i))
            ioxy = 0

            do j=1,iconn(1,idxc)
               n = abs(iconn(j+1,idxc))
               if (ianz(n).eq.8) ioxy = n
            end do

            do j=1,3
               tmp(j) = coo(j,m) - coo(j,ioxy)
            end do

            tmpl = vlen(tmp)

            if (dabs(tmpl-hbd(1,i)).gt.1.0d-3) then

               m = icalf(4,ihb(1,i))
               idxc = icalf(3,i)
               ioxy = 0

               do j=1,iconn(1,idxc)
                  n = abs(iconn(j+1,idxc))
                  if (ianz(n).eq.8) ioxy = n
               end do

            endif

            call hbconn(iopt,ioxy,m)

            if (ihb(2,i).ne.0.and.hbd(2,i).lt.hbfilt) then
               m = icalf(4,i)
               idxc = icalf(3,ihb(2,i))
               ioxy = 0

               do j=1,iconn(1,idxc)
                  n = abs(iconn(j+1,idxc))
                  if (ianz(n).eq.8) ioxy = n
               end do

               do j=1,3
                  tmp(j) = coo(j,m) - coo(j,ioxy)
               end do

               tmpl = vlen(tmp)

               if (dabs(tmpl-hbd(2,i)).gt.1.0d-3) then
                  m = icalf(4,ihb(2,i))
                  idxc = icalf(3,i)
                  ioxy = 0

                  do j=1,iconn(1,idxc)
                     n = abs(iconn(j+1,idxc))
                     if (ianz(n).eq.8) ioxy = n
                  end do

               endif

               call hbconn(iopt,ioxy,m)

            endif
         endif
       endif
      end do

      return
      end

      subroutine disabd(iopt,ianz,iaton,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension ianz(*),iaton(*),iconn(mxcon+1,*)

      do i=1,iatoms
          if (ianz(i).eq.1) then
             if (iopt.eq.0) then
                iaton(i) = 1
             elseif (iopt.eq.1) then
                iaton(i) = 0
             elseif (iopt.eq.2) then
                if (iconn(1,i).eq.1) then
                    if (iconn(2,i).gt.0) iaton(i) = 0
                elseif (iconn(1,i).eq.2) then
                    if (iconn(2,i).gt.0.and.iconn(3,i).gt.0) 
     &                  iaton(i) = 0
               
                endif
             endif
          endif
      end do

      return
      end

      subroutine hbcond(iopt,iat1,iat2,ianz,iatclr,iaton,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxel=100)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      dimension ianz(*),iatclr(*),iaton(*),iconn(mxcon+1,*)


      if (iat1.ne.0) then
         if (iopt.eq.1) then
            iaton(iat2) = 1
            iaton(iat1) = 1
            iatclr(iat2) = 15
            iatclr(iat1) = icol(ianz(iat1))
            iconn(1,iat2) = iconn(1,iat2) + 1
            iconn(1+iconn(1,iat2),iat2) = -iat1
            iconn(1,iat1) = iconn(1,iat1) + 1
            iconn(1+iconn(1,iat1),iat1) = -iat2
         else
            iaton(iat2) = 0
            iaton(iat1) = 0
            iconn(1,iat2) = iconn(1,iat2) - 1
            iconn(1,iat1) = iconn(1,iat1) - 1
         endif
      endif
 
      return
      end

      subroutine ribbd(iaton)
      implicit double precision (a-h,o-z)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      common /athlp/ iatoms, mxnat
      common /surf/  natorg,noscnd
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      dimension tmp(3),iaton(*)

      call vsetr(tmp,3,0.0d0)

      noscnd = iatoms

      call ribbon(0,0,1,0,tmp)
      call ribbon(1,0,1,0,tmp)
      call ribbon(2,0,1,0,tmp)
      call ribbon(3,0,1,0,tmp)

      call setarr(8,noscnd,idum)

      issdon = 1
      return
      end

      subroutine ribbod(istat,iscnd,dogl,nr,iungl,tori,
     &                  coo,ianz,iaton,iatclr,iresid,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (alpha = 32.0d0, beta = -11.0d0)
      parameter (torad = 3.1415926536/180.0)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (ncmx=32)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      integer dogl
      dimension vec1(3),vec2(3),quad(3,4),cooh(3,numcal),
     &          coot(3,numcal),cooca(3,numcal),hint(3),cvec(3),rvec(3)
      dimension tori(3),qnrm(3),hintb(3,3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*)

      istat = 1

      if (iscnd.eq.0) then
         iheldf = 3
      elseif (iscnd.eq.1) then
         iheldf = 4
      elseif (iscnd.eq.2) then
         iheldf = 10
      endif

      istrt  = 1
      iatorg = iatoms
      nfree = iatoms + 1
      cilrad = 0.2d0 / 0.52917706d0
      hlxwid = 2.4d0 / 0.52917706d0
      if (iscnd.eq.0) then
          hermhx = 4.7d0 / 0.52917706d0
      else
          hermhx = 3.0d0 / 0.52917706d0
      endif
      cos1 = dcos(torad*alpha)
      sin1 = dsin(torad*alpha)
      cos2 = dcos(torad*beta)
      sin2 = dsin(torad*beta)
 
100   continue

      if (istrt.ge.ncalf) return
      lhelx = 0
      ifrst = 0
      ilast = 0
      ia = 0
      is = 0
      do i=istrt,ncalf
         if (isal(i).eq.iscnd.and.ifrst.eq.0) then
             ifrst = i
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
         endif

         if (iscnd.eq.3.and.
     &      (isal(i).eq.3.and.isal(i+1).ne.3)) then
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
             if (i.eq.ia) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if (iscnd.eq.3.and.
     &      (isal(i).ne.3.and.isal(i+1).eq.3)) then
c             print*,i,islu(nchain),isal(i),isal(islu(nchain))
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
             if (i+1.eq.is) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if (iscnd.eq.3.and.
     &      ((isal(i).eq.0.and.isal(i+1).eq.1).or.
     &      (isal(i).eq.1.and.isal(i+1).eq.0))) then
             iia = 0
             iis = 0
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    iia = ianf(nn)
                    iis = islu(nn)
                endif
             end do
             if (i.ne.iia.and.i.ne.iis.and.i+1.ne.iis) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if ((isal(i).ne.iscnd.or.i.gt.is).and.ifrst.ne.0) goto 10
         if (i.eq.ncalf.and.ifrst.eq.0) return
         if (isal(i).eq.iscnd) lhelx = lhelx + 1
      end do
10    ilast = ifrst + lhelx - 1
      istrt = ilast + 1
 

      if (iscnd.eq.3) then
         if (ifrst.gt.ia) then
            ifrst = ifrst - 1
            lhelx = lhelx + 1
         endif
         if (ifrst+lhelx-1.lt.is) lhelx = lhelx + 1
         if (lhelx.eq.1) goto 100
      endif

20    iqopt = 1

c minimim Helix/Beta length of Four
 
      if (lhelx.le.0) return
      if (lhelx.gt.numcal) lhelx = numcal
      if (iscnd.ne.3.and.lhelx.lt.4.and.iamino(ifrst).le.23
     &    .and.ihashb.eq.0) goto 100
      if (iscnd.ne.3.and.lhelx.lt.3.and.iamino(ifrst).le.23) goto 100

      ihlx = 0
      do i=1,lhelx
         call bckok(ibckok,ifrst+i-1,1)
         if (ibckok.eq.1) then
            ihlx = ihlx + 1
            do j=1,3
               cooca(j,i) = coo(j,icalf(1,ifrst+i-1))
            end do
         endif
      end do
      lhelx = ihlx
 
c mag alleen in combinatie met chain break voor of na
c anders trek een recht lijntje
c      if (lhelx.le.2) goto 100

c compute tangent vectors for ca's in 
 
      do ica = 2,lhelx-1

        if (iscnd.eq.1) then
c           do j=1,3
c first try
c              cvec(j) = cooca(j,ica) - 
c     &                 (cooca(j,ica+1) + cooca(j,ica-1))*0.5d0
c           end do
c           call vsc1(cvec,1.0d0,1.0d-4)
           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,cvec)
           call vsc1(cvec,1.0d0,1.0d-4)
           
           do j=1,3
              cooh(j,ica) = cvec(j)
           end do

           do j=1,3
              cvec(j) = cooca(j,ica+1) - cooca(j,ica-1)
           end do
           call vsc1(cvec,1.0d0,1.0d-4)

           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,rvec)
           call vsc1(rvec,1.0d0,1.0d-4)
 
           do j=1,3
              coot(j,ica) = (cos2*cvec(j) + sin2*rvec(j))*hermhx
           end do

        else
           do j=1,3
              cvec(j) = cooca(j,ica+1) - cooca(j,ica-1)
           end do
           call vsc1(cvec,1.0d0,1.0d-4)

           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,rvec)
           call vsc1(rvec,1.0d0,1.0d-4)
 
           do j=1,3
              cooh(j,ica) = cos1*rvec(j) + sin1*cvec(j)
              coot(j,ica) = (cos2*cvec(j) + sin2*rvec(j))*hermhx
           end do
        endif
 
      end do
 
c find ca before and after chain
c Later check for chain break
 
      if (ifrst.gt.ia) ifrst = ifrst - 1
      if (ilast.lt.is) ilast = ilast + 1
 
c start initialization

      do j=1,3
           cooh(j,1) = cooh(j,2)
           coot(j,1) = cooca(j,2) - coo(j,icalf(1,ifrst))
           if (lhelx.eq.2) cooh(j,1) = -coot(j,1)
      end do
      call vsc1(coot(1,1),hermhx,1.0d-4)
 
c end initialization
 
      do j=1,3
         cooh(j,lhelx) = cooh(j,lhelx-1)
         if (iscnd.eq.1) then
            coot(j,lhelx) = coot(j,lhelx-1)
         else
            coot(j,lhelx) = coo(j,icalf(1,ilast)) - cooca(j,lhelx-1)
         endif
      end do
      call vsc1(coot(1,lhelx),hermhx,1.0d-4)

      if (iscnd.eq.1) then

c strand align and smooth
c alternating vector flip for subsequent ca's

        do ica=2,lhelx
           call timpsc(cooh(1,ica-1),cooh(1,ica),cimp)
           if (cimp.lt.0.0d0) then
              do j=1,3
                  cooh(j,ica) = -1.0d0 * cooh(j,ica)
              end do
           endif
        end do
        do ica=2,lhelx-1
           do j=1,3
               cooh(j,ica) = 
     &           cooh(j,ica-1) + cooh(j,ica) + cooh(j,ica+1)
           end do
           call vsc1(cooh(1,ica),1.0d0,1.0d-4)
        end do
        do ica=2,lhelx-1
           do j=1,3
               cooca(j,ica) = 0.5d0*(cooca(j,ica) +
     &           (cooca(j,ica-1) + cooca(j,ica+1))*0.5d0)
           end do
        end do

        if (dogl.eq.1.and.nr.eq.1) 
     &     write(iungl,'(a)') '[RIBBON] STRANDTOP'
        if (dogl.eq.1.and.nr.ge.2) 
     &     write(iungl,'(a)') '[RIBBON] STRANDBOTTOM'
      else
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.lt.2) 
     &     write(iungl,'(a)') '[RIBBON] HELIXOUT'
        if (dogl.eq.1.and.nr.ge.2.and.iscnd.lt.2) 
     &     write(iungl,'(a)') '[RIBBON] HELIXIN'
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.eq.2) 
     &   write(iungl,'(a)') '[RIBBON] RNA'
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.eq.3) 
     &   write(iungl,'(a)') '[RIBBON] COIL'
      endif

      if (dogl.eq.2) write(iungl,'(a)') 'mesh {'

 
c helix first segment edge

      do j=1,3
         if (dogl.ge.1) then
            if (iscnd.eq.1) then
               quad(j,1) = cooca(j,1) + hlxwid*cooh(j,1)/2.0d0
               quad(j,4) = cooca(j,1) - hlxwid*cooh(j,1)/2.0d0
            else
               quad(j,1) = cooca(j,1) + cilrad*cooh(j,1)
               quad(j,4) = cooca(j,1) - cilrad*cooh(j,1)
            endif
            hintb(j,3) = cooca(j,1)
         else
            if (nfree.le.mxnat) then
               coo(j,nfree)   = cooca(j,1)
            endif
         endif
      end do

      if (dogl.eq.0) then
         if (nfree.le.mxnat) then
            iconn(1,nfree) = 1
            iconn(2,nfree) = nfree+1
            iaton(nfree) = 1
            iatclr(nfree) = iheldf
            ianz(nfree) = 100
            iresid(nfree) = -iscnd
            nfree = nfree + 1
         else
            goto 1000
         endif
      endif
 
c helix/strand start 
 
      do iquad = 1, nquad
        t = dfloat(iquad)/dfloat(nquad)
 
        call intpol(hint,t,cooca(1,1),cooca(1,2),coot(1,1),coot(1,2))

        if (iscnd.eq.1) then
           rscal = hlxwid/2.0d0
        else
           rscal = cilrad + (hlxwid/2.0d0 - cilrad)*
     &          0.5d0*(-dcos(180.0d0*torad*t) + 1.0d0)
        endif

        do j=1,3
           if (dogl.ge.1) then
              vec1(j) = rscal*cooh(j,1)
              quad(j,2) = hint(j) + vec1(j)
              quad(j,3) = hint(j) - vec1(j)
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
              hintb(j,3) = hint(j)
           else
              coo(j,nfree)   = hint(j)
           endif
        end do

        if (dogl.ge.1) then

c compute normal

           call vsc1(vec1,1.0d0,1.0d-8)
           do j=1,3
              vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                  (quad(j,2) + quad(j,3))*0.5d0
           end do
           call vsc1(vec2,1.0d0,1.0d-8)
           call crprod(vec1,vec2,qnrm)
           call vsc1(qnrm,1.0d0,1.0d-8)

c put out quadrilateral

           if (iscnd.ge.2) then
              if (iquad.ge.2) then
                  call wrcoil(hintb(1,1),hintb(1,2),
     &                        hintb(1,3),iungl,tori,iqopt,dogl)
                  iqopt = 2
              endif
           else
              call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
              iqopt = 2
           endif
           do j=1,3
              quad(j,1) = quad(j,2)
              quad(j,4) = quad(j,3)
           end do

        else

           if (nfree.le.mxnat) then
              iconn(1,nfree) = 2
              iconn(2,nfree) = nfree+1
              iconn(3,nfree) = nfree-1
              iaton(nfree) = 1
              iatclr(nfree) = iheldf
              ianz(nfree) = 100
              iresid(nfree) = -iscnd
              nfree = nfree + 1
           else
              goto 1000
           endif

        endif

      end do
 
c helix/strand main 
 
      do ica = 2, lhelx - 2
        do iquad = 1, nquad

          t = dfloat(iquad)/dfloat(nquad)
 
          call intpol(hint,t,cooca(1,ica),cooca(1,ica+1),
     &                coot(1,ica),coot(1,ica+1))

          rscal = hlxwid/2.0d0
          do j=1,3
             vec1(j) = (1.0d0-t)*cooh(j,ica) + t*cooh(j,ica+1)
          end do

          call vsc1(vec1,rscal,1.0d-4)

          do j=1,3
              if (dogl.ge.1) then
                 quad(j,2) = hint(j) + vec1(j)
                 quad(j,3) = hint(j) - vec1(j)
                 hintb(j,1) = hintb(j,2)
                 hintb(j,2) = hintb(j,3)
                 hintb(j,3) = hint(j)
              else
                 if (nfree.le.mxnat) then
                    coo(j,nfree)   = hint(j)
                 endif
              endif
          end do

          if (dogl.ge.1) then

c compute normal

             call vsc1(vec1,1.0d0,1.0d-8)
             do j=1,3
                vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                    (quad(j,2) + quad(j,3))*0.5d0
             end do
             call vsc1(vec2,1.0d0,1.0d-8)
             call crprod(vec1,vec2,qnrm)
             call vsc1(qnrm,1.0d0,1.0d-8)

c put out quadrilateral

             if (iscnd.ge.2) then
                call wrcoil(hintb(1,1),hintb(1,2),
     &                      hintb(1,3),iungl,tori,iqopt,dogl)
             else
                call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
             endif
             do j=1,3
                quad(j,1) = quad(j,2)
                quad(j,4) = quad(j,3)
             end do

          else

             if (nfree.le.mxnat) then
                iconn(1,nfree) = 2
                iconn(2,nfree) = nfree+1
                iconn(3,nfree) = nfree-1
                iaton(nfree) = 1
                iatclr(nfree) = iheldf
                ianz(nfree) = 100
                iresid(nfree) = -iscnd
                nfree = nfree + 1
             else
                goto 1000
             endif

          endif


        end do
      end do
 
c helix/strand end
 
      if (lhelx.eq.2 ) then
        if (dogl.ge.1) then
           goto 200
        else
           if (nfree-1.le.mxnat) then
              iconn(1,nfree-1) = 1
              iconn(2,nfree-1) = iconn(3,nfree-1)
           endif
           goto 100
        endif
      endif

      do iquad = 1, nquad
        t = dfloat(iquad)/dfloat(nquad)
 
        call intpol(hint,t,cooca(1,lhelx-1),cooca(1,lhelx),
     &              coot(1,lhelx-1),coot(1,lhelx))

        if (iscnd.eq.1) then
           rscal = 1.8d0*hlxwid*(1.01d0-t)/2.0d0
        else
           rscal = cilrad + (hlxwid/2.0d0 - cilrad)*
     &          0.5d0*(dcos(180.0d0*torad*t) + 1.0d0)
        endif
        do j=1,3
           if (dogl.ge.1) then
              vec1(j) = rscal*cooh(j,lhelx)
              quad(j,2) = hint(j) + vec1(j)
              quad(j,3) = hint(j) - vec1(j)
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
              hintb(j,3) = hint(j)
           else
              if (nfree.le.mxnat) then
                 coo(j,nfree)   = hint(j)
              endif
           endif
        end do

        if (dogl.ge.1) then

c compute normal

           call vsc1(vec1,1.0d0,1.0d-8)
           do j=1,3
              vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                  (quad(j,2) + quad(j,3))*0.5d0
           end do
           call vsc1(vec2,1.0d0,1.0d-8)
           call crprod(vec1,vec2,qnrm)
           call vsc1(qnrm,1.0d0,1.0d-8)


c put out quadrilateral

           if (iscnd.ge.2) then
              call wrcoil(hintb(1,1),hintb(1,2),
     &                      hintb(1,3),iungl,tori,iqopt,dogl)
           else
              call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
           endif
           do j=1,3
              quad(j,1) = quad(j,2)
              quad(j,4) = quad(j,3)
           end do

        else

           if (nfree.le.mxnat) then
              iconn(1,nfree) = 2
              iconn(2,nfree) = nfree-1
              iconn(3,nfree) = nfree+1
              iaton(nfree) = 1
              iatclr(nfree) = iheldf
              ianz(nfree) = 100
              iresid(nfree) = -iscnd
              nfree = nfree + 1
           else
              goto 1000
           endif

        endif
 

      end do
 
200   continue

      if (dogl.ge.1) then
         if (iscnd.ge.2) then
            do j=1,3
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
c              hintb(j,3) = cooca(j,lhelx+1)
            end do
            do j=1,3
              hintb(j,3) = hintb(j,2) + (hintb(j,2) - hintb(j,1))
            end do
            call wrcoil(hintb(1,1),hintb(1,2),
     &                  hintb(1,3),iungl,tori,iqopt,dogl)
         else
            call wrquad(quad,qnrm,iungl,tori,3,nr,dogl)
         endif
      endif

      if (dogl.eq.2) then
         if (iscnd.eq.1) then
           if (nr.eq.1)
     &        write(iungl,'(a)') 'texture { STRANDTOP }'
           if (nr.ge.2)
     &        write(iungl,'(a)') 'texture { STRANDBOTTOM }'
         else
           if (nr.eq.1.and.iscnd.lt.2)
     &        write(iungl,'(a)') 'texture { HELIXOUT }'
           if (nr.ge.2.and.iscnd.lt.2)
     &        write(iungl,'(a)') 'texture { HELIXIN }'
           if (nr.eq.1.and.iscnd.eq.2)
     &      write(iungl,'(a)') 'texture { RNA }'
           if (nr.eq.1.and.iscnd.eq.3)
     &      write(iungl,'(a)') 'texture { COIL }'
         endif

         write(iungl,'(a)') '}'

      endif

      if (dogl.ge.1) goto 100


      if (nfree-1.le.mxnat) then
          iatoms = nfree-1
          iconn(1,nfree-1) = 1
      else
          goto 1000
      endif

      goto 100

1000  istat = 0
      iatoms = iatorg
      return
 
      end

      subroutine intpol(cnew,g,c1,c2,v1,v2)
      implicit double precision (a-h,o-z)
      dimension cnew(3),c1(3),c2(3),v1(3),v2(3)
 
      do i = 1, 3
        cnew(i) = c1(i)*(2.0*g*g*g - 3.0*g*g + 1.0)
     &          + c2(i)*(-2.0*g*g*g + 3.0*g*g)
     &          + v1(i)*(g*g*g - 2.0*g*g + g) + v2(i)*(g*g*g - g*g)
      end do
 
      return
      end

      subroutine wrquad(quad,qnrm,iungl,tori,iopt,nr,dogl)
      implicit double precision (a-h,o-z)
      parameter (ncmx=32)
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      integer dogl
      dimension quad(3,4),v1(3),v2(3),tori(3)
      dimension quadt(3,4),qnew(3),qnrm(3)

 
      ribbw = 0.4d0

      call vsc1(qnrm,1.0d0,1.0d-4)

      if (iopt.eq.1.and.nr.eq.4) then

c in between side quad of begin

         do j=1,3
            quadt(j,1) = quad(j,1) + qnrm(j)*ribbw
            quadt(j,4) = quad(j,4) + qnrm(j)*ribbw
            quadt(j,2) = quad(j,1) - qnrm(j)*ribbw
            quadt(j,3) = quad(j,4) - qnrm(j)*ribbw
         end do
         do j=1,3
            qnew(j) = (quad(j,2) + quad(j,3))*0.5d0 -
     &                (quad(j,1) + quad(j,4))*0.5d0
         end do
         call vsc1(qnew,1.0d0,1.0d-4)

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,4),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,quadt(1,3),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,quadt(1,3),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      endif

      if (iopt.eq.1) then
         do j=1,3
            qnew(j) = qnrm(j)
         end do
      elseif (iopt.eq.2) then
         do j=1,3
            qnew(j) = qnrm(j) + qnormo(j)
         end do
      elseif (iopt.eq.3) then
         do j=1,3
            qnew(j) = qnormo(j)
         end do
      endif

      call vsc1(qnew,1.0d0,1.0d-4)

c top and bottom strip

      if (nr.eq.1.or.nr.eq.2) then
         do i=1,4
            do j=1,3
               if (nr.eq.1) then
                  quadt(j,i) = quad(j,i) + qnew(j)*ribbw
               elseif (nr.eq.2) then
                  quadt(j,i) = quad(j,i) - qnew(j)*ribbw
               endif
            end do
         end do
      endif

c left side strip

      if (nr.eq.3) then
         do j=1,3
            quadt(j,1) = quad(j,1) + qnew(j)*ribbw
            quadt(j,2) = quad(j,2) + qnew(j)*ribbw
         end do
         do j=1,3
            quadt(j,4) = quad(j,1) - qnew(j)*ribbw
            quadt(j,3) = quad(j,2) - qnew(j)*ribbw
         end do
         do j=1,3
            qnew(j) = quad(j,4) - quad(j,1)
         end do
         call vsc1(qnew,1.0d0,1.0d-4)
      endif

c right side strip

      if (nr.eq.4) then
         do j=1,3
            quadt(j,1) = quad(j,4) + qnew(j)*ribbw
            quadt(j,2) = quad(j,3) + qnew(j)*ribbw
         end do
         do j=1,3
            quadt(j,4) = quad(j,4) - qnew(j)*ribbw
            quadt(j,3) = quad(j,3) - qnew(j)*ribbw
         end do
         do j=1,3
            qnew(j) = quad(j,4) - quad(j,1)
         end do
         call vsc1(qnew,1.0d0,1.0d-4)
      endif


      if (iopt.eq.2.or.iopt.eq.3) then

         if (dogl.eq.2) then
            call wrvert(qnew,quadt(1,4),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,quadt(1,4),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(crnrmo(1,1),crpnto(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif
      endif

      if (iopt.eq.1.or.iopt.eq.2) then
         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'

         call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,4),tori,iungl,dogl)

         if (dogl.eq.2) then
            do i=1,4
               do j=1,3
                  crpnto(j,1) = quadt(j,1)
                  crnrmo(j,1) = qnew(j)
               end do
            end do
         endif

      endif

      if (iopt.eq.3.and.nr.eq.4) then

c in between side quad of begin

         do j=1,3
            quadt(j,1) = quad(j,1) + qnrm(j)*ribbw
            quadt(j,4) = quad(j,4) + qnrm(j)*ribbw
            quadt(j,2) = quad(j,1) - qnrm(j)*ribbw
            quadt(j,3) = quad(j,4) - qnrm(j)*ribbw
         end do
         do j=1,3
            v1(j) = quadt(j,4) - quadt(j,1)
            v2(j) = quadt(j,2) - quadt(j,1)
         end do
         call crprod(v1,v2,qnew)
         call vsc1(qnew,1.0d0,1.0d-8)

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,4),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,quadt(1,3),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,quadt(1,3),tori,iungl,dogl)
         call wrvert(qnew,quadt(1,2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,quadt(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      endif

      do j=1,3
         qnormo(j) = qnrm(j)
      end do


      return
      end

      subroutine wrcoil(c1,c2,c3,iungl,tori,iopt,dogl)
      implicit double precision (a-h,o-z)
      parameter (ncmx=32)
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      integer dogl
      dimension c1(3),c2(3),c3(3),v1(3),v2(3),vt1(3),vt2(3),vt3(3)
      dimension tori(3),cirpnt(3,ncmx),cirnrm(3,ncmx)
      dimension ids(2)
 
      pi = 3.141592654d0
      twopi = 2*pi
      coilw = 0.5d0
      ids(1) = 1
      ids(2) = -1


c iopt = 1, first segment, only c2 and c3 defined

      do j=1,3
         vt1(j) = c1(j) - c2(j)
         vt2(j) = c3(j) - c2(j)
      end do
      call crprod(vt1,vt2,v2)
      call vsc1(v2,1.0d0,1.0d-8)

      call vsc1(vt1,1.0d0,1.0d-8)
      call vsc1(vt2,1.0d0,1.0d-8)

      do j=1,3
         v1(j) = vt1(j) + vt2(j)
      end do
      call vsc1(v1,1.0d0,1.0d-8)

      if (vlen(v1).lt.1.0d-8.and.iopt.ne.1) then
         do j=1,3
            v2(j) = crnrmo(j,numcir)
         end do
         call crprod(vt1,v2,v1)
      endif

      call crprod(v1,v2,vt3)

      
      do i=1,numcir
         s = twopi * dble(i)/dble(numcir)
         do j=1,3
            cirnrm(j,i) = dsin(s)*v1(j) + dcos(s)*v2(j)
            cirpnt(j,i) = c2(j) + cirnrm(j,i)*coilw
         end do
      end do

      if (iopt.eq.1) then

         call crprod(v2,vt1,v1)
         call vsc1(v1,1.0d0,1.0d-8)

         do i=1,numcir
            s = twopi * dble(i)/dble(numcir)
            do j=1,3
               crnrmo(j,i) = dsin(s)*v1(j) + dcos(s)*v2(j)
               crpnto(j,i) = c1(j) + crnrmo(j,i)*coilw
            end do
         end do

      endif

      idir = 1
      dismin = 10000.0d0
      do l=1,2
         do iof=0,numcir-1
            dsq = 0.0d0
            do i=1,numcir
               i1 = i
               i2 = iof + ids(l)*i
               if (i2.gt.numcir) then
                  i2 = i2 - numcir
               elseif (i2.lt.1) then
                  i2 = i2 + numcir
               endif
               dsq = dsq + dist2(crpnto(1,i1),cirpnt(1,i2))
            end do
            if (dsq.lt.dismin) then
               dismin = dsq
               ioff = iof
               idir = ids(l)
            endif
         end do
      end do

c write quads

      do i=1,numcir
         i1 = i
         i2 = i + 1
         if (i2.gt.numcir) i2 = i2 - numcir
         l1 = ioff + idir*i
         if (l1.gt.numcir) then
            l1 = l1 - numcir
         elseif (l1.lt.1) then
            l1 = l1 + numcir
         endif
         l2 = ioff + idir*(i+1)
         if (l2.gt.numcir) then
            l2 = l2 - numcir
         elseif (l2.lt.1) then
            l2 = l2 + numcir
         endif

c dogl.eq.2 (povray), split quad up in to triangles

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(crnrmo(1,i1),crpnto(1,i1),tori,iungl,dogl)
         call wrvert(crnrmo(1,i2),crpnto(1,i2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(cirnrm(1,l2),cirpnt(1,l2),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(cirnrm(1,l2),cirpnt(1,l2),tori,iungl,dogl)
         call wrvert(cirnrm(1,l1),cirpnt(1,l1),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(crnrmo(1,i1),crpnto(1,i1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      end do

      do i=1,numcir
         do j=1,3
            crnrmo(j,i) = cirnrm(j,i)
            crpnto(j,i) = cirpnt(j,i)
         end do
      end do

      return
      end

      subroutine wrvert(qnrm,qvert,tori,iungl,dogl)
      implicit double precision (a-h,o-z)
      integer dogl
      common /setogl/ idirogl
      dimension qnrm(3),qvert(3),tori(3)

      toang = 0.52917706d0

      if (idirogl.eq.1) then
        call ognrm(qnrm(1),qnrm(2),qnrm(3))
        call ogvrt(qvert(1),qvert(2),qvert(3))
      else
        if (dogl.eq.1) then
         write(iungl,'(3(f9.6,1x))') qnrm(1),qnrm(2),qnrm(3)
         write(iungl,'(3(f12.6,1x))') (qvert(1)-tori(1))*toang,
     &     (qvert(2)-tori(2))*toang,(qvert(3)-tori(3))*toang
        elseif (dogl.eq.2) then
         write(iungl,'(2(a,3(f12.6,a)))')
     &   '<',(qvert(1)-tori(1))*toang,',',(qvert(2)-tori(2))*toang,
     &   ',',(qvert(3)-tori(3))*toang,'>, ',
     &   '<',qnrm(1),',',qnrm(2),',',qnrm(3),'>'
        endif
      endif

      return
      end

      subroutine ribogl()
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /setogl/ idirogl
      common /rotmat/ rx(3),ry(3),rz(3),t(3), td(3)

      iun = 47
      open(unit=iun,form='formatted',status='scratch')


      idirogl = 1
c helix
         call ogribb
         call sribcol(2)
         call ribbon(0,1,1,iun,t)
         call ogendd

         call ogribb
         call sribcol(3)
         call ribbon(0,1,2,iun,t)
         call ogendd

         call ogribb
         call sribcol(3)
         call ribbon(0,1,3,iun,t)
         call ogendd

         call ogribb
         call sribcol(3)
         call ribbon(0,1,4,iun,t)
         call ogendd

c strand
         call ogribb
         call sribcol(1)
         call ribbon(1,1,1,iun,t)
         call ogendd

         call ogribb
         call sribcol(1)
         call ribbon(1,1,2,iun,t)
         call ogendd

         call ogribb
         call sribcol(1)
         call ribbon(1,1,3,iun,t)
         call ogendd

         call ogribb
         call sribcol(1)
         call ribbon(1,1,4,iun,t)
         call ogendd

c rna
         call ogribb
         call sribcol(4)
         call ribbon(2,1,1,iun,t)
         call ogendd

c coil
         call ogribb
         call sribcol(5)
         call ribbon(3,1,1,iun,t)
         call ogendd

         idirogl = 0

      close(iun)

      return
      end

      subroutine plotgr(ipen,dy,dx)
      implicit double precision (a-h,o-z)
      parameter (mxfill = 1000)
      logical euclid, yes
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*64 carray
      character*5 tk4014
      character*13 str
      real xx, yy
      integer*2 ixx
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /fill /  ixx(mxfill),nixx,ihight,icol1
      common /plot / iplot,iplwin,icolps
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /tektro/ carray, ic
      integer istmnt
      character*2 gstr

      if (euclid) then
         r2 = 1.0d0
      else
         r2 = dsqrt(2.0d0)
      endif

      dx = 0.5d0 + dx / r2
      dy = 0.5d0 + dy / r2

      isgrey = 0
      if (grey.lt.1.0) isgrey = 1

      if (iplot.eq.6) then
         xx = dx
         yy = dy
         if (ipen.eq.1) then
             if (oclose.and.ofill) then
                if (nixx.gt.1) then
                   nixx = nixx + 1
                   ixx(2*nixx-1) = ixx(1)
                   ixx(2*nixx)   = ixx(2)
                   icol1 = 10
                   if (isgrey.eq.1) icol1  = 6
                   call drwpol(ixx,nixx,icol1,0,isgrey)
                endif
                nixx = 1
                ixx(1) = dx*ihight
                ixx(2) = (1.0-dy)*ihight
             endif
             call xwin(xx,yy,2,str,nstr,inct,incp)
             if (yes.and.euclid) then
                 str = gstr(icnt)
                 call xwin(xx,yy,4,str,2,inct,incp)
             endif 
         else
             if (oclose.and.ofill) then
                 if (nixx.le.mxfill-2) then
                    nixx = nixx + 1
                    ixx(2*nixx-1) = dx*ihight
                    ixx(2*nixx)   = (1.0-dy)*ihight
                 endif
             endif
             call xwin(xx,yy,3,str,nstr,inct,incp)
         endif
         return
      endif

      dx = max(0.d0,min(1.d0,dx))
      dy = max(0.d0,min(1.d0,dy))
      istmnt = ipen
      if (ipen.eq.2) then
        if (iplot.eq.0) assign 20 to istmnt
        if (iplot.eq.1) assign 40 to istmnt
        if (iplot.eq.2) assign 60 to istmnt
        if (iplot.eq.4) assign 100 to istmnt
      else
        if (iplot.eq.0) assign 10 to istmnt
        if (iplot.eq.1) assign 30 to istmnt
        if (iplot.eq.2) assign 50 to istmnt
        if (iplot.eq.4) assign 90 to istmnt
      endif
      if (iplot.eq.0.or.iplot.eq.1) write(iun4,istmnt)dx,dy
      if (iplot.eq.2) then
        write(iun4,istmnt)char(27),int(dx*389),int(dy*389)
      endif
      if (iplot.eq.4) then
        if (ipen.ne.2) then
          if (oclose.and.ofill) then
              write(iun4,*) 'closepath'
              write(iun4,*) 'gsave'
              if (icolps.eq.1) then
                 if (isgrey.eq.1) then
                    write(iun4,*) 'negfill setcol'
                 else
                    write(iun4,*) 'posfill setcol'
                 endif
              else
                 write(iun4,*)  grey,' setgray'
              endif
              write(iun4,*) 'fill'
              write(iun4,*) 'grestore'
              if (icolps.eq.0) then
                 write(iun4,*) '0 setgray'
              endif
          endif
          write(iun4,'(''s'')')
          if (euclid) then
             if (yes) then
                write(iun4,'(''tabel {'',i4,'' '',i4,'' m ('',
     &                     i2,'') show } if'')')
     &           int(dx*2000),int(dy*2000+125),icnt
             else
                if (cntval.ne.99.999)
     &           write(iun4,'(''contourvalues {'',i4,'' '',i4,'' m ('',
     &                     f10.6,'') show } if'')')
     &           int(dx*2000),int(dy*2000+125),cntval
             endif
          endif
          write(iun4,'(''n'')')
        endif
        write(iun4,istmnt)int(dx*2000),int(dy*2000)+125
      endif
      if (iplot.eq.3) then
         if (ipen.eq.1) then
c-- voer laaste line series uit
           if (carray(1:1).eq.char(29)) then
            carray(7+ic*5:7+ic*5) = char(13)
            write(iun4,'(a)') carray(1:7+ic*5)
           endif
           carray(1:1) = char(29)
           carray(2:6) = tk4014(int(dx*3100),int(dy*3100))
           ic = 0
         else
           if (ic.eq.9) then
             carray(7+ic*5:7+ic*5) = char(13)
             write(iun4,'(a)') carray(1:7+ic*5)
             carray(2:6)  = carray(2+ic*5:6+ic*5)
             carray(7:11) = tk4014(int(dx*3100),int(dy*3100))
             ic = 1
           else
             ic = ic + 1
             carray(2+ic*5:6+ic*5) = tk4014(int(dx*3100),
     &       int(dy*3100))
           endif
         endif
      endif
10    format('.m',f8.5,f8.5)  
20    format('.d',f8.5,f8.5)
30    format('PU',f8.4,f8.4,';')  
40    format('PD',f8.4,f8.4,';')
50    format(a,'*pa',i3,',',i3,'Z')
60    format(a,'*pb',i3,',',i3,'Z')
90    format(' ',i4,' ',i4,' m')
100    format(' ',i4,' ',i4,' l')
      if (yes.and.euclid) then
        if (iplot.eq.0) then
           write(iun4,'(''.to 3'')')
           write(iun4,'(''.ch 1.2'')')
           write(iun4,'(''.pt '',i2)') icnt
           write(iun4,'(''.to 5'')')
           write(iun4,'(''.ch 1.5'')')
        endif
        if (iplot.eq.1) then
           write(iun4,'(''LB'',i2,a,'';'')')icnt,char(3)
        endif
      endif

      return
      end

      subroutine oginid(r,adjus,natoms,nat,icol,xyz,xsym,ysym,zsym,
     &                  vdwr,cnst,npts1,npts2)
      implicit double precision (a-h,o-z)
      dimension r(*),xyz(3,*),xsym(*),ysym(*),zsym(*),vdwr(*)
      dimension nat(*),icol(*)

      idum = 0

      return
      end

      subroutine runjob(imod,iqopt,ihaszm)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /xyzopt/ ixyz,ichx,icrtp,ipdbwh,iambch
      character*80 glin1,glin2,gtitl,rungam
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,
     &                glin1,glin2,gtitl,jname,qname,rungam
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm
      common /types/ iff
      integer dolabs,fancy,persp,shade,atcol
      logical fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*80 taroot
      character*80 pwd
      character*11 ename
      character*80 outfil
      character*137 line
      logical mapxyz,opfil,domap
      
      izmtmp = ihaszm

      jlen = linlen(jname)
      iqlen = linlen(qname)
      itnkln = linlen(tnknm)

      ename = 'PWD'
      call getenv(ename,pwd)

      ig94 = 1
      itnk = 0
      if (imod.eq.1) then
         ename = 'TA_ROOT'
      elseif (imod.eq.2) then
         ename = 'QNT_ROOT'
      elseif (imod.eq.3) then
         ename = 'TNK_ROOT'
      elseif (imod.eq.4) then
         ename = 'GAMESS_ROOT'
      elseif (imod.eq.5) then
         ename = 'g94root'
      elseif (imod.eq.6) then
         ename = 'MOPAC_ROOT'
      elseif (imod.eq.7) then
         ename = 'XTINKER'
      elseif (imod.eq.8) then
         ename = 'AMBFOR'
      endif

      call getenv(ename,taroot)
      if (taroot(1:1).eq.' ') then
          if (imod.eq.1) then
            call inferr('Environment variable TA_ROOT not set !',0)
            call zmterr('Environment variable TA_ROOT not set !',1,0,1)
          elseif (imod.eq.2) then
            call inferr('Environment variable QNT_ROOT not set !',0)
            call zmterr('Environment variable QNT_ROOT not set !',1,0,1)
          elseif (imod.eq.3) then
            call inferr('Environment variable TNK_ROOT not set !',0)
            call zmterr('Environment variable TNK_ROOT not set !',1,0,1)
          elseif (imod.eq.4) then
            call inferr('Environment variable GAMESS_ROOT not set !',0)
            call zmterr('Environment variable GAMESS_ROOT not set !',1,
     &                  0,1)
          elseif (imod.eq.5) then
            ename = 'g92root'
            call getenv(ename,taroot)
            if (taroot(1:1).eq.' ') then
               ename = 'g98root'
               call getenv(ename,taroot)
            else
               ig94 = 0
            endif
            if (taroot(1:1).eq.' ') then
               ename = 'g03root'
               call getenv(ename,taroot)
            else
               ig94 = 2
               goto 10
            endif
            if (taroot(1:1).eq.' ') then
               call inferr(
     &         'Environment variable g92/g94/g98/g03root not set !',0)
               call zmterr(
     &     'Environment variable g92/g94/g98/g03root not set !',1,0,1)
               goto 10
            else
               ig94 = 3
               goto 10
            endif
          elseif (imod.eq.6) then
            call inferr('Environment variable MOPAC_ROOT not set !',0)
            call zmterr('Environment variable MOPAC_ROOT not set !',1,
     &                   0,1)
          elseif (imod.eq.7) then
            ename = 'TNK_ROOT'
            call getenv(ename,taroot)
            if (taroot(1:1).eq.' ') then
               call inferr(
     &         'Environment variable TNK_ROOT/XTINKER not set !',0)
            else
               itnk = 1
               goto 10
            endif
          elseif (imod.eq.8) then
            taroot = '/usr/local/bin/'
            goto 10
          endif
          return
      endif
10    itlen = linlen(taroot)

      iun = 50
      iuncln = 51

      if (imod.eq.1) then
         ixyz = 1
         call wrpnt('molin.mol2',10,4,0,0,0,0,1,.false.)
      elseif (imod.eq.2) then
         ixyz = 2
         call wrpnt('molin.msf',9,4,0,0,0,0,1,.false.)
      elseif (imod.eq.3) then
         ixyz = 3
         call wrpnt(tnknm(1:itnkln)//'.xyz',itnkln+4,4,0,0,0,
     &      0,1,.false.)
      elseif (imod.eq.4) then
         call wrpnt(jname(1:jlen)//'.in',1,19,0,0,0,
     &              0,1,.false.)
      elseif (imod.eq.5) then
         call wrpnt(jname(1:jlen)//'.com',1,20,0,0,0,
     &              0,1,.false.)
      elseif (imod.eq.6) then
         call wrpnt(jname(1:jlen)//'.dat',1,21,0,0,0,
     &              0,1,.false.)
      elseif (imod.eq.7) then
         if (iff.ne.1) then
             iff = 1
             call dotyp(1)
         endif
         ixyz = 5
         call wrpnt(tnknm(1:itnkln)//'.cssr',itnkln+5,4,0,0,
     &               0,0,1,.false.)
         if (iqopt.eq.0) then
            call fdat(16,0,0,0,0,0)
         else
            call fdat(17,0,0,0,0,0)
         endif
         call fdat(ifd,0,0,0,0,0)
      elseif (imod.eq.8) then
         ixyz = 11
         call wrpnt(tnknm(1:itnkln)//'.xyz',itnkln+4,4,0,0,0,
     &      0,1,.false.)
      endif

      if (imod.ne.8) then
         if (imod.ge.3) then
            if (imod.eq.3.or.imod.eq.7) then
               open(unit=iun,form='formatted',
     &           file=tnknm(1:itnkln)//'.run',
     &           status='unknown',err=100)
               open(unit=iuncln,form='formatted',file='clnjob',
     &           status='unknown',err=100)
            else
               open(unit=iun,form='formatted',
     &           file=jname(1:jlen)//'.run',
     &           status='unknown',err=100)
            endif
         else
            open(unit=iun,form='formatted',file='runjob',
     &           status='unknown',err=100)
         endif
      endif

      if (imod.eq.1) then
      write(iun,'(''#!/bin/sh'')')
      write(iun,*) 'rm molout.mol2'
      write(iun,*) '. $TA_ROOT/lib/.profile'
      write(iun,*) '$TA_ROOT/bin/sybyl << EOF > molout.log'
      write(iun,*) 'tailor set mol file_format mol2 | |'
      write(iun,*) 'set autosave off'
      write(iun,*) 'mol in M1 molin.mol2'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MINIMIZATION_METHOD POWELL'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!TERMINATION_OPTION GRADIENT'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MIN_ENERGY_CHANGE  0.050'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!RMS_GRADIENT  0.050'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!RMS_DISPLACEMENT  0.001'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MAXIMUM_ITERATIONS 1000'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!PARAMETER_SET Tripos'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!NON_BONDED_CUTOFF 8.0'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!DIELECTRIC_CONSTANT 1.0'
      write(iun,*) 
     &  'SETVAR TAILOR!FORCE_FIELD!DIELECTRIC_FUNCTION distance'
      write(iun,*) 
     &  'SETVAR TAILOR!FORCE_FIELD!REVIEW_HS_AND_LPS DO_NOT_CHANGE'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!LIST_TERMS NO'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!ONE_FOUR_SCALING 1.0'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!HBOND_RAD_SCALING 0.7'
      write(iun,*) 'MAXIMIN2 M1 Electrostatics IGNORE_ELECTROSTATICS ',
     &             char(92)
      write(iun,*) 'Interesting M1(*-(0)) Boundary_Conditions ',char(92)
      write(iun,*) 'IGNORE_PBCS List DONE INTERACTIVE'
      write(iun,*) 'mol out M1 molout.mol2'
      write(iun,'(''EOF'')')
      elseif (imod.eq.2) then
      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'unalias mv'
      write(iun,*) 'unalias rm'
      write(iun,*) 'source /compchem/1/msi/quanta96/.setquanta'
      write(iun,*) 'mkdir qnt$$'
      write(iun,*) 'cd qnt$$'
      write(iun,*) 'cat <<EOF > quanta.scr'
      write(iun,*) 'mole init molin.msf'
      write(iun,*) 'charm init'
      write(iun,*) 'charm writ psf'
      write(iun,*) 'charm set mini nstep 1000'
      write(iun,*) 'charm do mini'
      write(iun,*) 'msf save over'
      write(iun,*) 'end'
      write(iun,'(''EOF'')')
      write(iun,*) 'cp $HYD_LIB/default.cst .cst'
      write(iun,*) 'mv ../molin.msf .'
      write(iun,*) 'chmod u+rwx .cst'
      write(iun,*) 'quanta -n -i quanta.scr -l quanta >& /dev/null'
      write(iun,*) 'mv molin.msf ..'
      write(iun,*) 'mv quanta.log ..'
      write(iun,*) 'cd ..'
      write(iun,*) 'unalias rm'
      write(iun,*) 'rm -rf qnt$$'
      elseif (imod.eq.3.or.imod.eq.7) then
      write(iuncln,'(''#!/bin/csh -f'')')
      write(iuncln,*) 'unalias rm'
      write(iuncln,*) 'if ( -e '//tnknm(1:itnkln)//
     &                ' ) mv '//tnknm(1:itnkln)//' '//
     &                tnknm(1:itnkln)//'.bck'

      if (imod.eq.3) then
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.xyz_*'
      else
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.cssr_*'
      endif
      write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
      write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.arc*'
      close(iuncln)
      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'unalias rm'
      write(iun,*) 'rm clnjob'
      write(iun,*) 'setenv AMBER amber'
      write(iun,*) 'setenv CHARMM charmm'
      write(iun,*) 
     &  'if ( -f $TNK_ROOT/params/amber99.prm ) setenv AMBER amber99'
      write(iun,*) 
     &  'if ( -f $TNK_ROOT/params/charmm27.prm ) setenv CHARMM charmm27'
      if (imod.eq.3) then
        write(iun,*) 'cat <<EOF > '//tnknm(1:itnkln)//'.key'
        if (iff.le.1) then
         write(iun,*) 'parameters $TNK_ROOT/params/mm3'
         write(iun,*) 'torsion       5   2   3   6       '//
     &                '0.000 +1     8.000 -2     0.000 +3'
         write(iun,*) 'torsion       2   3   6  24       '//
     &                '0.000 +1     0.500 -2     0.000 +3'
         write(iun,*) 'angle         1    3    77    '//
     &                '0.850    123.500    123.500      0.000'
         write(iun,*) 'angle         1    3    78    '//
     &                '0.850    123.500    123.500      0.000'
         write(iun,*) 'angle         5    1    75    '//
     &                '0.820    110.000    108.900    108.700'
         write(iun,*) 'opbend        3    77         0.650'
         write(iun,*) 'opbend        3    78         0.650'
        elseif (iff.eq.2) then
         write(iun,*) 'parameters $TNK_ROOT/params/$CHARMM'
        elseif (iff.eq.3) then
         write(iun,*) 'parameters $TNK_ROOT/params/$AMBER'
        elseif (iff.eq.4) then
         write(iun,*) 'parameters $TNK_ROOT/params/amoebapro.prm'
        endif
        if (.not.(tnkbg.eq.1.and.tnkarc.eq.0)) 
     &     write(iun,*) 'save-cycle'
        write(iun,*) 'maxiter ',tnkit
        write(iun,'(''EOF'')')
      else
        write(iun,*) 'cat < tnk.key > '//tnknm(1:itnkln)//'.key'
        write(iun,*) 'rm tnk.key'
        write(iun,*) 'cat <<EOF >>'//tnknm(1:itnkln)//'.key'
        if (.not.(tnkbg.eq.1.and.tnkarc.eq.0)) 
     &     write(iun,*) 'save-cycle'
        write(iun,*) 'maxiter ',tnkit
        write(iun,*) 'writeout 1'
        write(iun,'(''EOF'')')
      endif

      if (tnkprg.eq.0) then
         write(iun,*) '$TNK_ROOT/bin/minimize '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
      elseif (tnkprg.eq.1) then
         write(iun,*) '$TNK_ROOT/bin/optimize '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
      elseif (tnkprg.eq.2) then
         write(iun,*) '$TNK_ROOT/bin/newton '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         write(iun,*) ' '
         write(iun,*) ' '
      elseif (tnkprg.eq.3) then
         write(iun,*) '$TNK_ROOT/bin/dynamic '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         write(iun,*) '10000'
         write(iun,*) ' '
         write(iun,*) ' '
         write(iun,*) ' '
         write(iun,'(''EOF'')')
      elseif (tnkprg.eq.4) then
         if (itnk.eq.1) then
            write(iun,*) '$TNK_ROOT/bin/xxtalmins c '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         else
            write(iun,*) '$XTINKER/bin/xxtalmins c '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         endif
      endif

      if (tnkprg.lt.3.or.tnkprg.eq.4) then
         write(iun,'(f12.8)') rmsgrd
         write(iun,'(''EOF'')')
      endif

      if (tnkbg.eq.1.and.tnkarc.eq.1) then
         if (imod.eq.3) then
            write(iun,*) '$TNK_ROOT/bin/archive '//tnknm(1:itnkln)
     &                   //' <<EOF >>& '//tnknm(1:itnkln)//'.log'
            write(iun,*) ' '
            write(iun,*) ' '
            write(iun,*) '1 1000 ',tnkarf
            write(iun,'(''EOF'')')
         else
            write(iun,*) 'cat '//tnknm(1:itnkln)//'.[0-9]* > '//
     &                    tnknm(1:itnkln)//'.arc'
         endif
         write(iun,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
      endif

      elseif (imod.eq.4) then
         write(iun,'(''#!/bin/csh'')')
         write(iun,'(a)') rungam(1:linlen(rungam))
      elseif (imod.eq.5) then
         write(iun,'(''#!/bin/csh'')')
         if (ig94.eq.1) then
            write(iun,*) 'source $g94root/g94/bsd/g94.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g94 '//jname(1:jlen)
            else
               write(iun,*) 'subg94 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif
         elseif (ig94.eq.2) then
            write(iun,*) 'source $g98root/g98/bsd/g98.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g98 '//jname(1:jlen)
            else
               write(iun,*) 'subg98 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif
         elseif (ig94.eq.3) then
            write(iun,*) 'source $g03root/g03/bsd/g03.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g03 '//jname(1:jlen)
            else
               write(iun,*) 'subg03 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif
         else
            write(iun,*) 'source $g92root/g92/bsd/g92.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g92 '//jname(1:jlen)
            else
               write(iun,*) 'subg92 '//qname(1:iqlen)//' '//
     &                       jname(1:jlen)
            endif
         endif
         write(iun,*) ' '
         write(iun,*) ' '
         write(iun,*) ' '
      elseif (imod.eq.6) then
         write(iun,'(''#!/bin/csh'')')
         if (ibatch.eq.0) write(iun,*) 'cd '//pwd(1:linlen(pwd))
         write(iun,*) taroot(1:itlen)//'/bin/mopac.csh '//
     &                jname(1:jlen)//
     &                ' >& /dev/null'
      endif

      if (imod.ne.8) close(iun)

c make jobscript executable

      if (imod.ge.3) then
         if (imod.eq.3.or.imod.eq.7) then
            taroot = 'chmod u+x '//tnknm(1:itnkln)//'.run'
            nstr = itnkln+14
         else
            taroot = 'chmod u+x '//jname(1:jlen)//'.run'
            nstr = jlen+14
         endif
      else
         taroot = 'chmod u+x runjob'
         nstr = 16
      endif

      iextmp = 0
      if (imod.ne.8) call exstr(taroot,nstr,iextmp)

c prepare cleaning up

      if (imod.eq.3.or.imod.eq.7) then
         taroot = 'chmod u+x clnjob'
         nstr = 16
         iextmp = 0
         call exstr(taroot,nstr,iextmp)
         taroot = '.'//char(47)//'clnjob'
         nstr = 8
         iextmp = 0
         call exstr(taroot,nstr,iextmp)
      endif

c are you ready ?

      if (imod.ne.3.and.imod.ne.7.and.imod.ne.8) call curs(1)
      call confrm(0,istat)
      if (istat.ne.1) then
          call curs(0)
          return
      endif

      if (imod.ge.3.and.imod.ne.8) then
         if (imod.eq.6.and.ibatch.eq.0) then
            taroot = 'qsub -eo -q '//qname(1:iqlen)//' '//
     &               jname(1:jlen)//'.run'
            nstr = jlen+iqlen+17
         else
            if (imod.eq.3.or.imod.eq.7) then
               taroot = '.'//char(47)//tnknm(1:itnkln)//'.run'
               nstr = itnkln+6
               if (tnkbg.eq.0) then
                   taroot = tnknm(1:itnkln)
                   nstr = itnkln
               endif
            else
               taroot = '.'//char(47)//jname(1:jlen)//'.run'
               nstr = jlen+6
            endif
         endif
      elseif (imod.eq.8) then
         taroot = 
     &      'ambfor '//tnknm(1:itnkln)//'.xyz'
         nstr = 7 + itnkln + 4
      else
        
         taroot = '.'//char(47)//'runjob'
         nstr = 8
      endif

c execute or batching of jobscript

      iextmp = 0
      if (imod.lt.3.or.(imod.ge.4.and.ibatch.eq.0).or.
     &    ((imod.eq.3.or.imod.eq.7).and.tnkbg.eq.0).or.
     &    (imod.eq.8.and.tnkbg.eq.0)) then

         if ((imod.eq.3.or.imod.eq.7.or.imod.eq.8).and.
     &        tnkbg.eq.0) then

c    tinker in the background updating screen; also fork

            if (imod.eq.8) then
               taroot = tnknm(1:itnkln)
               nstr = itnkln
               iextmp = 3
               call exstr(taroot,nstr,iextmp)
            else
               iextmp = 2
               call exstr(taroot,nstr,iextmp)
            endif
         else

c    system

            iextmp = 0
            call exstr(taroot,nstr,iextmp)
         endif

      else

c    fork

         if (imod.eq.8) then
            taroot = tnknm(1:itnkln)
            nstr = itnkln
            iextmp = 4
         else
            iextmp = 1
         endif
         call exstr(taroot,nstr,iextmp)

      endif

      iexst = iextmp

c clean up tinker cycle files of a non detached job

      if ((imod.eq.3.or.imod.eq.7).and.tnkbg.eq.0) then
         open(unit=iuncln,form='formatted',file='clnjob',
     &     status='unknown',err=100)
         write(iuncln,'(''#!/bin/csh -f'')')
         if (tnkarc.eq.1) then
          if (imod.eq.3) then
            write(iuncln,*) '$TNK_ROOT/bin/archive '//tnknm(1:itnkln)
     &                     //' <<EOF >>& '//tnknm(1:itnkln)//'.log'
            write(iuncln,*) ' '
            write(iuncln,*) ' '
            write(iuncln,*) '1 1000 ',tnkarf
            write(iuncln,'(''EOF'')')
          else
            write(iuncln,*) 'cat '//tnknm(1:itnkln)//'.[0-9]* > '//
     &                    tnknm(1:itnkln)//'.arc'
          endif
         endif
         write(iuncln,*) 'unalias rm'
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
         write(iuncln,*) 'rm clnjob'
         close(iuncln)
         iextmp = 0
         taroot = 'chmod u+x clnjob'
         nstr = 16
         call exstr(taroot,nstr,iextmp)
         taroot = '.'//char(47)//'clnjob'
         nstr = 8
         call exstr(taroot,nstr,iextmp)
      endif

c open to be mapped file

      ierr = 0
      iform = 1
      domap = .true.
      if (imod.eq.1) then
         nstr = 11
         outfil = 'molout.mol2'
      elseif (imod.eq.2) then
         iform = 0
         nstr = 9
         outfil = 'molin.msf'
      elseif (imod.eq.3.and.tnkbg.eq.0.and.iexst.ne.-1) then
         nstr = itnkln+6
         outfil = tnknm(1:itnkln)//'.xyz_2'
      elseif (imod.eq.7.and.tnkbg.eq.0.and.iexst.ne.-1) then
         nstr = itnkln+7
         outfil = tnknm(1:itnkln)//'.cssr_2'
c      elseif (imod.eq.8.and.tnkbg.eq.0.and.iexst.ne.-1) then
      elseif (imod.eq.8.and.tnkbg.eq.0) then
         nstr = itnkln+8
         outfil = tnknm(1:itnkln)//'_opt.xyz'
      else
         domap = .false.
      endif
      if (domap) then
         if (opfil(iun,outfil,nstr,iform,1,0)) then
             rewind(iun)
         else
             ierr = 1
             goto 50
         endif
      endif

c map the file onto the z-matrix, or just read it in

      if (imod.ne.4.and..not.
     &    ((imod.eq.3.or.imod.eq.7.or.imod.eq.8)
     &      .and.tnkbg.eq.1)) then
         ierr = 1
         if (iexst.ne.-1) iexst = imod
         if (mapxyz(iun,iexst,iff,izmtmp)) ierr = 0
         if (iexst.eq.-1) then
            ierr = 20
            call dohcon(0)
         else
            if (imod.eq.7) call fdat(ifd,0,0,0,0,0)
         endif
      endif
      if (domap) close(iun)

c check for tinker error conditions (non detached job)

50    if ((imod.eq.3.or.imod.eq.7)
     &   .and.tnkbg.eq.0.and.iexst.ne.-1) then
         if (opfil(iun,tnknm(1:itnkln)//'.log',itnkln+4,1,1,0)) then
             iuntmp = iun2
             iun2 = iun
             call searcht(line,'MECHANIC','Incomplete Convergence',
     &                'Too many Parameters',istat)
             if (istat.ne.0) then
                if (index(line,'MECHANIC').ne.0) then
                   ierr = 2
                elseif (index(line,'Incomplete Convergence').ne.0) then
                   ierr = 3
                elseif (index(line,'Too many Parameters').ne.0) then
                   ierr = 4
                endif
             endif
             close(iun)
             iun2 = iuntmp
         endif
      endif
      if ((imod.eq.3.or.imod.eq.7).and.iexst.eq.-1) ierr = 5

      if ((imod.ge.4.and.imod.lt.7).or.
     &   ((imod.eq.3.or.imod.eq.7.or.imod.eq.8).and.tnkbg.eq.1)) 
     &   ierr = 6
 
      if (imod.ne.3.and.imod.ne.7.and.imod.ne.8) call curs(0)

c popup status message

      call messg(ierr)

      return

100   call inferr('Error opening file !',0)
      return
      end

      subroutine tnkpnt(ipnt,iret)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm
      common /types/ iff
      integer dolabs,fancy,persp,shade,atcol
      logical fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*20 tnkfil
      character*3 tstr
      character*4 ttstr
      character*5 tttstr
      logical opfil

      iret = 0
      idummy = 0
      
      jlen = linlen(tnknm)

      if (ipnt.eq.-1) then
         tnkfil = tnknm(1:jlen)//'.tmp'
         jlen = jlen + 1 + 3
      elseif (ipnt.lt.1000) then
         call zerstr(ipnt,tstr,3)
         tnkfil = tnknm(1:jlen)//'.'//tstr
         jlen = jlen + 1 + 3
      elseif (ipnt.lt.10000) then
         write(ttstr,'(i4)') ipnt
         tnkfil = tnknm(1:jlen)//'.'//ttstr
         jlen = jlen + 1 + 4
      elseif (ipnt.lt.100000) then
         write(ttstr,'(i5)') ipnt
         tnkfil = tnknm(1:jlen)//'.'//tttstr
         jlen = jlen + 1 + 5
      endif

      if (opfil(52,tnkfil,jlen,1,1,0)) then
          iuntmp = iun2
          iun2 = 52
          if (tnkprg.eq.4) then
             call rdchx(0,3,0,0,0,istat,icrtp,1)
             if (istat.gt.0) then
                iret = 1
                call fdat(ifd,0,0,0,0,0)
             endif
          else
             call gettnk(igttnk,0,idummy,iff,iheat,heat)
             if (igttnk.eq.1) iret = 1
          endif
          close(52)
          iun2 = iuntmp
      endif

      return
      end

      subroutine wrtsng
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /xyzopt/ ixyz,ichx,icrtp,ipdbwh,iambch
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm

      itnkln = linlen(tnknm)

      ixyz = 11
      call wrpnt(tnknm(1:itnkln)//'.xyz',itnkln+4,4,0,0,0,
     &           0,1,.false.)

      return
      end

      subroutine vec(small,ohoh,u,c,j,k)
c
c
      implicit double precision (a-h,o-z)
      logical ohoh
c
      dimension c(*),r(3),u(3)
c
      data dzero/0.0d0/
c
      jtemp=(j-1)*3
      ktemp=(k-1)*3
      r2=dzero
      do 10 i=1,3
      r(i)=c(i+jtemp)-c(i+ktemp)
      r2=r2+r(i)*r(i)
 10   continue
      r2=dsqrt(r2)
      ohoh=r2.lt.small
      if(ohoh)return
      do 20 i=1,3
 20   u(i)=r(i)/r2
      return
c
      end

      subroutine vdwlj(ev,nac,iac,nad,iad,coo,iconn,ityp,forces,potscl)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxamb=701)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=49)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      parameter (mxgff=71)
      common /gftyp/  gfvdw(2,mxgff)
      common /limits/ cutvdw, cutchg
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension ded(3),vr(3)
      dimension coo(3,*),ityp(*),iconn(mxcon+1,*),
     &          forces(3,*),potscl(*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*)

      ev = 0.0d0
      cut2 = cutvdw * cutvdw
      v14sc = 0.5d0

      do i=1,iatoms-1

         i1 = int(ityp(i))
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr1 = ambvdwr(il)
            vdwe1 = ambvdwe(il)
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr1 = gfvdw(1,i1)
            vdwe1 = gfvdw(2,i1)
         endif

         do j=i+1,iatoms
            potscl(j) = 1.0d0
         end do

         do j=1,iconn(1,i)
            jj = iconn(j+1,i)
            if (jj.gt.0) then
               potscl(jj) = 0.0d0
            endif
         end do

         do j=1,nac(i)
            potscl(iac(j,i)) = 0.0d0
         end do

         do j=1,nad(i)
            potscl(iad(j,i)) = v14sc
         end do

         do k=i+1,iatoms

               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do

               rv2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               if (rv2.le.cut2) then

c          [ (Rmin)**12       (Rmin)**6 ]
c e = eps  [ (----)     - 2.0 (----)    ]
c          [ ( r  )           ( r  )    ]

                  i2 = int(ityp(k))
                  if (i2.gt.0) then
                     kl = ambcls(i2)
                     vdwr2 = ambvdwr(kl)
                     vdwe2 = ambvdwe(kl)
                  elseif (i2.le.0) then
                     i2 = iabs(i2)
                     vdwr2 = gfvdw(1,i2)
                     vdwe2 = gfvdw(2,i2)
                  endif

c alternatively we could precalculate these vdwr(il,kl)
c                                           vdwe(il,kl)
                  rsum = vdwr1 + vdwr2
                  epsm = dsqrt(vdwe1 * vdwe2)

                  epsm = epsm * potscl(k)
                  rv   = dsqrt(rv2)
                  p6   = rsum**6 / rv2**3
                  p12  = p6 * p6

                  e    = epsm * (p12 - 2.0d0*p6)
                  de   = epsm * (p12 - p6) * (-12.0d0/rv)

                  de   = de / rv

                  do j=1,3
                     ded(j) = de * vr(j)
                  end do

                  ev   = ev + e

                  do j=1,3
                     forces(j,i) = forces(j,i) + ded(j)
                     forces(j,k) = forces(j,k) - ded(j)
                  end do

               end if
         end do
      end do

      return
      end

      subroutine asschd(ityp,q)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxamb=701)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension ityp(*),q(*)

      nion = 0

      do i=1,iatoms
          if (ityp(i).gt.0.and.ityp(i).le.mxamb) then
             q(i) = ambchg(ityp(i))
          elseif (ityp(i).eq.0) then
             q(i) = 0.0d0
          endif
      end do

      return
      end

      subroutine charge(ec,nac,iac,nad,iad,
     &                  coo,iconn,q,forces,potscl)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      common /athlp/  iatoms, mxnat
      common /limits/ cutvdw, cutchg
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          forces(3,*),potscl(*)

      econv = 332.05382d0
      cut2 = cutchg * cutchg
      v14sc = 1.0d0 / 1.2d0
      ec = 0.0d0

      do i=1,iatoms-1

         do j=1,iatoms
            potscl(j) = 1.0d0
         end do

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               potscl(jj) = 0.0d0
            endif
         end do

         do j=1,nac(i)
            potscl(iac(j,i)) = 0.0d0
         end do

         do j=1,nad(i)
            potscl(iad(j,i)) = v14sc
         end do

         do k=i+1,iatoms

               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do

               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               if (r2.le.cut2) then
                  r = dsqrt(r2)
                  e = econv * q(i) * q(k) * potscl(k) / r
                  de = -e / r
                  de = de / r

                  do j=1,3
                     ded(j) = de * vr(j)
                  end do

c                  print*,'echg ',i,' ',k,' ',e,' scl ',potscl(k),'ded '
c     &                   ,(ded(j),j=1,3)

                  ec = ec + e

                  do j=1,3
                     forces(j,i) = forces(j,i) + ded(j)
                     forces(j,k) = forces(j,k) - ded(j)
                  end do

               end if
         end do
      end do

      return
      end

      subroutine prtcal
      implicit double precision (a-h,o-z)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      character*3 aminos
      character*1 scnd(4)
      common /amino/aminos(mxres)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      data scnd/'H','B','R','C'/

      do i=1,nchain
          nlen = islu(i)-ianf(i)+1
          write(iun3,*) 'Chain ',i,' Length = ',nlen
          write(iun3,*) '       '
          do j=ianf(i),islu(i),13
            kl = min(islu(i)-j+1,13)
            write(iun3,'(13(a3,1x))')(aminos(iamino(k+j-1)),k=1,kl)
          end do
      end do

      toang = 0.52917706d0
      write(iun3,*) ' nr res    hbond                scnd phi    psi'
      do i=1,ncalf
        if (iamino(i).le.23) then
         p1 = phi(i)
         p2 = psi(i)
         h1 = hbd(1,i)*toang
         h2 = hbd(2,i)*toang
         if (ihb(1,i).eq.0) h1 = 0.0d0
         if (ihb(2,i).eq.0) h2 = 0.0d0
         write(iun3,100) i,' ',aminos(iamino(i)),' ',
     &   ihb(1,i),',',ihb(2,i),' ',h1,',',h2,
     &   ' ',scnd(isal(i)+1),' ',p1,' ',p2
        endif
      end do

100   format(i4,a,a3,a,i4,a,i4,a,f6.3,a,f6.3,a,a,a,f6.1,a,f6.1)
      return
      end

      subroutine rdvecd(idebug,ig94,istats,
     &                  vectrs,vectrb,focc,eiga,eigb,ncols,ncolb)
      implicit double precision (a-h,o-z)
      parameter (mxcol=10)
      parameter (numatm=2000)
      character*137 line
      common /orbhlp/ mxorb,iuhf,ispd
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical natorb,nlmo,reo
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),eiga(*),eigb(*)
      dimension vt(15,mxcol),irord(15)

      istats = 1

      irord(1)  = 15
      irord(2)  = 5
      irord(3)  = 1
      irord(4)  = 14
      irord(5)  = 13
      irord(6)  = 9
      irord(7)  = 4
      irord(8)  = 6
      irord(9)  = 2
      irord(10) = 12
      irord(11) = 10
      irord(12) = 3
      irord(13) = 11
      irord(14) = 8
      irord(15) = 7

      natorb = .false.
      nlmo = .false.
      npl = 5
      if (idebug.eq.1) 
     &      call inferr('Looking for Molecular Orbital Coefficients',0)

      call searcht(line,'Molecular Orbital Coefficients',
     &    'Natural Orbital Coefficients',
     &    'NLMOs in the AO basis:',istat)
      if (istat.eq.0) then
       call inferr('no MO COEFFICIENTS found on GAUSSIAN outputfile',0)
        goto 150
      endif
      if (index(line,'Natural').ne.0.or.index(line,'NATURAL').ne.0) then
          natorb = .true.
          iuhf = 0
      endif
      if (index(line,'NLMO').ne.0) then
          nlmo = .true.
          npl = 8
          iuhf = 0
          ido5d = 1
          ido7f = 1
          ido9g = 1
      endif
      imin = 0
      imax = 0
      npass = (ncols - 1) / npl + 1
      do ipass=1,npass
         imin = imax + 1
         imax = imax + npl
         imax = min0(ncols,imax)
         do i =1,10
            read(iun2,'(a)') line
            call tocap(line,80)
            if (nlmo) then
               if (index(line,' AO ').ne.0) then
                  call readel(line,1)
                  goto 100
               endif
            else
               if (index(line,'EIGENVALUES').ne.0) goto 100
            endif
         end do
         if (imax.lt.ncols) goto 150
         return
100      continue
         if (natorb) then
            read(line,'(21x,5f10.5)',err=150) (focc(j),j=imin,imax)
            do j=imin,imax
                eiga(j) = 0.0d0
            end do
         else
            if (nlmo) then
               do j=imin,imax
                   eiga(j) = 0.0d0
               end do
            else
             read(line,'(21x,5f10.5)',err=150) (eiga(j),j=imin,imax)
            endif
         endif

         istrt = 0
         itel = 0
         nc = imax - imin + 1

         do irow=1,norbs
           read(iun2,'(a)',err=150) line
cnull           call rmnull(line)
           if (nlmo) then
              read(line,'(16x,8f8.4)',err=150)
     &         (vectrs((j-1)*mxorb+irow),j=imin,imax)
              if (index(line,'D6').ne.0.or.index(line,'d6').ne.0)
     &         ido5d = 0
              if (index(line,'F8').ne.0.or.index(line,'f8').ne.0)
     &         ido7f = 0
              if (index(line,'G10').ne.0.or.index(line,'g10').ne.0)
     &         ido9g = 0
           else
              read(line,'(21x,5f10.5)',err=150)
     &         (vectrs((j-1)*mxorb+irow),j=imin,imax)
              if (index(line,'D-2').ne.0.or.index(line,'d-2').ne.0)
     &         ido5d = 1
              if (index(line,'F-2').ne.0.or.index(line,'f-2').ne.0)
     &         ido7f = 1
              if (index(line,'G-2').ne.0.or.index(line,'g-2').ne.0)
     &         ido9g = 1
           endif

           if (istrt.eq.0.and.index(line,'ZZZZ').ne.0) then
               istrt = irow
               itel = 0
               reo = .true.
           endif

           if (istrt.ne.0) then
              itel = itel + 1
              do k=1,nc
                 vt(itel,k) = vectrs((imin+k-2)*mxorb+irow)
              end do
           endif

           if (itel.eq.15) then
              do l=1,15
                 do k=1,nc
                    vectrs((imin+k-2)*mxorb + (istrt+l-1)) = 
     &                   vt(irord(l),k)
                 end do
              end do
              istrt = 0
              itel = 0
           endif

         end do
      end do

      if (iuhf.eq.1) then
         read(iun2,'(a)',err=150) line
         imin = 0
         imax = 0
         do ipass=1,npass
            imin = imax + 1
            imax = imax + npl
            imax = min0(ncols,imax)
            do i =1,10
               read(iun2,'(a)',err=150) line
               call tocap(line,80)
               if (index(line,'EIGENVALUES').ne.0) goto 200
            end do
            if (imax.lt.ncolb) goto 150
            return
200         continue

            read(line,'(21x,5f10.5)',err=150) (eigb(j),j=imin,imax)

            istrt = 0
            itel = 0
            nc = imax - imin + 1

            do irow=1,norbs
cnull              read(iun2,'(a)',err=150) line
cnull              call rmnull(line)
cnull              read(line,'(21x,5f10.5)',err=150)
              read(iun2,'(21x,5f10.5)',err=150)
     &             (vectrb((j-1)*mxorb+irow),j=imin,imax)


              if (istrt.eq.0.and.index(line,'ZZZZ').ne.0) then
                  istrt = irow
                  itel = 0
                  reo = .true.
              endif

              if (istrt.ne.0) then
                 itel = itel + 1
                 do k=1,nc
                    vt(itel,k) = vectrb((imin+k-2)*mxorb+irow)
                 end do
              endif

              if (itel.eq.15) then
                 do l=1,15
                    do k=1,nc
                       vectrb((imin+k-2)*mxorb + (istrt+l-1)) = 
     &                      vt(irord(l),k)
                    end do
                 end do
                 istrt = 0
                 itel = 0
              endif

            end do
         end do
      endif

      if (reo) then
          print*,' '
          print*,'========================================'//
     &           '======================================'
          print*,'Changed order of G functions:'
          print*,' '
          print*,'zzzz,yzzz,yyzz,yyyz,yyyy,xzzz,xyzz,xyyz,',
     &           'xyyy,xxzz,xxyz,xxyy,xxxz,xxxy,xxxx ->'
          print*,' '
          print*,'xxxx,yyyy,zzzz,xxxy,xxxz,yyyx,yyyz,zzzx,',
     &           'zzzy,xxyy,xxzz,yyzz,xxyz,yyxz,zzxy'
          print*,' '
          print*,'========================================'//
     &           '======================================'
          print*,' '
      endif

      return

150   call inferr('error in reading vectors',1)
      if (ig94.eq.1) then
         call inferr('use IOP(6/7=3) in gaussian inputfile',1)
      else
         call inferr('use IOP(6/7=1) in gaussian inputfile',1)
      endif
      istats = 0
      return
      end

      subroutine rotatg(nat,idebug)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /rotxyz/ amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      common /orient/ o321g(9,9),o431g(9,9),o631g(9,9),f321g(9,9),
     &                f431g(9,9),f631g(9,9),s321g(13,13),s431g(13,13),
     &                s631g(13,13),cl321g(13,13),cl431g(13,13),
     &                cl631g(13,13)
      common /orihlp/ ori(numatm),iuser(numatm),oalpha(numatm),
     $                obeta(numatm),norien,ibal
      common /del1/   dmolin(169),dofscl(169)
      common /del2/   d11(3,3),d12(3,3),d21(3,3),d22(3,3),
     &                f11(3),f12(3),f21(3),f22(3),occ(3),
     &                p(3,3),g(3,3),ibasis,idim
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension angle(2)

c###### split valence part ###############
c     dmolin contains the atomic part off the molecular
c            density matrix
c     dofscl   contains the oriented atomic density matrix
c            on return
c     idim   dimension of atomic density matrix without
c            polarisation function (=9 for o and f,
c                                   =13 for s and cl )
c     d11,d12,d21,d22
c            contain the p*p p*p' p'*p and p'*p' parts
c            of the atomic density matrix
c     f11,f12,f21,f22
c            idem,but now only diagonal terms
c
c--- initialisation -----
c
      todeg = 45.0d0 / datan(1.0d0)
      delold = 1.0d5
      amat(1,3) = 0.0d0
      amat(2,3) = 0.0d0
      amat(3,1) = 0.0d0
      amat(3,2) = 0.0d0
      amat(3,3) = 1.0d0
      bmat(1,2) = 0.0d0
      bmat(2,1) = 0.0d0
      bmat(2,2) = 1.0d0
      bmat(2,3) = 0.0d0
      bmat(3,2) = 0.0d0
      if (ibasis.eq.0) then
c----- sto3g ----------
         if (nat.eq.8.or.nat.eq.16) then
            occ(1) = 2.0d0
            occ(2) = 1.0d0
            occ(3) = 1.0d0
         endif
         if (nat.eq.9.or.nat.eq.17) then
            occ(1) = 2.0d0
            occ(2) = 2.0d0
            occ(3) = 1.0d0
         endif
      else
c------- spit valence -------
         if (nat.eq.8) then
           if (ibasis.eq.1) then
            do 2005 i=1,9
            do 2005 j=1,9
2005           dofscl(j+(i-1)*idim) = o321g(i,j)
           endif
           if (ibasis.eq.2) then
            do 2010 i=1,9
            do 2010 j=1,9
2010           dofscl(j+(i-1)*idim) = o431g(i,j)
           endif
           if (ibasis.eq.3) then
            do 2015 i=1,9
            do 2015 j=1,9
2015           dofscl(j+(i-1)*idim) = o631g(i,j)
           endif
         endif
         if (nat.eq.9) then
           if (ibasis.eq.1) then
            do 2020 i=1,9
            do 2020 j=1,9
2020           dofscl(j+(i-1)*idim) = f321g(i,j)
           endif
           if(ibasis.eq.2)then
            do 2025 i=1,9
            do 2025 j=1,9
2025           dofscl(j+(i-1)*idim)=f431g(i,j)
           endif
           if(ibasis.eq.3)then
            do 2030 i=1,9
            do 2030 j=1,9
2030           dofscl(j+(i-1)*idim)=f631g(i,j)
           endif
         endif
         if(nat.eq.16)then
           if(ibasis.eq.1)then
            do 2035 i=1,13
            do 2035 j=1,13
2035           dofscl(j+(i-1)*idim)=s321g(i,j)
           endif
           if(ibasis.eq.2)then
            do 2040 i=1,13
            do 2040 j=1,13
2040           dofscl(j+(i-1)*idim)=s431g(i,j)
           endif
           if(ibasis.eq.3)then
            do 2045 i=1,13
            do 2045 j=1,13
2045           dofscl(j+(i-1)*idim)=s631g(i,j)
           endif
         endif
         if(nat.eq.17)then
           if(ibasis.eq.1)then
            do 2050 i=1,13
            do 2050 j=1,13
2050           dofscl(j+(i-1)*idim)=cl321g(i,j)
           endif
           if(ibasis.eq.2)then
            do 2055 i=1,13
            do 2055 j=1,13
2055           dofscl(j+(i-1)*idim)=cl431g(i,j)
           endif
           if(ibasis.eq.3)then
            do 2060 i=1,13
            do 2060 j=1,13
2060           dofscl(j+(i-1)*idim)=cl631g(i,j)
           endif
         endif
         idim2=idim*idim
         do i=1,3
            f11(i) = dofscl(idim2+(i-7)*(idim+1))
            f12(i) = dofscl(idim2+(i-3)*idim-7+i)
            f21(i) = f12(i)
            f22(i) = dofscl(idim2+(i-3)*(idim+1))
         end do
      endif
c---- end initialisation -----
      write(iun3,*)' '
      write(iun3,*)'p-part atomic density matrix before orientation'
      write(iun3,*)' '
      if(ibasis.ne.0)then
          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dofscl(k1+idim-7+j),j=1,3),
     &                   (dofscl(k1+idim-3+j),j=1,3)
          end do
          write(iun3,*)' '
          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dofscl(k2+idim-7+j),j=1,3),
     &                   (dofscl(k2+idim-3+j),j=1,3)
          end do
      else
          write(iun3,'(f9.4,a)')occ(1),'   0.0000   0.0000'
          write(iun3,'(a,f9.4,a)')'   0.0000',occ(2),'   0.0000'
          write(iun3,'(a,f9.4)')'   0.0000   0.0000',occ(3)
      endif
      write(iun3,*)' '
      if (iuser(ibal).eq.1) then
         angle(1) = oalpha(ibal)
         angle(2) = obeta(ibal)
         delta    = del(angle)
         goto 1400
      endif
c----- start of coarse search ----
      do 1200  ia=0,180,10
         angle(1)=dfloat(ia)
         do 1200  ib=0,180,10
            angle(2)=dfloat(ib)
               delta=del(angle)
               if(delta.lt.delold)then
                 delold=delta
                 alopt=angle(1)
                 beopt=angle(2)
               endif
1200   continue
      angle(1)=alopt
      angle(2)=beopt
c----- end of coarse search ------
c----- start of medium search ----
      alco=alopt
      beco=beopt
      do 1300  ia=1,21
         angle(1)=alco+dfloat(ia-1)-10.0d0
         do 1300  ib=1,21
            angle(2)=beco+dfloat(ib-1)-10.0d0
            delta=del(angle)
            if(delta.lt.delold)then
              delold=delta
              alopt=angle(1)
              beopt=angle(2)
            endif
1300   continue
c----- end of medium search ------
c----- start of fine search ----
      alco=alopt
      beco=beopt
      do 1350  ia=1,21
         angle(1)=alco+dfloat(ia-1)*0.1d0-1.0d0
         do 1350  ib=1,21
            angle(2)=beco+dfloat(ib-1)*0.1d0-1.0d0
            delta=del(angle)
            if(delta.lt.delold)then
              delold=delta
              alopt=angle(1)
              beopt=angle(2)
            endif
1350   continue
c----- end of fine search ------
      angle(1) = alopt
      angle(2) = beopt
      delta    = del(angle)
1400  continue
c      if (idebug.eq.1) then
         write(iun3,*)' '
         write(iun3,*)'delta squared                  =',delta
         write(iun3,*)'alfa  optimised                =',angle(1)
         write(iun3,*)'beta  optimised                =',angle(2)
         write(iun3,*)' '
         write(iun3,*)'-------- rot-matrix ----------'
         write(iun3,*)' '
         do 110 i=1,3
110       write(iun3,120)(rmat(i,j),j=1,3)
          write(iun3,*)' '
         if(ibasis.eq.0)then
          write(iun3,*)'p-part molecular density matrix'
          write(iun3,*)' '
          do 111 i=1,3
111          write(iun3,120)(g(i,j),j=1,3)
          write(iun3,*)' '
          write(iun3,*)'p-part oriented atomic density matrix'
          write(iun3,*)' '
          do 112 i=1,3
112          write(iun3,120)(p(i,j),j=1,3)
         else
          write(iun3,*)'p-part molecular density matrix'
          write(iun3,*)' '
          do 150 i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dmolin(k1+idim-7+j),j=1,3),
     &                      (dmolin(k1+idim-3+j),j=1,3)
150       continue
          write(iun3,*)' '
          do 160 i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dmolin(k2+idim-7+j),j=1,3),
     &                   (dmolin(k2+idim-3+j),j=1,3)
160       continue
          write(iun3,*)' '
          write(iun3,*)'p-part oriented atomic density matrix'
          write(iun3,*)' '
          do 115 i=1,3
115          write(iun3,130)(d11(i,j),j=1,3),(d12(i,j),j=1,3)
          write(iun3,*)' '
          do 116 i=1,3
116          write(iun3,130)(d21(i,j),j=1,3),(d22(i,j),j=1,3)
          write(iun3,*)' '
         endif
c      endif
120   format(10x,3f9.4)
130   format(10x,3f9.4,2x,3f9.4)

      return
      end

      subroutine enegdd(energy,coo,forces,potscl,
     &                  nac,iac,nad,iad,
     &                  nbnd,ibnd,bl,bk,
     &                  nang,iang,ango,ak,
     &                  nt,it,trs1,trs2,trs3,trs4,
     &                  nti,iti,trsi1,trsi2,
     &                  q,iconn,ityp)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension forces(3,*),potscl(*)
      dimension nac(*),nad(*),iac(mxac,*),iad(mxad,*)
      dimension ibnd(2,*), bl(*), bk(*)
      dimension iang(3,*),ango(*),ak(*)
      dimension it(4,*),trs1(4,*),trs2(4,*),trs3(4,*),trs4(4,*)
      dimension iti(4,*),trsi1(4,*),trsi2(4,*)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),ityp(*)

      eb  = 0.0d0
      ea  = 0.0d0
      eit = 0.0d0
      et  = 0.0d0
      ev  = 0.0d0
      ec  = 0.0d0

      do i=1,iatoms
         do j=1,3
            forces(j,i) = 0.0d0
         end do
      end do

      call bond (eb,nbnd,ibnd,bl,bk,coo,forces)

      call angle(ea,nang,iang,ango,ak,coo,forces)
      call tors (eit,1,
     &                nt,it,trs1,trs2,trs3,trs4,
     &                nti,iti,trsi1,trsi2,
     &                coo,forces)
      call tors (et,0,
     &                nt,it,trs1,trs2,trs3,trs4,
     &                nti,iti,trsi1,trsi2,
     &                coo,forces)

      call vdwlj(ev,nac,iac,nad,iad,coo,iconn,ityp,forces,potscl)
      call charge(ec,nac,iac,nad,iad,
     &            coo,iconn,q,forces,potscl)

      energy = eb + ea + eit + et + ev + ec

c      print*,'eb=',eb,'ea=',ea,'eit=',eit,'et=',et,'ev=',ev,'ec=',ec
      do i=1,iatoms
         do j=1,3
            forces(j,i) = -forces(j,i)
         end do
      end do

      return
      end

      subroutine rdgdud(idebug,ibefo,istatio,irtype,istats,
     &                 focc,focb,nocc,nocb,ncols,ncolb,coo,ianz)

c THIS IS REALLY rdgaus

      implicit double precision ( a-h,o-z)
      parameter (numat1=20000)
      parameter (mxonh=100)
      common /athlp/ iatoms, mxnat
      common /qmchar/ qch(numat1),ihasesp
      parameter (numatm=2000)
      parameter (mxel=100)
      character*137 line,lint
      character*2 els
      common /coord / xyz(3,numatm)
      common /pseudo /ipseud,ivale(numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /gxyz/   ixyz98, iopr, isymm, irc, imp2, icntp
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      logical rohf
      dimension focc(*),focb(*),v1(3)
      dimension coo(3,*),ianz(*)

      istats = 1
      irtype = 0
      istatio = 0
      isymm = 1
      rohf = .false.
      ig94 = 0
      ixyz98 = 0
      iopr = 0
      irc = 0
      imp2 = 0
      icntp = 0

      call search(line,' ***********************',istat)
      read(iun2,'(a)') line
      if (line(11:12).eq.'DV') then
          ivers = 2003
      else
          read(line,'(10x,i2)') ivers
          if (ivers.eq.3) ivers = 2003
          if (ivers.ge.94) ig94 = 1
      endif
      if (ivers.ge.98) then
          ixyz98 = 1
          call search(line,'will use Cartesian coordinates',istat)
          if (istat.ne.0) ixyz98 = 2
          rewind iun2
      endif

      if (ig94.eq.0) then
         call search(line,'Restricted open shell SCF:',istat)
         if (istat.ne.0) rohf = .true.
         rewind iun2
      endif
      
      call search(line,'Frequencies --',istat)
      if (istat.ne.0) irtype = 4
      rewind iun2

      call search(line,'Symmetry turned off',istat)
      if (istat.ne.0) isymm = 0
      rewind iun2

      call search(line,'IRC-IRC-IRC',istat)
      if (istat.ne.0) irc = 1
      rewind iun2

      call search(line,'Computing MP2 derivatives',istat)
      if (istat.ne.0) imp2 = 1
      rewind iun2

      call search(line,'Counterpoise: corrected',istat)
      if (istat.ne.0) icntp = 1
      rewind iun2

      call searchd(line,'ONIOM: saving','ONIOM: Cut',istat)
      if (istat.ne.0) then
         ioni = 1
         nion = 0
         do while (index(line,'Cut').ne.0)
            if (nion.lt.mxonh) then
               nion = nion + 1
               id = index(line,'/') + 1
               els = line(id:id+1)
               if (els(2:2).eq.' ') then
                  els = ' '//els(1:1)
               endif
               do i=1,99
                  if (els.eq.elemnt(i)) natonh(nion) = i
               end do
               if (line(id+8:id+8).eq.' ') then
                  read(line(id+2:id+38),'(i6,7x,i6,8x,f10.6)') 
     &              ionih(nion),icntat(nion),fct(nion)
               else if (line(id+7:id+7).eq.' ') then
                  read(line(id+2:id+35),'(i5,7x,i5,8x,f9.6)') 
     &              ionih(nion),icntat(nion),fct(nion)
               else
                  print*,'error reading ONIOM: Cut atoms'
               endif
            endif
            call readel(line,1)
         end do
         if (idebug.eq.1) then
            print*,'Oniom boundary atoms:'
            do i=1,nion
               print*,natonh(i),' ',ionih(i)
            end do
         endif
      else 
         ioni = 0
      endif
      
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif
c     
c     look for number of orbitals and electrons
c
      call search(line,'primitive gaussians',istat)
      if (istat.eq.0) then
         call inferr('no primitive gaussian found!',1)
         goto 1000
      endif
      if (index(line,'primitive gaussians').eq.30) then
         read(line,'(1x,i3)',err=1000,end=1000) norbs
      else
         read(line,'(1x,i5)',err=1000,end=1000) norbs
      endif
      if (norbs.gt.mxorb) 
     &   call inferr('Exceeding MaxNum of Orbitals!',1)
      call search(line,'alpha electrons',istat)
      if (istat.eq.0) then
         call inferr('no alpha electrons found!',1)
          goto 1000
      endif
      if (index(line,'alpha electrons').eq.6) then
         read(line,'(1x,i3,21x,i4)',err=1000,end=1000) neleca,nelecb
      else
         read(line,'(1x,i5,20x,i5)',err=1000,end=1000) neleca,nelecb
      endif
      nelecs = neleca + nelecb
      iorbs = 0
      call search(line,'One-electron integrals computed using',istat)
      if (istat.eq.0) then
         rewind iun2
         call search(line,'alpha electrons',istat)
      endif
      do i=1,30
         read(iun2,'(a)',end=1000) line
         if (index(line,'RelInt:').eq.0) then
            if (index(line,'NBsUse=').ne.0) then
               read(line,'(9x,i5)',err=1000,end=1000) iorbs
            endif
         endif
      end do
      if (ig94.eq.1) then
         ncols  = norbs
         ncolb  = norbs
         if (iorbs.ne.0) then
            ncols = iorbs
            ncolb = iorbs
         endif
      else
         ncols  = max0(neleca+5,nelecb+5)
         ncols  = min0(ncols,norbs)
         if (rohf) ncols = norbs
         ncolb  = ncols
      endif
c
      do i=1,min0(mxorb,norbs)
         focc(i) = 0.0d0
      end do
      do i=1,min0(mxorb,neleca)
         focc(i) = 1.0d0
      end do

      rewind iun2
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif
c      call searchd(line,'UHF open shell SCF','E(UHF)',istat)
      call search(line,'Beta Molecular Orbital Coefficients',istat)
      if (istat.ne.0) then
         iuhf=1
         nocc=neleca
         nocb=nelecb
         do i=1,min0(mxorb,norbs)
            focb(i) = 0.0d0
         end do
         do i=1,min0(mxorb,nelecb)
            focb(i) = 1.0d0
         end do
      else
         nocc=max0(neleca,nelecb)
         do i=1,min0(mxorb,nelecb)
            focc(i) = focc(i) + 1.0d0
         end do
      endif
c
      call search(line,'-- Stationary point found',istat)
      rewind iun2
      if (istat.eq.0.or.ibefo.eq.1.or.(istat.eq.1.and.irtype.eq.4)) 
     &then
          write(iun3,*)'First standard orientation encountered used'
          write(iun3,*)'for density calculations'
          call search(line,'Z-MATRIX (ANGSTROMS AND DEGREES)',istat)
          if (istat.eq.0.or.irtype.eq.4) then
              call haszm(.false.)
          else
              call readel(line,2)
              call convzmat(coo,ianz,iatoms,1,1)
          endif
          call rdcor(idebug,isymm,istat)
          if (istat.eq.0) goto 1000
          if (idebug.eq.1) 
     &    call inferr('Succesfully read coordinates',0)
      else
          istatio = 1
          write(iun3,*)'Coordinates of stationary point used'
          write(iun3,*)'for density calculations'
10        call rdcor(idebug,isymm,istat)
          if (istat.eq.0) goto 20
          if (idebug.eq.1) 
     &    call inferr('found coordinates',0)
          goto 10
20        continue
      endif
c
      rewind iun2
      call fndor(idebug)

      if (ixyz98.gt.0.and.natoms.gt.50) then

c check for IOP(2/11=1)

         rewind iun2
         call search(line,' 2/',istat)
         if (istat.eq.1) then
            if (ichar(line(1:1)).eq.32.and.
     &          ichar(line(2:2)).eq.50.and.
     &          ichar(line(3:3)).eq.47) then
               if (index(line,'11=1').ne.0) then
                  iopr = 1
               endif
            endif
         endif
      endif

      if (ioni.eq.1) then

c coordinates are read, calculate the coordinates of the oniom link 
c atoms

         do j=1,nion
            do k=1,3
                v1(k) = xyz(k,ionih(j))-xyz(k,icntat(j))
            end do
            do k=1,3
               xyzi(k,j) = xyz(k,icntat(j)) + 
     &          fct(j)*v1(k)
            end do
         end do
         call xyzcoo(1,0,0)

      endif

      rewind iun2
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif

c if ioni=1, rdbas transforms the xyz array to those of H layer only

      call rdbas(idebug,0,istat)
      call norml

      if (istat.eq.0) goto 1000
      if (idebug.eq.1) 
     &    call inferr('Succesfully read basis-set',0)
      if (idebug.eq.1) call basprt(iun3,.false.,.false.)
      if (norbs.gt.mxorb) goto 1000

      call search(line,'Pseudopotential Parameters',istat)
      if (istat.eq.1) then
         ipseud = 1
         call readel(line,4)
         do i=1,natoms
            read(iun2,'(a)') line
            read(iun2,'(a)') lint
            if (icdex(lint,'No pseudo').ne.0) then
               read(line,'(14x,i3)') ivale(i) 
            else
               read(line,'(26x,i3)') ivale(i) 
               do while(.true.)
                  call readel(line,1)
                  if (line(5:5).ne.' ') then
                     backspace iun2
                     goto 100
                  endif
               end do
            endif
100         continue
         end do
      endif

      natbck = natoms
      if (ioni.eq.1) then

c     rdbas sets the array iomap, when ioni=1

         natmp = 0
         do i=1,numatm
            if (iomap(i).ne.0) natmp = natmp + 1
         end do
         natoms = natmp
      endif

      rewind iun2 
      call search(line,'Charges from ESP fit',istat)
      if (istatio.eq.1) call search(line,'Charges from ESP fit',istat)
      if (istat.eq.1) then
          call readel(line,2)
          do i=1,natbck
              read(iun2,'(a)',err=1000,end=1000) line
              if (linlen(line).eq.18) then
                 read(line,'(7x,f11.6)',err=1000,end=1000) qch(i)
              else if (linlen(line).eq.21) then
                 read(line,'(11x,f11.6)',err=1000,end=1000) qch(i)
              endif
          end do
          ihasesp = 1
      endif

      rewind iun2
      if (ioni.eq.1.and.istatio.eq.1) then
         call search(line,'-- Stationary point found',istat)
         if (istat.eq.0) then
            call inferr('no Stationary point found!',1)
            goto 1000
         endif
      endif
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('error reading vectors: '//
     &      'no high level on model system found for Stationary point!'
     &      ,1)
            call inferr(
     &   'no vectors for high level on model system '//
     &   'of stationary point: try molden -b',1)
            goto 1000
         endif
      endif
      if (istatio.eq.1) then
         call rdvect(idebug,ig94,istat)
         istato = istat
         if (ioni.ne.1) then
            call rdvect(idebug,ig94,istat)
            if (istat.eq.0.and.istato.eq.0) goto 1000
         else if (ioni.eq.1.and.istato.eq.0) then
            call inferr(
     &   'no vectors for high level on model system '//
     &   'of stationary point: use molden -b',1)
            goto 1000
         endif
      else
         call rdvect(idebug,ig94,istat)
         if (istat.eq.0) goto 1000
      endif
      if (idebug.eq.1) call inferr('Succesfully read vectors',0)


      if (idebug.eq.1) 
     &         call inferr('Succesfully read Gaussian output',0)

      return

1000  if (idebug.eq.1)  then
          call inferr('Error reading Gaussian output!',1)
          print*,line
      endif

      istats = 0
      return

      end

      subroutine cubtst(iun,ijag)
      implicit double precision ( a-h,o-z)
      character*137 line,str
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /grdhlp/ mx3d,mx3d2
      integer currec,bigend,buflen
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      character keywrd*160, keyori*160
      common /keywrd/ keywrd,keyori
      integer getlin
      character*4 buff(40)
      integer*2 buf2(256)
      integer*2 idum

      if (ijag.eq.1) then
c Jaguar cube
         iuntmp = iun2
         iun2 = iun

         do while(getlin(1).eq.1)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               if (nstr.ge.4) then
                  if (icdex(str,'npts').ne.0) then
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts1 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts2 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts3 = itype
                  endif
               endif
            endif
         end do

      elseif (ijag.eq.2) then

         iund = 10
         bigend = 1
         nlen = 1
         currec = 0
         buflen = 40

10       open(unit=iund,file=keywrd,access="direct",
     &        recl=nlen)

         call getrec(buff,buflen,ierr)
         if (ierr.eq.1) then
            bigend = 0
            currec = 0
            rewind(iund)
            call getrec(buff,buflen,ierr)
            if (ierr.eq.1.and.nlen.eq.1) then
               currec = 0
               bigend = 1
               nlen = 4
               close(iund)
               goto 10
            endif
         endif

         if (ierr.eq.1) then
            ijag = -1
            return
         endif

         call byter(buff(26),npts1)
         call byter(buff(27),npts2)
         call byter(buff(28),npts3)

         rewind(iund)
         currec = 0

      elseif (ijag.eq.3) then

c O map (DSN6)

         iund = 10
         bigend = 1
         nlen = 1
         currec = -1

12       open(unit=iund,file=keywrd,access="direct",
     &        recl=nlen)

         call getrc2(buf2,ierr)
         if (ierr.eq.1) then

            bigend = 0
            currec = -1
            rewind(iund)
            call getrc2(buf2,ierr)
            if (ierr.eq.1.and.nlen.eq.1) then

               currec = -1
               bigend = 1
               nlen = 2
               close(iund)
               goto 12

            endif

         endif

         if (ierr.eq.1) then
            ijag = -1
            return
         endif

         npts1 = int(buf2(7))
         npts2 = int(buf2(8))
         npts3 = int(buf2(9))

c         print*,'npts ',npts1,npts2,npts3
         rewind(iund)
         currec = -1

      else

         read(iun,'(a)') line
         read(iun,'(a)') line
         read(iun,'(a)') line

         read(iun,'(i5)') npts1
         read(iun,'(i5)') npts2
         read(iun,'(i5)') npts3

      endif

      nptsmx = npts1
      if (npts2.gt.nptsmx) nptsmx = npts2
      if (npts3.gt.nptsmx) nptsmx = npts3

      if (nptsmx.gt.mx3d) then
         call allgrd(nptsmx)
      endif

      if (ijag.eq.1) then
         rewind iun2
         iun2 = iuntmp
      else
         rewind iun
      endif

      return

100   print*,'error reading grid file'
      return
      end

      subroutine rdcubd(npts1,npts2,npts3,iposng,ipsi,istat,iun,
     &                  idebug,denn,pmnn)
      implicit double precision ( a-h,o-z)

c THIS IS REALLY rdcube

      parameter (numatm=2000)
      parameter (mxel=100)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /grdhlp/ mx3d,mx3d2
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /eulx/   ca,cb,sa,sb,cc,sc
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      character*137 line,lstr,str
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical gnreal,oampac,ojag
      integer getlin
      dimension orig(3),tmp(3),dtmp(6)
      dimension denn(*),pmnn(*)

      ojag = .false.
      if (istat.eq.1) ojag = .true.

      istat = 1
      itype = 0
      toang  = 0.52917706d0
      rneg = 0.0d0

      if (ojag) then

c Jaguar cube file

         iuntmp = iun2
         iun2 = iun
         do while(.true.)
            if (getlin(1).eq.1) then
               if (icdex(line,'&end').ne.0) goto 10
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1) then
                  if (nstr.eq.4) then
                     if (icdex(str,'npts').ne.0) then
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts1 = itype
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts2 = itype
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts3 = itype
                     endif
                  elseif (nstr.eq.6) then
                     if (icdex(str,'orig').ne.0) then
                        if (.not.gnreal(orig,3,.false.)) goto 100
                     endif
                  elseif (nstr.eq.7) then
                     if (icdex(str,'extent').ne.0) then
                        if (str(7:7).eq.'x'.or.str(7:7).eq.'X') then
                           if (.not.gnreal(v1,3,.false.)) goto 100
                        endif
                        if (str(7:7).eq.'y'.or.str(7:7).eq.'Y') then
                           if (.not.gnreal(v2,3,.false.)) goto 100
                        endif
                        if (str(7:7).eq.'z'.or.str(7:7).eq.'Z') then
                           if (.not.gnreal(tmp,3,.false.)) goto 100
                        endif
                     endif
                  endif
               endif
            endif 
         end do
10       natoms = 0
         nat(1) = 99

      else

c Gaussian Cube

         read(iun,'(a)') line
         read(iun,'(a)') line
         if (index(line,'Density').ne.0) itype = 0
         if (index(line,'MO coefficients').ne.0) itype = 1
         ipsi = itype

         read(iun,'(a)') line
         oampac = (linlen(line).eq.44)
         if (oampac) then
            read(line,'(i5,3f13.6)') natoms,(orig(i),i=1,3)
         else
            read(line,'(i5,3f12.6)') natoms,(orig(i),i=1,3)
         endif
         if (natoms.lt.0) itype = 1
         natoms = iabs(natoms)

         if (oampac) then
            read(iun,'(i5,3f13.6)') npts1,(v1(i),i=1,3)
            read(iun,'(i5,3f13.6)') npts2,(v2(i),i=1,3)
            read(iun,'(i5,3f13.6)') npts3,(tmp(i),i=1,3)
         else
            read(iun,'(i5,3f12.6)') npts1,(v1(i),i=1,3)
            read(iun,'(i5,3f12.6)') npts2,(v2(i),i=1,3)
            read(iun,'(i5,3f12.6)') npts3,(tmp(i),i=1,3)
         endif

      endif

      if (npts1.gt.mx3d.or.npts2.gt.mx3d.or.npts3.gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',npts1,' npts2 ',npts2,' npts3 ',npts3,
     &           ' maxdim ',mx3d 
          goto 100
      endif

      if (ojag) then

         r(1) = vlen(v1)
         r(2) = vlen(v2)
         r(3) = vlen(tmp)

         px = orig(1) + (v1(1) + v2(1) + tmp(1))/2.0d0
         py = orig(2) + (v1(2) + v2(2) + tmp(2))/2.0d0
         pz = orig(3) + (v1(3) + v2(3) + tmp(3))/2.0d0

      else

         r(1) = vlen(v1)*(npts1-1)
         r(2) = vlen(v2)*(npts2-1)
         r(3) = vlen(tmp)*(npts3-1)

         px = orig(1) + ((npts1-1)*v1(1) + (npts2-1)*v2(1) + 
     &                   (npts3-1)*tmp(1))/2.0d0
         py = orig(2) + ((npts1-1)*v1(2) + (npts2-1)*v2(2) + 
     &                   (npts3-1)*tmp(2))/2.0d0
         pz = orig(3) + ((npts1-1)*v1(3) + (npts2-1)*v2(3) + 
     &                   (npts3-1)*tmp(3))/2.0d0

      endif

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(tmp,1.0d0,1.0d-4)


      cx = tmp(1)
      cy = tmp(2)
      cz = tmp(3)

      if (.not.ojag) then
         do i=1,natoms
            if (oampac) then
               read(iun,'(i5,4f13.6)') nat(i),tdum,(xyz(j,i),j=1,3)
            else
               read(iun,'(i5,4f12.6)') nat(i),tdum,(xyz(j,i),j=1,3)
            endif
         end do
      endif

      if (idebug.eq.1) then
         print*,'r=',(r(i),i=1,3)
         print*,'px py pz ',px,py,pz
         print*,'cx cy cz ',cx,cy,cz
         print*,'v1=',(v1(i),i=1,3)
         print*,'v2=',(v2(i),i=1,3)
         if (ojag) then
            do i=1,natoms
               print*, nat(i),(xyz(j,i),j=1,3)
            end do
         endif
      endif

      call crprod(v1,v2,dtmp)
      call impsc(dtmp,tmp,cosb)
      if (1.0d0-dabs(cosb).gt.0.001d0) then
          lstr = 'Only rectangular grids supported !'
          print*,'ERROR: Only rectangular grids supported ',cosb
          goto 100
      endif

      if (.not.ojag.and.itype.eq.1) then
         read(iun,'(i5)') no
         if (no.gt.1) then
            lstr = 'ONLY single orbital cube files are supported !'
            goto 100
         endif
         nlines = (no + 1) / 10
         if (no+1 - nlines*10.gt.0) nlines = nlines + 1
         do i=1,nlines-1
            read(iun,'(a)') line
         end do
      endif

      ij = 0
      iposng = 0
      
      if (ojag) then

c Jaguar cube file

         do i=1,npts1
            do j=1,npts2
               ij = ij + 1
               do k=1,npts3

                 if (getlin(0).eq.1) then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
                      if (rtype.lt.0.0d0) iposng = 1
                      denn((k-1)*mx3d2 + ij) = rtype 
                   endif
                 else
                   lstr = 'Not enough lines'
                   goto 100
                 endif

               end do
            end do
         end do

      else

c Gaussian Cube

         do i=1,npts1
            do j=1,npts2
               ij = ij + 1
               kk = 0
               do while (kk.lt.npts3)
                  n = 6
                  if (npts3-kk.lt.n) n = npts3-kk
                  read(iun,'(6E13.5)') (dtmp(k),k=1,n)
                  do k=1,n
                     denn((npts3-(kk+k))*mx3d2 + ij) = dtmp(k)
                     if (dtmp(k).lt.rneg) rneg = dtmp(k)
                  end do
                  kk = kk + 6
               end do
            end do
         end do
      endif

c allow tolerance for density, since gaussian density cubes often
c have small negative values

      if (dabs(rneg).gt.1.0d08) iposng = 1

      iplat = 0

      ca = v2(2)
      sa = -v2(1)
      sb = -v1(3)
      if (dabs(ca).gt.0.001d0) then
         cb = v1(1) / ca
      else
         cb = v1(2) / sa
      endif

      cc = 1.0d0
      sc = 0.0d0


      call parrat
      call proato

      do i=1,npts3
          pmnn(i) = 100000.d0
      end do

      do i=1,natoms
         nconn(i) = 0
         do j=1,natoms
           if (i.ne.j) then
            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*toang)**2
     &             +((xyz(2,i)-xyz(2,j))*toang)**2
     &             +((xyz(3,i)-xyz(3,j))*toang)**2
            if (dijsq.lt.dmaxsq) then
                nconn(i) = nconn(i) + 1
            endif
           endif
         end do
      end do

      call xyzcoo(1,0,0)

      ofrst = .false.

      if (ojag) iun2 = iuntmp

      lstr = 'found cube file'
      call inferr(lstr,0)
      return

100   continue
110   istat = 0
      if (ojag) iun2 = iuntmp
      call inferr(lstr,0)

      return
      end

      subroutine rdvasd(npts1,npts2,npts3,iposng,istat,lenf,
     &                  idocub,idebug,denn,pmnn,bucket,
     &                  coo,ianz,iatclr,iconn)
      implicit double precision ( a-h,o-z)

c THIS IS REALLY rdvasp

      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mxcon=10)
      parameter (lnbuck=10)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /grdhlp/ mx3d,mx3d2
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /eulx/   ca,cb,sa,sb,cc,sc
      common /celpar/ xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,nspg,kz
      common /cell/ nnat,norg,icent,inorm,ico(3,8),icn(4,8),icl(32),ncon
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)

      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,lstr
      logical opfil,gnreal
      integer getlin
      character*137 str
      character*2 tocapf
      character keywrd*160, keyori*160
      common /keywrd/ keywrd,keyori
      dimension tmp(3),dtmp(10),xyzt(3)
      dimension ieltyp(20),ielnum(20)
      dimension denn(*),pmnn(*),bucket(*)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*)

      istat = 1
      itype = 0
      toang  = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      lstr = ' '

      if (idocub.eq.1) then
         iuntmp = iun2
         iun2 = 21

         if (.not.opfil(21,keywrd(1:lenf),lenf,1,1,0)) then
            lstr = keywrd(1:lenf)//' non-existent'
            goto 110
         endif
      endif


c title

      natt = 0

      if (idocub.eq.1) then
         read(iun2,'(a)') line
      else

c are there element types ?

         if (getlin(0).eq.1) then
            do while(.true.)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
                  if (nstr.eq.1) then
                     str(2:2) = str(1:1)
                     str(1:1) = ' '
                  endif
                  ity = 0
                  do i=1,99
                     if (tocapf(str).eq.tocapf(elemnt(i))) ity = i
                  end do
                  if (ity.ne.0) then
                     natt = natt + 1
                     ieltyp(natt) = ity
                  endif 
               else
                  goto 10
               endif
            end do
         endif
      endif

10    continue

c scale factor

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            scl = rtype
         endif
      endif

c unit vectors

      if (getlin(0).eq.1) then
         if (.not.gnreal(v1,3,.false.)) goto 100
      else
         goto 100
      endif

      if (getlin(0).eq.1) then
         if (.not.gnreal(v2,3,.false.)) goto 100
      else
         goto 100
      endif

      if (getlin(0).eq.1) then
         if (.not.gnreal(tmp,3,.false.)) goto 100
      else
         goto 100
      endif

      r(1) = vlen(v1)*scl
      r(2) = vlen(v2)*scl
      r(3) = vlen(tmp)*scl
      if (r(1).le.0.0d0.or.r(2).le.0.0d0.or.r(3).le.0.0d0) goto 100

      a = r(1)
      b = r(2)
      c = r(3)
      call impsc(v2,tmp,csa)
      call impsc(v1,tmp,csb)
      call impsc(v1,v2,csc)
      alpha = dacos(csa)*todeg
      beta = dacos(csb)*todeg
      gamma = dacos(csc)*todeg
      nspg = 1

      call prcell
      call setop
      call cprot(nspg,.false.)
      if (idebug.eq.1) call prop

c number of atoms of each sort

      natoms = 0
      ity = 0
      if (getlin(0).eq.1) then
         do i=1,50
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               natoms = natoms + itype
               ity = ity + 1
               ielnum(ity) = itype
            else
               goto 20
            endif
         end do
      else
         goto 100
      endif

20    continue

      if (natt.eq.ity) then
         k = 0
         do i=1,natt
            do j=1,ielnum(i)
               k = k + 1
               ianz(k) = ieltyp(i)
               nat(k) = ieltyp(i)
            end do
         end do
      endif


c Check for Direct (=fractional coordinates)

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            call tocap(str,nstr)
            if (str(1:nstr).eq.'SELECTIVE') then
               if (getlin(0).eq.1) then
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.ne.1) goto 100
               endif
            endif
            if (str(1:nstr).ne.'DIRECT') then
                if (str(1:nstr).eq.'CARTESIAN') then
                   lstr = 'Only DIRECT; fractional coordinates'
                endif
                goto 100
            endif
         else
            goto 100
         endif
      else
         goto 100
      endif

c read in fractional coordinates

      do i=1,natoms
         if (natt.ne.ity) then
            nat(i) = 99
            ianz(i) = 99
         endif
         if (getlin(0).eq.1) then
            if (.not.gnreal(xyzt,3,.false.)) goto 100
            do j=1,3
               xyz(j,i) = v1(j)*scl*xyzt(1) + v2(j)*scl*xyzt(2) +
     &                    tmp(j)*scl*xyzt(3)
               coo(j,i) = xyzt(j)
            end do
         else
            goto 100
         endif
      end do

c      if (idocub.eq.0) then

         ncon = 1
         inorm = 0 
         iatoms = natoms
         nnat = natoms
         norg = natoms
         nstor = mxnat-iatoms
         do i=1,iatoms

            do j=1,3
               coo(j,nstor+i) = coo(j,i)
            end do
   
            call fr2crt(coo(1,i))
            do j=1,3
                coo(j,i) = coo(j,i)/toang
            end do
            ianz(nstor+i) = ianz(i)
            iatclr(nstor+i) = 1

         end do

         call doconn
         call dohcon(0)
   
         do i=1,iatoms
            do j=1,iconn(1,i)+1
               iconn(j,nstor+i) = iconn(j,i)
            end do
         end do


c      endif

      if (idocub.eq.0) then
          istat = 2
          return
      endif

      read(iun2,'(a)') line

c x,y,z dimension of grid

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts1 = itype
         else
            goto 100
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts2 = itype
         else
            goto 100
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts3 = itype
         else
            goto 100
         endif
      else
         goto 100
      endif

      if (npts1.gt.mx3d.or.npts2.gt.mx3d.or.npts3.gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',npts1,' npts2 ',npts2,' npts3 ',npts3,
     &           ' maxdim ',mx3d 
          goto 100
      endif

      px = (scl*v1(1) + scl*v2(1) + scl*tmp(1))/2.0d0
      py = (scl*v1(2) + scl*v2(2) + scl*tmp(2))/2.0d0
      pz = (scl*v1(3) + scl*v2(3) + scl*tmp(3))/2.0d0

c      do i=1,natoms
c         xyz(1,i) = xyz(1,i) + px
c         xyz(2,i) = xyz(2,i) + py
c         xyz(3,i) = xyz(3,i) + pz
c      end do

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(tmp,1.0d0,1.0d-4)


      cx = tmp(1)
      cy = tmp(2)
      cz = tmp(3)

      if (idebug.eq.1) then
         print*,'r=',(r(i),i=1,3)
         print*,'px py pz ',px,py,pz
         print*,'cx cy cz ',cx,cy,cz
         print*,'v1=',(v1(i),i=1,3)
         print*,'v2=',(v2(i),i=1,3)
         do i=1,natoms
            print*, nat(i),(xyz(j,i),j=1,3)
         end do
      endif

      call crprod(v1,v2,dtmp)
      call impsc(dtmp,tmp,cosb)
      if (1.0d0-dabs(cosb).gt.0.001d0) then
          lstr = 'Only rectangular grids supported !'
          print*,'ERROR: Only rectangular grids supported ',cosb
          goto 100
      endif

      j = 1
      k = 1
      ijkt = 0
      iposng = 0
      nall = npts1*npts2*npts3
      ib = 0
      nb = (npts1/lnbuck)*lnbuck
      if (npts1.gt.nb) nb = nb + lnbuck

      do while (ijkt.lt.nall)
c fill bucket
c          ijkt = ijk
          do while (ib.lt.nb.and.ijkt.lt.nall)
             n = lnbuck
             if (nall-ijkt.lt.n) n = nall-ijkt
c             print*,'n=',n,' bucket',bucket(ib),' ',nall,' ',ijkt
             read(21,'(10f8.3)') (bucket(ib+l),l=1,n)
             ib = ib + n
             ijkt = ijkt + n
          end do
c full bucket
          ib = ib - npts1
c fill density array
          do i=1,npts1
             denn((k-1)*mx3d2 + (i-1)*npts2+j) = bucket(i)
          end do
c          print*,j,' ',k
c          print*,(bucket(l),l=1,npts1)
c move access bucket to beginning of bucket
          do l=1,ib
             bucket(l) = bucket(npts1+l)
          end do
          j = j + 1
          if (j.gt.npts2) then
             j = 1
             k = k + 1
          endif
c          ijk = ijk + npts1
      end do

      iplat = 0

      ca = v2(2)
      sa = -v2(1)
      sb = -v1(3)
      if (dabs(ca).gt.0.001d0) then
         cb = v1(1) / ca
      else
         cb = v1(2) / sa
      endif

      cc = 1.0d0
      sc = 0.0d0


      call parrat
      call proato

      do i=1,npts3
          pmnn(i) = 100000.d0
      end do

      do i=1,natoms
         nconn(i) = 0
         do j=1,natoms
           if (i.ne.j) then
            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*toang)**2
     &             +((xyz(2,i)-xyz(2,j))*toang)**2
     &             +((xyz(3,i)-xyz(3,j))*toang)**2
            if (dijsq.lt.dmaxsq) then
                nconn(i) = nconn(i) + 1
            endif
           endif
         end do
      end do

      if (idocub.eq.1) then
          close(21)
          call xyzcoo(1,0,0)
      endif

      ofrst = .false.

      if (idocub.eq.1) iun2 = iuntmp

      lstr = 'found cube file'
      call inferr(lstr,0)
      return

100   if (idocub.eq.1) close(21)
110   if (idocub.eq.1) iun2 = iuntmp
      istat = 0
      call inferr(lstr,0)

      return
      end

      subroutine wrvasd(iun,coo,ianz)
      implicit double precision ( a-h,o-z)
      parameter (mxel=100)
      parameter (mxetyp=20)
      common /celpar/ xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,nspg,kz
      common /cell/ nnat,norg,icent,inorm,ico(3,8),icn(4,8),icl(32),ncon
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)
      logical fndel
      dimension tmp(3),tr(3),rr(3,3),ieltyp(mxetyp),ielnum(mxetyp)
      dimension coo(3,*),ianz(*)

      toang  = 0.52917706d0

      natt = 0
      do i=1,mxetyp
         ielnum(i) = 0
      end do

      do i=1,iatoms

         if (ianz(i).gt.0.and.ianz(i).lt.99) then

            fndel = .false.
            do j=1,natt
               if (ianz(i).eq.ieltyp(j)) then
                  ielnum(j) = ielnum(j) + 1
                  fndel = .true.
               endif
            end do

            if (.not.fndel) then
               natt = natt + 1
               ieltyp(natt) = ianz(i)
               ielnum(natt) = 1
            endif

         endif

      end do

      write(iun,'(20(a2,1x))') (elemnt(ieltyp(i)),i=1,natt)

      scl = 1.0d0
      write(iun,'(f12.6)') scl

      call setrr(alpha,beta,gamma,a,b,c,rr)

      tmp(1) = 1.0d0
      tmp(2) = 0.0d0
      tmp(3) = 0.0d0
c      call fr2crt(tmp)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do

c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)
      
      tmp(1) = 0.0d0
      tmp(2) = 1.0d0
      tmp(3) = 0.0d0
c      call fr2crt(tmp)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      tmp(1) = 0.0d0
      tmp(2) = 0.0d0
      tmp(3) = 1.0d0
c      call fr2crt(tmp)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      write(iun,'(20(i3,1x))') (ielnum(i),i=1,natt)

      write(iun,'(a)') 'Direct'

      do k=1,natt

         do i=1,iatoms
            if (ianz(i).eq.ieltyp(k)) then
               do j=1,3
                  tmp(j) = coo(j,i) * toang
               end do
               call crt2fr(tmp,tr)
               write(iun,'(3(f12.6,1x))') (tr(j),j=1,3)
            endif
         end do

      end do

      call inferr('Wrote file: POSCAR',0)

      return
      end

      subroutine wrmopd(iun,coo,ianz)
      implicit double precision ( a-h,o-z)
      parameter (mxel=100)
      parameter (mxetyp=20)
      common /celpar/ xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,nspg,kz
      common /cell/ nnat,norg,icent,inorm,ico(3,8),icn(4,8),icl(32),ncon
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension tmp(3)
c      dimension tr(3),rr(3,3)
      dimension coo(3,*),ianz(*)

      toang  = 0.52917706d0

      write(iun,'(a)') 'AM1 NOINTER XYZ'
      write(iun,'(a)') ' '
      write(iun,'(a)') ' '

c      call setrr(alpha,beta,gamma,a,b,c,rr)



      do i=1,iatoms
          do j=1,3
             tmp(j) = coo(j,i) * toang
          end do
          if (ianz(i).gt.0.and.ianz(i).lt.99) then
             if (i.eq.1) then
                write(iun,'(a2,1x,3(f12.6,a3))') elemnt(ianz(i)),
     &            tmp(1),' 0 ',tmp(2),' 0 ',tmp(3),' 0 '
             else
                write(iun,'(a2,1x,3(f12.6,a3))') elemnt(ianz(i)),
     &            tmp(1),' 1 ',tmp(2),' 1 ',tmp(3),' 1 '
             endif
          endif
      end do



      tmp(1) = 1.0d0
      tmp(2) = 0.0d0
      tmp(3) = 0.0d0
      call fr2crt(tmp)
c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do

      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 1 ',tmp(2),' 0 ',tmp(3),' 0 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)
      
      tmp(1) = 0.0d0
      tmp(2) = 1.0d0
      tmp(3) = 0.0d0
      call fr2crt(tmp)
c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 0 ',tmp(2),' 1 ',tmp(3),' 0 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      tmp(1) = 0.0d0
      tmp(2) = 0.0d0
      tmp(3) = 1.0d0

      call fr2crt(tmp)

c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)

      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 0 ',tmp(2),' 0 ',tmp(3),' 1 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      call inferr('Wrote file: mopac.dat',0)

      return
      end

      subroutine rdgrdd(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn,buff)
      implicit double precision (a-h,o-z)
      parameter (mxdir=500)
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      real ra,orig,den
      character*137 lstr
      character*4 buff(*)
      character*72 header
      integer currec,bigend,buflen
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      dimension orig(3)
      dimension denn(*),pmnn(*),dens(*)

c nnx,nny,nnz    the number of points in x, y and z direction
c ra             real step along x,y and z direction per point
c rx,ry,rz       origin of the grid

      istat = 1
      lstr = ' '

      iplat = 0

      buflen = mx3d2
      rewind(iund)
      call getrec(buff,buflen,ierr)

      do i =1,18
         header(4*(i-1)+1:4*i) = buff(i)(1:4)
      end do

      print*,'header = ',header

      call byter(buff(26),npts1)
      call byter(buff(27),npts2)
      call byter(buff(28),npts3)

      print*,'npts1=',npts1,' npts2=',npts2,' npts3=',npts3

      call byter(buff(29),ra)

      print*,'ra=',ra

      call byter(buff(30),orig(1))
      call byter(buff(31),orig(2))
      call byter(buff(32),orig(3))

      print*,'orgx,orgy,orgz ',orig(1),' ',orig(2),' ',orig(3)

      v1(1) = 1.0d0
      v1(2) = 0.0d0
      v1(3) = 0.0d0

      v2(1) = 0.0d0
      v2(2) = 1.0d0
      v2(3) = 0.0d0

      r(1) = dble(ra)*dble(npts1-1)
      r(2) = dble(ra)*dble(npts2-1)
      r(3) = dble(ra)*dble(npts3-1)

      px = dble(orig(1)) + r(1)/2.0d0
      py = dble(orig(2)) + r(2)/2.0d0
      pz = dble(orig(3)) + r(3)/2.0d0

      cx = 0.0d0
      cy = 0.0d0
      cz = 1.0d0

      pmax = -1000000.d0
      pmin = 1000000.d0

      do k=1,npts3

c get plate

         call getrec(buff,buflen,ierr)
         if (ierr.eq.1) goto 100

         call byter(buff(1),nz)
         call byter(buff(2),nx)
         call byter(buff(3),ny)

c         print*,'nz,nx,ny ',nz,' ',nx,' ',ny

         call getrec(buff,buflen,ierr)

         ij = 0
         do i=1,ny
            do j=1,nx
               ij = ij + 1
               call byter(buff(ij),den)
               dens((j-1)*ny+i) = dble(den)
            end do
         end do
         do i=1,nx*ny
            denn((nz-1)*mx3d2 + i) = dens(i)
            if (dens(i).gt.pmax) pmax = dens(i)
            if (dens(i).lt.pmin) pmin = dens(i)
         end do

      end do

      do i=1,npts3
         pmnn(i) = 100000.d0
      end do

      call pareul

      ofrst = .false.

      lstr = 'found cube file'
      call inferr(lstr,0)
      return

100   istat = 0
      lstr = 'error reading GRID file'
      call inferr(lstr,0)
      return
      end

      subroutine rdomad(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn)
      implicit double precision (a-h,o-z)
      parameter (mxdir=500)
      logical dolap, lapdbl
      common /vropt/ ivtwo,ihand,ivadd
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3)
      common /grdhlp/ mx3d,mx3d2
      common /cnthlp/ rng1,rng2,vlcnt
      character*137 lstr
      integer*2 buff(256),i1to2
      integer*1 bff(512)
      integer currec,bigend
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      equivalence (buff,bff)
      dimension origin(3),rt(3)
      dimension denn(*),pmnn(*),dens(*), fdum(3)

c nnx,nny,nnz    the number of points in x, y and z direction
c ra             real step along x,y and z direction per point
c rx,ry,rz       origin of the grid

      istat = 1
      lstr = ' '

      toang  = 0.52917706d0
      iplat = 0

      currec = -1
      rewind(iund)
      call getrc2(buff,ierr)

      npts1 = int(buff(7))
      npts2 = int(buff(8))
      npts3 = int(buff(9))

      print*,' '
      print*,'O/DSN6 map file:'
      print*,' '
      print*,'npts1 npts2 npts3 ',npts1,npts2,npts3

      ior1 = int(buff(1)) 
      ior2 = int(buff(2)) 
      ior3 = int(buff(3)) 

      print*,'orgx,orgy,orgz ',ior1,ior2,ior3

      iex1 = int(buff(4)) 
      iex2 = int(buff(5)) 
      iex3 = int(buff(6)) 

      print*,'iex1,iex2,iex3 ',iex1,iex2,iex3

c     the grid does not cover the whole unit cell, but just the molecule
c     the grid therefor does not run from 1 to npts in each direction but
c     from ior1 to ior1 + iex1 -1 (in the x direction)
c     we need npts1,npts2,npts3 however to calculate the spacing between
c     two consequetive grid points in all three directions 
c     (together with a,b,c)
c
c     the problem with existing molden maps is they have equally many
c     points to the right and left of the origin (vo)
c     in these new maps the origin is not the center of the map, but
c     the start of the map in all three directions (npts1=npts2=npts3=1)


      sc  =  1.0d0 / dble(buff(18))
      sca  =  1.0d0 / (dble(buff(18)) * toang)

c     the spacing between two consequetive grid points in all three directions 

      a = sca * dble(buff(10)) / dble(npts1)
      b = sca * dble(buff(11)) / dble(npts2)
      c = sca * dble(buff(12)) / dble(npts3)

      print*,'a b c',sc*dble(buff(10)),sc*dble(buff(11)),
     *               sc*dble(buff(12))

      alpha = sc * dble(buff(13)) * 3.14159265d0 / 180.0d0
      beta = sc * dble(buff(14)) * 3.14159265d0 / 180.0d0
      gamma = sc * dble(buff(15)) * 3.14159265d0 / 180.0d0


      prod = dble(buff(16)) / dble(buff(19))
      plus = dble(buff(17))

      print*,'alpha beta gamma ',sc*dble(buff(13)),sc*dble(buff(14)),
     &                           sc*dble(buff(15))

      v1(1) = a
      v1(2) = 0.0d0
      v1(3) = 0.0d0
    
      v2(1) = dcos(gamma) * b
      v2(2) = dsin(gamma) * b
      v2(3) = 0.0d0
    
      z1 = dcos(beta)
      z2 = (dcos(alpha) - dcos(beta)*dcos(gamma)) / dsin(gamma)
      z3 = dsqrt(1.0 - z1*z1 - z2*z2);

      v3(1) = z1 * c
      v3(2) = z2 * c
      v3(3) = z3 * c
    
c     Convert the origin from grid space to cartesian coordinates

      vo(1) = v1(1) * dble(ior1) + 
     &        v2(1) * dble(ior2) + v3(1) * dble(ior3)
      vo(2) = v2(2) * dble(ior2) + v3(2) * dble(ior3)
      vo(3) =                      v3(3) * dble(ior3)
     
c     normalise basis vectors

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(v3,1.0d0,1.0d-4)

      r(1) = a*dble(iex1-1)
      r(2) = b*dble(iex2-1)
      r(3) = c*dble(iex3-1)

      npts1 = iex1
      npts2 = iex2
      npts3 = iex3

c     spacing between consequetive points in the three directions
c     rf1 = r(1) / dble(iex1-1)
c     rf2 = r(2) / dble(iex2-1)
c     rf3 = r(3) / dble(iex3-1)
c
c     do kc=1,npts3 do ic=1,npts2 do jc=1,npts3
c     coordinates of each grid point (jc,ic,kc) rt(1,2,3)
c     rt(1) = v1(1)*(jc-1)*rf1 + v2(1)*(ic-1)*rf2 + v3(1)*(kc-1)*rf3 + vo(1)
c     rt(2) = v1(2)*(jc-1)*rf1 + v2(2)*(ic-1)*rf2 + v3(2)*(kc-1)*rf3 + vo(2)
c     rt(3) = v1(3)*(jc-1)*rf1 + v2(3)*(ic-1)*rf2 + v3(3)*(kc-1)*rf3 + vo(3)
c
c     we have to change rotbck to:
c      do i=1,3
c         wn(i) = v1(i)*(w1)*r(1) +
c     &           v2(i)*(w2)*r(2) +
c     &           v3(i)*(w3)*r(3) + vo(i)
c      end do
c
c alternatively we could make it a general purpose routine by specifying
c in common comsrf what is the location of the origin in grid coordinates
c

      pmax = -1000000.d0
      pmin = 1000000.d0

      ibrik = npts1/8
      if (npts1.gt.ibrik*8) ibrik = ibrik + 1
      jbrik = npts2/8
      if (npts2.gt.jbrik*8) jbrik = jbrik + 1
      kbrik = npts3/8
      if (npts3.gt.kbrik*8) kbrik = kbrik + 1

      do k=1,kbrik
         do j=1,jbrik
            do i=1,ibrik

               call getrc2(buff,ierr)

               do iz=1,8
                  if ((iz + (k-1)*8).le.npts3) then
                     do iy=1,8
                        if ((iy + (j-1)*8).le.npts2) then
                           do ix=1,8

                              if ((ix + (i-1)*8).le.npts1) then

                                ipnt = ix        +
     &                                 (iy-1)*8  +
     &                                 (iz-1)*64 
                                den = dble(i1to2(bff(ipnt))) - plus
                                den = den / prod

                                denn( (ix+(i-1)*8)          +
     &                               ((iy+(j-1)*8)-1)*npts1 +
     &                               ((iz+(k-1)*8)-1)*mx3d2) 
     &                          = den

                                if (den.gt.pmax) pmax = den
                                if (den.lt.pmin) pmin = den

                              endif
                        
                           end do
                        endif
                     end do
                  endif
               end do

            end do
         end do
      end do

      do i=1,npts3
         pmnn(i) = 100000.d0
      end do

      print*,'Dens Max=',pmax,' Dens Min=',pmin
      rng1 = pmin
      rng2 = pmax

c      wo(1) = 0.0d0
c      wo(2) = 0.0d0
c      wo(3) = 0.0d0
c
c      valcnt = 1.00d0
c      do i=1,3
c         origin(i) = 0.0d0
c         rt(i) = 1.0d0
c      end do
c
c      ipsi = 0
c      dolap =.false.
c      lapdbl = .false.
c      itrans = 1
c      mapit = 0
c
c      ivtwot = ivtwo
c      ivtwo = 4
c
c      call mcubes(npts1,npts2,npts3,denn,fmap,mapit,origin,valcnt,rt,
c     &                      ipsi,dolap,lapdbl,itrans,iun)
c
c      ivtwo = ivtwot

      vlcnt = 1.00d0
      lstr = 'found omap file'
      call inferr(lstr,0)

      close(iun)
      call messg(16)

      return

100   istat = 0
      lstr = 'error reading OMAP/DSN6 file'
      call inferr(lstr,0)
      return
      end

      subroutine dpomad(denn)
      implicit double precision (a-h,o-z)
      parameter (numcal=5000)
      parameter (mxheta=50)
      logical dolap, lapdbl
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3)
      common /cnthlp/ rng1,rng2,vlcnt
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf,
     &                iams(numcal),ihets(mxheta)
      common /vropt/ ivtwo,ihand,ivadd
      dimension origin(3),rt(3)
      dimension denn(*),fdum(3)

      call curs(1)
      wo(1) = 0.0d0
      wo(2) = 0.0d0
      wo(3) = 0.0d0

      do i=1,3
         origin(i) = 0.0d0
         rt(i) = 1.0d0
      end do

      ipsi   = 0
      dolap  = .false.
      lapdbl = .false.
      itrans = 1
      mapit  = 0

      ivtwot = ivtwo
      ivtwo = 4

      call mcubes(npts1,npts2,npts3,denn,fdum,mapit,origin,vlcnt,rt,
     &                      ipsi,dolap,lapdbl,itrans,iun)

      ivtwo = ivtwot
      call curs(0)

      return
      end

      subroutine byter(intin,intout)
      implicit none
      integer intin, intout,bigend,nlen
      common /isend/ bigend,nlen

      if (bigend.eq.1) then
         intout = intin
      else
         call mvbits( intin, 24, 8, intout, 0  )
         call mvbits( intin, 16, 8, intout, 8  )
         call mvbits( intin,  8, 8, intout, 16 )
         call mvbits( intin,  0, 8, intout, 24 )
      endif

      return
      end

      subroutine getrec(buff,buflen,ierr)
      implicit real (a-h,o-z)
      character*4 buff(*)
      integer recln,currec,ierr,buflen
      common /rdrec/ iund,currec

      ierr = 0
      currec = currec + 1

      read(iund,rec=currec,err=100) intin

      call byter(intin,intout)

      recln = intout/4

      if (recln.gt.buflen) goto 100

      do i =1,recln
         read(iund,rec=currec+i,err=100) buff(i)
      end do
   
      currec = currec + recln
      currec = currec + 1

      read(iund,rec=currec,err=100) intin


      call byter(intin,intchk)

      if (intout.ne.intchk) then
         ierr = 1
         print*,'error reading file'
      endif

      return

100   ierr = 1
      return
      end

      subroutine bytr2(intin)
      implicit none
      integer bigend,nlen,i
      integer*2 intin(256),intout
      common /isend/ bigend,nlen

      do i=1,256
         if (bigend.ne.1) then
            call mvbits( intin(i),  8, 8, intout, 0 )
            call mvbits( intin(i),  0, 8, intout, 8 )
            intin(i) = intout
         endif
      end do

      return
      end

      integer*2 function i1to2(intin)
      integer*1 intin

      i1to2 = intin
      if (i1to2.lt.0) i1to2 = abs(intin) + 128
      return
      end

      subroutine getrc2(buff,ierr)
      implicit real (a-h,o-z)
      integer*2 buff(256)
      integer currec,ierr
      integer*2 into
      common /rdrec/ iund,currec

      ierr = 0
      currec = currec + 1

      do i =1,256
         read(iund,rec=currec+i,err=100) buff(i)
      end do
   
      call bytr2(buff)
      if (currec.eq.0) then
         if (buff(19).ne.100) goto 100
      endif

      currec = currec + 255

      return

100   ierr = 1
      return
      end

      subroutine fndor(idebug)
      implicit double precision ( a-h,o-z)
      character*137 line
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor

      if (idebug.eq.1) print*,'start find orientations'
      ifor = 0
      nzm = 0
      nso = 0
      nio = 0
      nzo = 0 
      istat = 1
      do while(istat.eq.1)
         call searchq(line,'Z-MATRIX (ANGSTROMS',
     &                     'Standard orientation:',
     &                     'Input orientation:',
     &                     'Z-Matrix orientation:',istat)
         if (icdex(line,'Z-MATRIX (ANGSTROMS').ne.0) nzm = nzm + 1
         if (icdex(line,'Standard orientation:').ne.0) nso = nso + 1
         if (icdex(line,'Input orientation:').ne.0) nio = nio + 1
         if (icdex(line,'Z-Matrix orientation:').ne.0) nzo = nzo + 1
      end do

      if (nso.eq.nio) ioropt = 1
      if (nso.eq.0.and.nio.eq.0) ioropt = 0
      if (nso.gt.nio) ioropt = 2
      if (nso.lt.nio) ioropt = 3

      if (idebug.eq.1) then
         print*,'nzm=',nzm,' nso=',nso,' nio=',nio,' nzo=',nzo
      endif

      return
      end

      subroutine wrcubd(npts1,npts2,npts3,ipsi,denn)

c THIS IS REALLY wrcube

      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /grdhlp/ mx3d,mx3d2
      dimension v3(3),o(3),p(3),dtmp(6),denn(*)

      iun = 21

c     normalize the perpendicular vector

      rn = dsqrt(cx*cx+cy*cy+cz*cz)

      v3(1) = cx / rn
      v3(2) = cy / rn
      v3(3) = cz / rn

      p(1) = px
      p(2) = py
      p(3) = pz

c     calculate the origin for the cube

      do i=1,3
         o(i) = p(i) - 0.5d0*(v1(i)*r(1) + v2(i)*r(2) + v3(i)*r(3))
      end do

      write(iun,'(a)') 'Molden generated cube file'

      if (ipsi.eq.0) then
         write(iun,*) 'Density'
      else
         if (ipsi.lt.0) then
            write(iun,'(''Beta Orbital '',i4)') iabs(ipsi)
         else
            write(iun,'(''Orbital '',i4)') ipsi
         endif
      endif

c     number of atoms and origin of the cube

      write(iun,'(i5,4(f12.6))') natoms,(o(i),i=1,3)

c     number of points in each dimension, and voxel size

      write(iun,'(i5,4(f12.6))') npts1,
     &            (v1(i)*r(1)/dble(npts1-1),i=1,3)
      write(iun,'(i5,4(f12.6))') npts2,
     &            (v2(i)*r(2)/dble(npts2-1),i=1,3)
      write(iun,'(i5,4(f12.6))') npts3,
     &            (v3(i)*r(3)/dble(npts3-1),i=1,3)

c     atomic numbers and coordinates of the atoms (in bohrs)

      do i=1,natoms
        write(iun,'(i5,4(f12.6))') nat(i),0.0,(xyz(j,i),j=1,3)
      end do

c     density data

      ij = 0 

      do i=1,npts1
         do j=1,npts2
            ij = ij + 1
            kk = 0
            do while (kk.lt.npts3)
               n = 6
               if (npts3-kk.lt.n) n = npts3-kk
               do k=1,n
                  dtmp(k) = denn((npts3-(kk+k))*mx3d2 + ij)
               end do
               write(iun,'(6E13.5)') (dtmp(k),k=1,n)
               kk = kk + 6
            end do
         end do
      end do

      return
      end

      subroutine getpod(icom,ifd,iff,doscl,ioatms,ioadd,
     &                  coo,ianz,iaton,iconn)

      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (mxonh=100)
      parameter (numatm=2000)
      parameter (small=1.0d-4)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /athlp/ iatoms, mxnat
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /gxyz/   ixyz98, iopr, isymm, irc, imp2, icntp
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /zmpart/ ipart,imn,imx,idcur
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fdum3(10),idum(7),ieav,ifrav,mxpnt
      common /mopver/ mopopt

      character lstr*137
      character*3 astr
      character*8 refcod
      integer first,prev,next,last,xmol,getmf,doscl
      logical gamess,gauss,mopac,molpot,favail,oxyz,elpot,cpmd,chemx,
     & oisbin,doconv,dummy,dozme,gamus,ctoz
      logical adfin,gusirc,chpot,qchem,orca
      common /choic/mopac,gamess,gauss,molpot,elpot,chemx,cpmd,
     &              oisbin,gamus,ctoz,adfin,chpot,qchem,orca
      common /getpnt/ irtype,ipdbon,ipdbgro,xmol,favail,oxyz,
     &                doconv,dozme,gusirc
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /xyzopt/ ixyz,ichx,icrtp,ipdbwh,iambch
      common /cllab/ iclon,iclpnt(4)
      character*23 stmp
      dimension dum(3),coo(3,*),ianz(*),iaton(*),iconn(mxcon+1,*)

cd     write(iun3,'(a)')'enter subroutine getpoi'

      first = -1
      next  = -2
      last  = -3
      prev  = -4
      tol = small
      idoprt = 0

      icomm = icom

c for gaussian
 
      stmp = 'Input orientation:'
      ns = 18
      if (ixyz98.gt.0.and.(ioropt.eq.2)) then
          stmp = 'Standard orientation:'
          ns = 22
      endif

      if (dozme) then
c since dumzm resets the ipart variable, we need the help variable dopart
c this is because otherwise conpdb downstream goes wrong
          if (ipart.eq.1) idoprt = ipart
          favail = .false.
          call dumzm(coo,ianz,iatoms)
          goto 100
      endif

      if (oisbin.and..not.chemx) iatoms = 0


c     convert mopac coordinates to a.u.
c     vdwr are in angstrom, vrad in a.u.

      if (mopac.and.doconv) call xyzcoo(1,1,0)

      if (cpmd.and.ipoints.eq.0.and.(oxyz.or.irtype.eq.4)) then
          call xyzcoo(1,0,0)
          call haszm(.false.)
      endif

      if (gamess.and.ipoints.eq.0.and.(oxyz.or.irtype.eq.4).and.
     &    .not.gamus) then
          call xyzcoo(1,0,0)
          call haszm(.false.)
      endif
      if (gauss.and.(ipoints.le.1.or.irtype.eq.4).and.icomm.eq.-1) then
          rewind iun2
          call gaupoi(istat)
          if (istat.eq.-1) then
             favail = .false.
          else
             favail = .true.
          endif
          if ((istat.eq.0.or.irtype.eq.4).and.ioni.ne.1) 
     &          call xyzcoo(1,0,0)
          if (istat.eq.0) call haszm(.false.)
      endif
      
      if (icomm.eq.prev) then
          if ( ipnt.le.1 ) return
          ipnt = ipnt -1
          icomm = ipnt
      endif

      favail = .false.

      if (iatoms.eq.0.and..not.(gamess.or.gauss.or.cpmd)) then
          call inferr('No coordinates found !',0)
cd         write(iun3,'(a)')'leave subroutine getpoi'
          return
      endif

c Mopac2007 AUX file

      if (mopac.and.mopopt.eq.4.and.ipoints.ge.1) then

          if (icomm .eq. first) then
             rewind iun2
             call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
             call readel(lstr,2)
             if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
             if (istat.eq.1) ipnt = 1
          elseif (icomm .eq. next) then
             call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
             call readel(lstr,2)
             if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
             if (istat.eq.1) then
                ipnt = ipnt +1
             else
                rewind iun2
                call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
                call readel(lstr,2)
                if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
                if (istat.eq.1) ipnt = 1
             endif
          elseif (icomm.gt.0) then
             rewind iun2
             do i=1,icomm
                call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
                call readel(lstr,2)
                if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
                if (istat.eq.1) then
                    dummy = .true.
                else
                    dummy = .false.
                endif
             end do
             ipnt = icomm
          endif
          call xyzcoo(0,1,0)
      endif

      if (mopac.and..not.doconv.and.ipoints.ge.1) then
          if (icomm .eq. first) then
             rewind iun2
             call getmop(iatoms,heat,0,1,istat) 
             if (istat.eq.1) ipnt = 1
          elseif (icomm .eq. next) then
             call getmop(iatoms,heat,0,0,istat) 
             if (istat.eq.1) then
                ipnt = ipnt +1
             else
                rewind iun2
                call getmop(iatoms,heat,0,0,istat) 
                if (istat.eq.1) ipnt = 1
             endif
          elseif (icomm.gt.0) then
             rewind iun2
             idomopf = 1
             do i=1,icomm
                call getmop(iatoms,heat,0,idomopf,istat) 
                if (istat.eq.1) then
                    dummy = .true.
                else
                    dummy = .false.
                endif
                idomopf = 0
             end do
             ipnt = icomm
          endif
      endif

      if ((xmol.ge.1.or.(adfin.and.ihasg.ge.1)).and.ipoints.gt.1) then
          if (icomm .eq. first) then
             if (adfin) then
                call rewmf
                call srchmf(lstr,'[GEOMETRIES]',istat)
             else
                rewind iun2
             endif
             if (adfin.and.ihasg.eq.2) then
                call getzm(iatoms,0,0,istat)
                if (istat.eq.1) ipnt = 1
             else
                if (xmol.eq.2.or.xmol.eq.3) then
                   call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                   if (igttnk.eq.1) ipnt = 1
                elseif (xmol.eq.4) then
                   call getmol(igetmo)
                   if (igetmo.eq.1) ipnt = 1
                else
                   call getxyz(igetxy,heat,0)
                   if (igetxy.eq.1) ipnt = 1
                endif
             endif
             if (adfin) then
                iolin = getmf()
                call rdfc(ipnt,istat)
                if (istat.eq.1) then
                   favail = .true.
                else
                   favail = .false.
                endif
                call putmf(iolin)
             endif
          elseif (icomm .eq. next.and..not.(adfin.and.ifrav.eq.1)) then
             if (adfin.and.ihasg.eq.2) then
                call getzm(iatoms,0,0,istat)
                if (istat.eq.1) then
                   dummy = .true.
                else
                   dummy = .false.
                endif
             else
                if (xmol.eq.2.or.xmol.eq.3) then
                   call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                   if (igttnk.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                elseif (xmol.eq.4) then
                   call getmol(igetmo)
                   if (igetmo.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   call getxyz(igetxy,heat,0)
                   if (igetxy.eq.1) then
                       dummy = .true.
                   else
                       dummy = .false.
                   endif
                endif
             endif
             if (dummy) then
                ipnt = ipnt +1
             else
                if (adfin) then
                   call rewmf
                   call srchmf(lstr,'[GEOMETRIES]',istat)
                else
                   rewind iun2
                endif
                if (adfin.and.ihasg.eq.2) then
                   call getzm(iatoms,0,0,istat)
                   if (istat.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   if (xmol.eq.2.or.xmol.eq.3) then
                      call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                      if (igttnk.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   elseif (xmol.eq.4) then
                      call getmol(igetmo)
                      if (igetmo.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   else
                      call getxyz(igetxy,heat,0)
                      if (igetxy.eq.1) then
                          dummy = .true.
                      else
                          dummy = .false.
                      endif
                   endif
                endif
                if (dummy) ipnt = 1
             endif
          elseif (icomm.gt.0.or.
     &           (icomm.eq.next.and.adfin.and.ifrav.eq.1)) then
             if (icomm.eq.next) then
                ipntt = ipnt + 1
                if (ipntt.gt.ipoints) ipntt = ipoints
             endif
             if (icomm.gt.0) ipntt = icomm
             if (adfin) then
                call rewmf
                call srchmf(lstr,'[GEOMETRIES]',istat)
             else
                rewind iun2
             endif
             do i=1,ipntt
                if (adfin.and.ihasg.eq.2) then
                   call getzm(iatoms,0,0,istat)
                   if (istat.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   if (xmol.eq.2.or.xmol.eq.3) then
                      call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                      if (igttnk.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   elseif (xmol.eq.4) then
                      call getmol(igetmo)
                      if (igetmo.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   else
                      call getxyz(igetxy,heat,0)
                      if (igetxy.eq.1) then
                          dummy = .true.
                      else
                          dummy = .false.
                      endif
                   endif
                endif
             end do
             if (adfin) then
                call rdfc(ipntt,istat)
                if (istat.eq.1) then
                   favail = .true.
                else
                   favail = .false.
                endif
             endif
             ipnt = ipntt
          endif
      endif

      if (qchem) then
          if ( icomm .eq. first ) then
             call rewmf
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewmf
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewmf
             ipnt = icomm
          endif
          call qcxyz(0,.false.,ipnt,istat)
          if (istat.eq.-1) then
               favail = .false.
          else
               favail = .true.
          endif
      endif

      if (orca) then
          if ( icomm .eq. first ) then
             call rewmf
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewmf
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewmf
             ipnt = icomm
          endif
          call orcxyz(0,ipnt,istat)
          if (istat.eq.-1) then
               favail = .false.
          else
               favail = .true.
          endif
      endif

      if (gamess.and.ipoints.gt.0.and.(.not.gamus)) then
          if ( icomm .eq. first ) then
             rewind iun2
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             rewind iun2
             ipnt = ipoints
          elseif (icomm.gt.0) then
             rewind iun2
             ipnt = icomm
          endif
          if (oxyz) then
             itmp = ipnt - 1
             call gampoi(itmp,istat,oxyz)
          else
             call gampoi(ipnt,istat,oxyz)
          endif
          if ( istat .eq. -1 ) then
               favail = .false.
          else
               favail = .true.
          endif
c          if (msucc.eq.0.and..not.oxyz) favail = .false.
      endif

      if (gauss.and.ipoints.gt.1) then
          if ( icomm .eq. first ) then
             rewind iun2
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             rewind iun2
             do i=1,ipoints
                 if ((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0) then
                    call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
                 elseif (nzo.gt.0) then
                    call search(lstr,'Z-Matrix orientation:',istat)
                 else
                    call search(lstr,stmp(1:ns),istat)
                 endif
             end do
             backspace iun2
             ipnt = ipoints
          elseif (icomm.gt.0) then
             rewind iun2
             do i=1,icomm
                 if ((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0) then
                    call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
                 elseif (nzo.gt.0) then
                    call search(lstr,'Z-Matrix orientation:',istat)
                 else
                    call search(lstr,stmp(1:ns),istat)
                 endif
             end do
             backspace iun2
             ipnt = icomm
          endif
          call gaupoi(istat)
          if ( istat .eq. -1 ) then
               favail = .false.
          else
               favail = .true.
          endif
      endif

      if ( gamus.and..not.(ipoints.le.1.and.iatoms.gt.0) ) then
          if ( icomm .eq. first ) then
             rewind iun2
             ipnt = 1
             call gamupt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call gamupt(ipnt,istat)
          elseif ( icomm .eq. last ) then
             rewind iun2
             do i=1,ipoints
                call gamupt(ipoints,istat)
             end do
             backspace iun2
             ipnt = ipoints
          elseif (icomm.gt.0) then
             rewind iun2
             do i=1,icomm
                call gamupt(icomm,istat)
             end do
             backspace iun2
             ipnt = icomm
          endif
          favail = .true.
      endif

      if (cpmd.and..not.(ipoints.le.1.and.iatoms.gt.0)
     &     .and.irtype.ne.3 ) then
c          iunt = iun2
c          iun2 = iun5
          if ( icomm .eq. first ) then
             rewind iun2
             ipnt = 1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. last ) then
             rewind iun2
             do i=1,ipoints
                call cpmdpt(ipoints,istat)
             end do
             backspace iun2
             ipnt = ipoints
          elseif (icomm.gt.0) then
             rewind iun2
             do i=1,icomm
                call cpmdpt(icomm,istat)
             end do
             backspace iun2
             ipnt = icomm
          endif
          favail = .true.
c          iun2 = iunt
      endif

      if ( cpmd.and..not.(ipoints.le.1.and.iatoms.gt.0)
     &     .and.irtype.eq.3 ) then
          if (icomm.ne.first) then
             iunt = iun2
             iun2 = iun5
          endif
          if ( icomm .eq. first ) then
             rewind iun2
             ipnt = 1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call cpmdptdyn(ipnt,istat)
          elseif ( icomm .eq. last ) then
             rewind iun2
             do i=1,ipoints
                call cpmdptdyn(ipoints,istat)
             end do
             backspace iun2
             ipnt = ipoints
          elseif (icomm.gt.0) then
             rewind iun2
             do i=1,icomm
                call cpmdptdyn(icomm,istat)
             end do
             backspace iun2
             ipnt = icomm
          endif
          favail = .true.
          if (icomm.ne.first) iun2 = iunt
      endif

      if (((icrtp.le.3.and.icrtp.ge.1).or.icrtp.eq.5)
     &     .and.ipoints.gt.1) then
          if (icomm.eq.first) then
             rewind iun2
             if (icrtp.eq.3) then
                call rfbio(0,1,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,idum,1)
             elseif (icrtp.eq.5) then
                call getxdt(1,istat)
             else
                call rfdat(0,istat,refcod)
             endif
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             if (icrtp.eq.3) then
                call rfbio(0,0,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,idum,1)
             elseif (icrtp.eq.5) then
                call getxdt(ipnt,istat)
             else
                call rfdat(0,istat,refcod)
             endif
          elseif (icomm.gt.0) then
             rewind iun2
             if (icrtp.eq.3) then
                call rfbio(0,1,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,idum,1)
             elseif (icrtp.eq.5) then
                call getxdt(icomm,istat)
             else
                call rfdat(0,istat,refcod)
             endif
             if (icrtp.ne.5) then
                do i=1,icomm-1
                   if (icrtp.eq.3) then
                      call rfbio(0,0,istat)
                   elseif (icrtp.eq.1) then
                      call rdchx(0,3,0,0,0,istat,
     &                           idum,1)
                   else
                      call rfdat(0,istat,refcod)
                   endif
                end do
             endif
             ipnt = icomm
          endif
          if (.not.(icrtp.eq.3.and.istat.eq.1)) 
     &       call fdat(ifd,0,0,0,0,0)
      endif

      if (ipdbon.eq.1.and.ipdbgro.eq.1) then
          if (icomm.eq.first) then
             ipnt = 1
             call gtfrm(ipnt)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt + 1
             call gtfrm(ipnt)
          elseif (icomm.gt.0) then
             rewind iun2
             call gtfrm(icomm)
             ipnt = icomm
          endif
      endif

100   continue

      if (ioadd.eq.0) then
        if (.not.((gamess.and.ipoints.eq.0.and.(oxyz.or.irtype.eq.4))
     &    .or.(gauss.and.ipoints.le.1).or.
     &    (icrtp.eq.3.and.ipoints.gt.1).or.
     &    (ipdbon.eq.1.and.dozme))) call docent
      endif

      if (gamess.and.ipoints.gt.0.and..not.oxyz.and.msucc.eq.1
     &    .and.(.not.dozme).and.(.not.gamus).and.(.not.cpmd)) 
     &    call rotmom(ipnt,favail)


      ibeg = 1
      if (ioadd.eq.1) ibeg = ioatms + 1

      do i=ibeg,iatoms
         if (ipdbgro.eq.1) then
            if (ianz(i).eq.100.and.ipnt.gt.1) then
               if (i.gt.iclpnt(1)+7) iaton(i) = 0
            else
               iaton(i) = 1
            endif
         else
            iaton(i) = 1
         endif
      end do

      if (ipdbon.eq.1) then
         if (ialtyp.eq.1) then
            if (dozme) then
               call convar(coo,iconn,ianz,nscnd,iscst)
               call pmfass(1,0)
               call totpmf(dum(1))
               call upsco()
            endif
         else
            if (dozme) then
               if (idoprt.eq.0) call conpdb
               call chkbck
            endif
         endif
      else
         if ((.not.chemx.and.xmol.eq.0.and..not.(adfin.and.ihasg.eq.1))
     &        .or.(dozme.and..not.ichx.eq.1)) call doconn
      endif

      if (ipdbon.eq.0) then
         if (.not.ichx.eq.1) call dohcon(0)
      endif
c
c  get scale
c

      if (ioadd.eq.0) then
         if (doscl.eq.1.and..not.(icrtp.eq.3.and.ipoints.gt.1).and.
     &       .not.(ipdbon.eq.1.and.dozme)) then
            call doscal
            if (dozme.and.iatoms.lt.7) scali = 3.5d0
            scal = scali * 2.4d0 * smag
         endif
      endif

      if (favail) call parfc

      call drwgeo

      if (ctoz) call allzmt(ipdbon)
      if (.not.dozme) call upzme
      dozme = .false.


      if (icrtp.eq.2.and.ipoints.gt.1) then
          lstr = refcod
          call inferr(lstr,0)
cd         write(iun3,'(a)')'leave subroutine getpoi'
          return
      elseif (icrtp.eq.5.and.ipoints.gt.1) then
          call zerstr(ipnt,astr,3)
          lstr = 'point '//astr
          call inferr(lstr,0)
          return
      endif

      if (.not.(cpmd.or.gamess.or.gauss.or.(mopac.and..not.doconv)
     &    .or.(xmol.ge.1.and.ipoints.gt.1)).or.dozme) then
cd        write(iun3,'(a)')'leave subroutine getpoi'
         return
      endif

      if (ipoints.eq.0) then
         lstr = ' '
         if (.not.mopac) then
             lstr = 'Single point'
         endif
      elseif (ipnt.eq.1) then
         lstr = 'First point'
      elseif (ipnt.eq.ipoints) then
         lstr = 'Last point'
      else
         if (oxyz) then
            call zerstr(ipnt-1,astr,3)
         else
            call zerstr(ipnt,astr,3)
         endif
         lstr = 'point '//astr
      endif

      if (cpmd) lstr=lstr(1:22)//'CPMD output file'

      call inferr(lstr,0)

cd     write(iun3,'(a)')'leave subroutine getpoi'
      return
      end

      subroutine docond(coo,iconn,ianz)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)

      call convar(coo,iconn,ianz,iatoms,0)

      return
      end

      subroutine convar(coo,iconn,ianz,iatoms,ioff)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*),ctemp(3)

      adjus=0.52917706d0

      do i=ioff+1,ioff+iatoms
         k = 0
         iconn(1,i) = 0
         do j=ioff+1,ioff+iatoms
            dmaxsq = (vdwr(ianz(i))+vdwr(ianz(j)))/adjus
            dmaxsq = dmaxsq*dmaxsq
            dijsq = 0
            do l=1,3
               ctemp(l) = coo(l,i) - coo(l,j)
               dijsq = dijsq + ctemp(l)*ctemp(l)
            end do
            if (i.ne.j.and.ianz(i).ne.99.and.ianz(j).ne.99) then
              if (dijsq.lt.dmaxsq) then
                  k = k + 1
                  if (k.le.mxcon) then
                     iconn(1,i) = k
                     iconn(k+1,i) = j
                  else
                     write(iun3,*) 
     &                  'more than mxconn connections found'
                  endif
              endif
            endif
         end do
      end do

      return
      end

      subroutine dohcod(ihflag,coo,ianz,iconn,isurf)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (nacc=6)
      parameter (ndon=4)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /athlp/ iatoms, mxnat
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      logical isacc,isdon
      real angle,hamin,hamax
      dimension ctemp(3),isel(4)
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*),isurf(*)

      call domcon(1,1)

      if (.not.hon) return

      hdmin2 = hdmin*hdmin
      hdmax2 = hdmax*hdmax

c
c Hydrogen bonds
c
      do i=1,iatoms
         do j=i+1,iatoms
           if (ihflag.eq.0.or.
     &     (ihflag.gt.0.and.(isurf(i).eq.1.or.isurf(j).eq.1))) then
            iai = ianz(i)
            iaj = ianz(j)
            dijsq = 0
            do l=1,3
               ctemp(l) = coo(l,i) - coo(l,j)
               dijsq = dijsq + ctemp(l)*ctemp(l)
            end do
            if ((iai.eq.1.and.isacc(iaj)).or.
     &          (iaj.eq.1.and.isacc(iai))) then
               if (dijsq.gt.hdmin2.and.dijsq.lt.hdmax2) then
                  isel(1) = 0
                  if (iai.eq.1) then
                      if (iconn(1,i).gt.0) then
                         iai = ianz(iconn(2,i))
                         if (isdon(iai)) then
                            isel(1) = iconn(2,i)
                            isel(2) = i
                            isel(3) = j
                         endif
                      endif
                  else
                      if (iconn(1,j).gt.0) then
                         iaj = ianz(iconn(2,j))
                         if (isdon(iaj)) then
                            isel(1) = iconn(2,j)
                            isel(2) = j
                            isel(3) = i
                         endif
                      endif
                  endif
                  if (isel(1).ne.0) then
                    call intcor(intc,angle,isel,3)
                    if (intc.eq.1) then
                     if (abs(angle).gt.hamin.and.
     &                    abs(angle).lt.hamax) then
                         k = iconn(1,i)
                         if (k.lt.mxcon) then
                            iconn(1,i) = iconn(1,i) + 1
                            iconn(iconn(1,i)+1,i) = -j
                         else
                            write(iun3,*) 
     &                        'more than mxconn connections found'
                         endif
                         k = iconn(1,j)
                         if (k.lt.mxcon) then
                            iconn(1,j) = iconn(1,j) + 1
                            iconn(iconn(1,j)+1,j) = -i
                         else
                            write(iun3,*) 
     &                        'more than mxconn connections found'
                         endif
                     endif
                    endif
                  endif
               endif
            endif
           endif
         end do
      end do

      if (ihflag.eq.1) call clrsrf

      return
      end

      subroutine nohcod(iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension icn(mxcon+1),iconn(mxcon+1,*)

c
c Deactivate Hydrogen bonds
c
      do i=1,iatoms
          inn = 0
          do j=1,iconn(1,i)
             if (iconn(1+j,i).gt.0) then
                inn = inn + 1
                icn(inn) = iconn(1+j,i)
             endif
          end do  
          iconn(1,i) = inn
          do j=1,inn
             iconn(1+j,i) = icn(j)
          end do
      end do

      return
      end

      logical function isacc(iatnr)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (nacc=6)
      parameter (ndon=4)
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      real hamin,hamax

      isacc = .false.

      do i=1,nacc
          if (iatnr.eq.iacc(i)) isacc = .true.
      end do

      return
      end

      logical function isdon(iatnr)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (nacc=6)
      parameter (ndon=4)
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      real hamin,hamax

      isdon = .false.

      do i=1,ndon
          if (iatnr.eq.idon(i)) isdon = .true.
      end do

      return
      end

      subroutine doscad(coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /athlp/ iatoms, mxnat
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)
      common /pers/xv,yv,zv,c0,pincr,ssincr,xincr,yincr
      common /gracom/  uscl,colscd,colscpd,ivdwpl
      dimension coo(3,*)

      scali = 0.0d0
      do i=1,iatoms
         dist = 0.0d0
         do j=1,3
             dt = coo(j,i)-t(j)
             dist = dist + dt*dt
         end do
         if (dist.gt.scali) scali = dist
      end do
      scali = dsqrt(scali)
      scal = scali * 2.4d0 * smag

      if (scali.gt.15.0d0) then
         colscpd = 1.3d0
      else
         colscpd = .4d0
      endif

      colscd = 2.0d0

      zv = scali
      pincr = 0.02d0*scali

      return
      end

      subroutine redcod(iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension icnn(mxcon),iconn(mxcon+1,*)

      do j=1,iatoms
         ibnds = 0
         do i=1,iconn(1,j)
            ioke = 1
            do k=1,i-1
               if (iconn(k+1,j).eq.iconn(i+1,j)) ioke = 0
            end do
            if (ioke.eq.1.and.ibnds.lt.mxcon) then
               ibnds = ibnds + 1
               icnn(ibnds) = iconn(i+1,j)
            endif
         end do
         iconn(1,j) = ibnds
         do i=1,ibnds
            iconn(i+1,j) = icnn(i)
         end do
      end do

      return
      end

      subroutine domcod(ipt,idoall,iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (maxdm=20)
      parameter (numcal=5000)
      parameter (mxheta=50)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf,
     &                iams(numcal),ihets(mxheta)
      real rout
      dimension iconn(mxcon+1,*)


      if (idoall.eq.1) then
         ibeg = 1
         iend = ndm
      else
         ibeg = ipt
         iend = ipt
      endif

      do i=ibeg,iend
         call intcor(intc,rout,idmon(1,i),2)
         if (intc.eq.1) then
            rdm(i) = dble(rout)*0.52917706d0
            if (ifogl.ne.1) then
               i1 = idmon(1,i)
               i2 = idmon(2,i)
               k = iconn(1,i1)
               if (k.lt.mxcon) then
                  iconn(1,i1) = k + 1
                  iconn(k+2,i1) = -i2
               endif
               k = iconn(1,i2)
               if (k.lt.mxcon) then
                  iconn(1,i2) = k + 1
                  iconn(k+2,i2) = -i1
               endif
            endif
         endif
      end do

      if (ifogl.eq.1) call ogmon

      return
      end

      subroutine chkbck
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      integer fancy,shade,atcol,dolabs,persp
      logical fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon

      if (backb) then
         call actcal(1)
         call ribbs
         if (ihet(1).eq.1) call acthel(1,0,0,0)
         if (ihet(2).eq.1) call acthel(1,1,0,0)
         if (ihet(3).eq.1) call acthel(1,2,0,0)
         if (ihet(4).eq.1) call acthel(1,3,0,0)
         do i=5,mxheta
            j = -i+1
            if (ihet(i).eq.1) then
               call actami(j,0,1,0)
            endif
         end do
         do i=1,ncalf
            if (reson(i).eq.1) then
               call actami(i,0,1,0)
            endif
         end do
      endif

      return
      end

      subroutine rott(x,y,z,xc,yc,zc,itran)
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      if (itran.eq.1) then
         xc = (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)
         yc = (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)
         zc = (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)
      else
         xc = x*rx(1)+y*rx(2)+z*rx(3)
         yc = x*ry(1)+y*ry(2)+z*ry(3)
         zc = x*rz(1)+y*rz(2)+z*rz(3)
      endif

      return
      end

      subroutine rotts(x,y,z,xc,yc,zc,itran)
      implicit double precision (a-h,o-z)
      real x,y,z
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      if (itran.eq.1) then
         xc = (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)
         yc = (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)
         zc = (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)
      else
         xc = x*rx(1)+y*rx(2)+z*rx(3)
         yc = x*ry(1)+y*ry(2)+z*ry(3)
         zc = x*rz(1)+y*rz(2)+z*rz(3)
      endif

      return
      end

      subroutine mktrn(inct,incp)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /pers/  xv,yv,zv,c0,pincr,ssincr,xincr,yincr
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /coars/ icoars
      logical fyesno,backb
      integer dolabs,fancy,persp,shade,atcol
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension vec(3)

      celinc = 0.001d0*0.52917706d0

      if (irtcel.ne.0) then
         do i=1,3
            vec(i) = 0.0d0
         end do
      endif

      idir = 0
      if (inct.eq.290) then
         if (irtcel.ne.0) then
            idir = incp
            iax = 3
         else
            if (persp.eq.1) then
               if (incp.eq.1)  zv = zv + pincr
               if (incp.eq.-1) zv = zv - pincr
            else
               if (incp.eq.1)  smag = smag*ssincr
               if (incp.eq.-1) smag = smag/ssincr
               smag = max(smag,0.01d0)
               scal = scali*2.4d0*smag
            endif
         endif
      elseif (inct.eq.415) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 2
         else
            yv = yv + yincr*(5**icoars)*incp
         endif
      elseif (inct.eq.416) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 1
         else
            xv = xv + xincr*(5**icoars)*incp
         endif
      elseif (inct.eq.417) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 3
         else
            if (persp.eq.1) then
               zv = zv + pincr*incp
            else
               ssc = abs(incp)*ssincr
               if (incp.gt.0) smag = smag*ssc
               if (incp.lt.0) smag = smag/ssc
               smag = max(smag,0.01d0)
               smag = min(smag,1000.0d0)
               scal = scali*2.4d0*smag
            endif
         endif
      elseif (inct.eq.420) then
         if (irtcel.ne.0) then
            idir = -1
            iax = 2
         else
            yv = yv - yincr*(5**icoars)
         endif
      elseif (inct.eq.430) then
         if (irtcel.ne.0) then
            idir = 1
            iax = 2
         else
            yv = yv + yincr*(5**icoars)
         endif
      elseif (inct.eq.440) then
         if (irtcel.ne.0) then
            idir = -1
            iax = 1
         else
            xv = xv - xincr*(5**icoars)
         endif
      elseif (inct.eq.450) then
         if (irtcel.ne.0) then
            idir = 1
            iax = 1
         else
            xv = xv + xincr*(5**icoars)
         endif
      else 
         goto 100
      endif

      if (irtcel.ne.0) then
         if (itz.eq.1.and.iax.eq.3) then
            do i=1,3
               vec(i) =  idir*tz(i)*(10**icoars)
            end do
         else
            vec(iax) =  idir*celinc*(10**icoars)
            if ((inct.eq.415.or.inct.eq.416.or.inct.eq.417)
     &          .and.irtcel.eq.2) then
               do i=1,3
                  vec(i) =  celinc*(10**icoars)*incp*vecs(iax,i)
               end do
            endif
         endif
         if (irtcel.eq.1) then
            call cllrot(vec,0,ifd)
         else
            call alnrot(vec,0)
         endif
      endif

      goto 200

100   continue
      if (abs(incp).eq.1.or.abs(inct).eq.421.or.inct.eq.422) then
         if (abs(inct).eq.421) then
            theinc = -incp
            if (inct.eq.421) then
               inct = -3
            else
               inct = -2
            endif
         elseif(inct.eq.422) then
            theinc = -incp
            inct = -1
         else
            if (icoars.eq.2) then
               theinc = incp*rincr*45.0d0
            elseif (icoars.eq.1) then
               theinc = incp*rincr*5.0d0
            else
               theinc = incp*rincr
            endif
         endif

         if (irtcel.gt.0) then
            if (irtcel.eq.1) then
               call clmat(inct,theinc,1)
               call cllrot(vec,1,ifd)
            else
               if (ialtyp.eq.1) then
                  call clmat(inct,theinc,0)
               else
                  call clmat(inct,theinc,1)
               endif
               call alnrot(vec,1)
            endif
         else
            call xyzrot(inct,theinc)
         endif
      endif

200   if (irtcel.gt.1) then
         if (ialtyp.eq.1) then
            call totpmf(tpmf)
c            print*,'totpmf=',tpmf
            call upsco()
         endif
      endif

      return
      end

      subroutine mtinv3
      implicit double precision (a-h,o-z)
      dimension al(9),alt(9)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
   
      do i=1,3
         do j=1,3
            if (i.eq.j) then
               vecs(i,j) = 1.0d0
            else
               vecs(i,j) = 0.0d0
            endif
         end do
      end do

      do j=1,3
         al(j)   = rx(j)
         al(3+j) = ry(j)
         al(6+j) = rz(j)
         alt(j)   = rx(j)
         alt(3+j) = ry(j)
         alt(6+j) = rz(j)
      end do

      call matinv(al,3,det)

      do j=1,3
         rx(j) = al(j)
         ry(j) = al(3+j)
         rz(j) = al(6+j)
      end do

      call rott(vecs(1,1),vecs(1,2),vecs(1,3),xc,yc,zc,0)
      vecs(1,1) = xc
      vecs(1,2) = yc
      vecs(1,3) = zc
      call rott(vecs(2,1),vecs(2,2),vecs(2,3),xc,yc,zc,0)
      vecs(2,1) = xc
      vecs(2,2) = yc
      vecs(2,3) = zc
      call rott(vecs(3,1),vecs(3,2),vecs(3,3),xc,yc,zc,0)
      vecs(3,1) = xc
      vecs(3,2) = yc
      vecs(3,3) = zc

c restore original rotation

      do j=1,3
         rx(j) = alt(j)
         ry(j) = alt(3+j)
         rz(j) = alt(6+j)
      end do

      return
      end

      subroutine xyzrot(inct,theang)
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      todeg = 45.0d0 / datan(1.0d0)

      sa = dsin(theang/todeg)
      ca = dcos(theang/todeg)

      if (inct.eq.-3) then
         do i=1,3
            y = ry(i)
            z = rz(i)
            ry(i) = ca*y + sa*z
            rz(i) = ca*z - sa*y
         end do
      elseif (inct.eq.-2) then
         do i=1,3
            x = rx(i)
            z = rz(i)
            rx(i) = ca*x + sa*z
            rz(i) = ca*z - sa*x
         end do
      elseif (inct.eq.-1) then
         do i=1,3
            x = rx(i)
            y = ry(i)
            rx(i) = ca*x - sa*y
            ry(i) = ca*y + sa*x
         end do
      endif

      return
      end

      subroutine initr
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      do i=1,3
         t(i)  = 0.0d0
      end do

      return
      end

      subroutine inirot
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      do i=1,3
         rx(i) = 0.0d0
         ry(i) = 0.0d0
         rz(i) = 0.0d0
      end do

      rx(1) = 1.0d0
      ry(2) = 1.0d0
      rz(3) = 1.0d0

      return
      end

      subroutine setrot
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      do i=1,3
         rx(i) = 0.0d0
         ry(i) = 0.0d0
         rz(i) = 0.0d0
      end do

      rx(1) = 1.0d0
      ry(3) = 1.0d0
      rz(2) = -1.0d0

      return
      end

      subroutine setord(iatom,coo)
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)
      common /pers/xv,yv,zv,c0,pincr,ssincr,xincr,yincr
      logical fyesno,backb
      integer dolabs,fancy,persp,shade,atcol
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      dimension coo(3,*)

      if (irtcel.eq.2) then
         call alnsorg(iatom,coo)
      else
         do i=1,3
            t(i) = coo(i,iatom)
         end do
      endif

c      call doscal

      xv = 0.0d0
      yv = 0.0d0

      return
      end

      subroutine setxyv
      implicit double precision (a-h,o-z)
      common /pers/xv,yv,zv,c0,pincr,ssincr,xincr,yincr

      xv = 0.0d0
      yv = 0.0d0

      return
      end

      subroutine prtrot
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      print*,(rx(i),i=1,3)
      print*,(ry(i),i=1,3)
      print*,(rz(i),i=1,3)

      print*,(t(i),i=1,3)

      return
      end

      subroutine rarbxi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligx/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      todeg = 45.0d0 / datan(1.0d0)
      do i=1,3
         v(i) = vecs(1,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'matrix ry'
c      call prtmat(ry)
c      print*,'matrix rz'
c      call prtmat(rz)
c      print*,'matrix ryi'
c      call prtmat(ryi)
c      print*,'matrix rzi'
c      call prtmat(rzi)
c      return

      end

      subroutine rarbx(alfat)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligx/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do

c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v

      alfa = -alfat

      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine rarbyi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligy/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      do i=1,3
         v(i) = vecs(2,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'y matrix ry'
c      call prtmat(ry)
c      print*,'y matrix rz'
c      call prtmat(rz)
c      print*,'y matrix ryi'
c      call prtmat(ryi)
c      print*,'y matrix rzi'
c      call prtmat(rzi)

      return
      end

      subroutine rarby(alfa)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligy/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do


c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v

      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine matmult(a,b,c)
      implicit double precision (a-h,o-z)
      dimension a(3,3),b(3,3),c(3,3)

      do i=1,3
         do j=1,3
            c(i,j)=0.0d0
            do k=1,3
               c(i,j) = c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do

      return
      end

      subroutine rarbzi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligz/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      todeg = 45.0d0 / datan(1.0d0)
      do i=1,3
         v(i) = vecs(3,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'matrix ry'
c      call prtmat(ry)
c      print*,'matrix rz'
c      call prtmat(rz)
c      print*,'matrix ryi'
c      call prtmat(ryi)
c      print*,'matrix rzi'
c      call prtmat(rzi)
c      return

      end

      subroutine rarbz(alfa)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligz/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do

c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v


      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine prtmat(a)
      implicit double precision (a-h,o-z)
      dimension a(3,3)

      do i=1,3
         write(6,'(3f12.4)') (a(i,j),j=1,3)
      end do

      return
      end

      subroutine rdpdd(istat,coo,ianz)
      implicit double precision (a-h,o-z)

      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxel=100)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      common /athlp/ iatoms, mxnat
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      character lstr*137
      character*2 tstr,tocapf
      dimension coo(3,*),ianz(*)

      ihashb = 0

      rewind iun2
      istat = 1
      
10    call searchd(lstr,'ATOM','HETATM',istat)
      if (istat.eq.0) then
           call inferr('no ATOM/HETATM found !',0)
           goto 100
      endif
      if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 10
      backspace iun2

      iatoms = 0
      do while (.true.)
15        read(iun2,'(a)',end=20) lstr
          if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 15
          if (iatoms.ge.mxnat) then
               call inferr('exceeded maximum atoms !',1)
               goto 100
          endif
          iatoms = iatoms + 1
          ianz(iatoms) = 0
          read(lstr,'(12x,a2,16x,3f8.3)') tstr,
     &        coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
          it = ichar(tstr(1:1))
          if (.not.(it.ge.65.and.it.le.90).and..not.
     &             (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
          do j=1,99
             if (tstr.eq.tocapf(elemnt(j))) ianz(iatoms) = j
          end do
          if (ianz(iatoms).eq.0.and.tstr(1:1).ne.' ') then
             tstr(1:1) = ' '
             do j=1,99
                if (tstr.eq.tocapf(elemnt(j))) ianz(iatoms) = j
             end do
          endif
          if (ianz(iatoms).le.0) then
             if (tstr(2:2).eq.'D') then
                ianz(iatoms) = 1
             else
                write(iun3,*) 'Unclassified atom =',tstr
                write(iun3,*) lstr
                ianz(iatoms) = 99
             endif
          endif
      end do

20    continue

      return
100   istat = 0
      return
      end

      subroutine pdbsdd(istat,doscnd,ioadd,
     &                  coo,ianz,iaton,iresid,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=701)
      parameter (mxgff=71)
      parameter (mxamo=201)
      integer*2 ityp
      character*3 chtnk,pdbsym,hsym,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      common /athlp/ iatoms, mxnat
      common /surf/ natorg,nosncd

      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxmmul=100)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      logical isatm,ishet,hasalt,doscnd,skip,dall
      character*3 aminos
      common /amino/ aminos(mxres)
      common /multim/imulm, nmulm,ihasqm(mxmmul)

      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*2 tocapf,hetred
      character*4 tstr
      character*3 resi
      character*1 restmp,resa,altloc,aloc,ach
      dimension ipdb(mxsym),hetred(4),
     &          ihpdb(mxhsym*3),tmp(3),isc(numcal)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),
     &          ityp(*)

      data hetred/
     &   'AC','AN','AO','AP'/

      imulm = 1
      if (ioadd.eq.0) then
         call parsfn('Helix',5,1)
         call parsfn('Beta',4,1)
         call parsfn('RNA/DNA',7,1)
         call parsfn('Coil',4,1)
      endif

      ihashb = 0


      ioatms = 0
      if (ioadd.eq.1) then
         natorg = iatoms
         do i=ncalf+1,numcal
             isal(i) = 3
             isc(i) = 3
         end do
         noff = ncalf
         ioatms = iatoms
      else
         do i=1,numcal
             isal(i) = 3
             isc(i) = 3
         end do
         noff = 0
      endif

      if (.not.doscnd) goto 5

c
c     Proces Helix/Sheet information
c
      rewind iun2

      do while (.true.)
          call searchd(lstr,'HELIX','SHEET',istat)
          if (istat.eq.0) goto 5
          if (index(lstr,'HELIX').eq.1) then
             read(lstr,'(21x,i4,8x,i4)',err=4,end=4) i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                do i=i1,i2
                   isc(noff+i) = 0
                end do
             endif
          elseif (index(lstr,'SHEET').eq.1) then
             read(lstr,'(22x,i4,7x,i4)',err=4,end=4) i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                do i=i1,i2
                   isc(noff+i) = 1
                end do
             endif
          endif
      end do
4     call inferr('Error reading HELIX/SHEET record !',0)
5     continue

      rewind iun2
      istat = 1
      hasalt = .false.
      dall = .false.
      
10    call searchd(lstr,'HETATM','ATOM',istat)
      if (istat.eq.0) then
           call inferr('no ATOM/HETATM record found !',0)
           rewind iun2
           goto 210
      endif

      if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 10
      backspace iun2

      if (ioadd.eq.1) then
         call numhet(nhmol)
         nmulm = nhmol - 3
         nmulmt = nmulm
         icres = ncalf
         ianf(nchain+1) = 1
         islu(nchain+1) = 0
      else
         nhmol = 3
         iatoms = 0
         icres = 0
         nchain = 1
         ianf(1) = 1
         islu(1) = 0
         nmulm = 0
      endif

      jres = -1
      irtmp = -10000
      ipdb(38) = 0
      restmp = ' '
      ihashy = 0
      skip = .false.
      aloc = ' '

      do while (.true.)
15        read(iun2,'(a)',end=20) lstr
          isatm = (lstr(1:4).eq.'ATOM'.or.lstr(1:6).eq.'HETATM')
          if (lstr(1:6).eq.'ENDMDL') goto 20
          if (.not.isatm) goto 15
c
c found atom
c
          read(lstr,'(12x,a4,a1,a3,1x,a1,i4,a1,3x,3f8.3)') tstr,altloc,
     &       resi,ach,iresnr,resa,(tmp(l),l=1,3)
           
          jrest = 0
          if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)
          do j=1,mxres
             if (resi.eq.aminos(j)) jrest = j
          end do
          if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
             jrest = 17
             resi = 'HIS'
          endif
          if (jrest.eq.0) goto 15

          do i=1,4
             if (ichar(tstr(i:i)).eq.39) tstr(i:i) = '*'
          end do

          if (tstr(2:4).eq.'OT ') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'OCT') tstr(2:4) = 'OXT'
          if (iresnr.ne.irtmp.or.restmp.ne.resa) then
c
c next amino acid
c
             if (iatoms.gt.mxnat-30) goto 20
             if (skip) then
                skip = .false.
             else
c                if (icres.gt.0.and.jres.ne.0) then
                if (icres.gt.0.and.jres.gt.0) then
                   call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
                   call pdbtyp(ipdb,ihpdb,jres,1)
                endif
                if (jres.ne.0) icres  = icres + 1
                if (restmp.ne.resa) skip = .true. 
             endif
             if (icres.gt.0.and.icres.le.numcal) then
                iamino(icres) = jrest
                irsnr(icres) = iresnr
                achain(icres) = ach
                if (ihashb.eq.1.and.iresnr.gt.0.and.iresnr.le.numcal) 
     &              isal(icres) = isc(iresnr)
             endif
             irtmp = iresnr
             restmp = resa
             jres = jrest
             do j=1,mxsym
                ipdb(j) = 0
             end do
             do j=1,mxhsym*3
                ihpdb(j) = 0
             end do
             ihashy = 0
             if (skip) goto 15
          else
             if (skip) goto 15
          endif

          if (iatoms.ge.mxnat-1000) then
             dall = .true.
             goto 100
          endif

          iatoms = iatoms + 1
          ianz(iatoms) = 0
          iconn(1,iatoms) = 0
          iresid(iatoms) = icres

          do l=1,3
             coo(l,iatoms) = tmp(l)
          end do

c determine ianz, see if hydrogen atom

          call detanz(resi,tstr,lstr,ifnd,ish,ianz(iatoms),ihashy)

          ihstyp = 0
          if (ish.eq.1) then
            do j=1,mxhsym
               if (tstr(2:4).eq.hsym(j)) then
                  ihstyp = 1
                  if (ihpdb((j-1)*3+1).eq.0) then
                     aloc = altloc
                  elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif
                  do l=1,3
                     if (ihpdb((j-1)*3+l).eq.0) then
                        ihpdb((j-1)*3+l) = iatoms
                        goto 1000
                     endif
                  end do
1000              continue
               endif
            end do
          else
            do j=1,mxsym
               if (tstr(2:4).eq.pdbsym(j)) then
                  ihstyp = 1
c
c Allow only the first of alternate locations
c
                  if (ipdb(j).eq.0) then
                     ipdb(j) = iatoms
                  else
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif
               endif
            end do
          endif
          if (ihstyp.eq.0) then
              nhmol = nhmol + 1
              iresid(iatoms) = -nhmol
              irtmp = -10000
              resi = 'UNK'
              call parsfn(resi,3,1)
          endif
          iaton(iatoms)  = 1
      end do


20    continue

c round up last amino acid

      
      if (jres.gt.0) then
         call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
         call pdbtyp(ipdb,ihpdb,jres,1)
      endif
      islu(nchain) = icres
      ncalf = icres
      namatm = iatoms
c
c do hetatm
c
      ishoh = 0
      irtmp = -10000

      rewind iun2
210   call searchd(lstr,'HETATM','ATOM',istat)
      if (istat.eq.0) goto 220
      if (lstr(1:6).ne.'HETATM'.and.lstr(1:4).ne.'ATOM') goto 210
      backspace iun2

      do while (.true.)
215        read(iun2,'(a)',end=220) lstr
           ishet = (lstr(1:6).eq.'HETATM')
           isatm = (lstr(1:4).eq.'ATOM')
           if (lstr(1:3).eq.'TER') irtmp = -10000
           if (lstr(1:6).eq.'ENDMDL') goto 220
           resi = lstr(18:20)
           if (ishet.or.isatm) then
              jrest = 0
              ishet = .false.
              if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)
              do j=1,mxres
                 if (resi.eq.aminos(j)) jrest = j
              end do
              if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
                 jrest = 17
                 resi = 'HIS'
              endif
              if (jrest.eq.0) ishet = .true.
           endif
           if (.not.ishet) goto 215

           if (iatoms.ge.mxnat-1000) then
               dall = .true.
               goto 100
           endif

           iatoms = iatoms + 1
           ianz(iatoms) = 0
           read(lstr,'(12x,a4,a1,a3,2x,i4,4x,3f8.3)') tstr,altloc,
     &        resi,iresnr, coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
           
           if (altloc.ne.' '.and.altloc.ne.'A'.and.altloc.ne.'a'.and.
     &         altloc.ne.'1') then
              iatoms = iatoms - 1
              hasalt = .true.
              goto 215
           endif

           if (resi.eq.'HEM') then
              if (tstr(1:2).eq.'HA'.or.tstr(1:2).eq.'HB'.or.
     &            tstr(1:2).eq.'HM') tstr(1:4) = ' H  '
              if (tstr(2:3).eq.'FE') tstr(1:3) = 'FE '
           endif

           if (resi.eq.'NDP') then
              if (tstr(1:2).eq.'NP') tstr(1:4) = ' P  '
           endif

           do j=1,4
              if (tocapf(tstr(1:2)).eq.hetred(j)) then
                  tstr(1:1) = ' '
              endif
           end do

           it = ichar(tstr(1:1))
           if (.not.(it.ge.65.and.it.le.90).and..not.
     &        (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
           it2 = ichar(tstr(2:2))
           if (.not.(it2.ge.65.and.it2.le.90).and..not.
     &        (it2.ge.97.and.it2.le.122)) tstr(2:2) = ' '
           if (tstr(2:2).eq.' '.and.tstr(1:1).ne.' ') then
              tstr(2:2) = tstr(1:1)
              tstr(1:1) = ' '
           endif 

           do j=1,99
             if (tstr(1:2).eq.tocapf(elemnt(j))) ianz(iatoms) = j
           end do
           if (ianz(iatoms).eq.0.and.tstr(1:1).ne.' ') then
              tstr(1:1) = ' '
              do j=1,99
                  if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &               ianz(iatoms) = j
              end do
           endif
           if (ianz(iatoms).le.0) then
              write(iun3,*) 'Unclassified atom =',tstr
              write(iun3,*) lstr
              ianz(iatoms) = 99
           endif
           iconn(1,iatoms) = 0
           iaton(iatoms)  = 0
           if (iresnr.ne.irtmp) then
              irtmp = iresnr
              if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
                  if (ishoh.eq.0) then
                     nhmol = nhmol + 1
                     if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                     call parsfn(resi,3,1)
                     ishoh = nhmol
                  endif  
              else
                  nhmol = nhmol + 1
                  if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                  call parsfn(resi,3,1)
              endif
           endif
           if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
              iresid(iatoms) = -ishoh
           else
              iresid(iatoms) = -nhmol
           endif
      end do
220   continue
c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         do j=ioatms+1,namatm + ii - 1
            call connij(idum,i,j,0)
         end do
      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idum,ii,jj,0)
                     if (idum.eq.1) then
                        ityp(ii) = 82
                        ityp(jj) = 82
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      do i=1,ncalf
         if (iamino(i).eq.21) iamino(i) = 10
         if (iamino(i).eq.22) iamino(i) = 14
      end do
      if (islu(1).lt.ianf(1)) nchain = 0

      if (ioadd.eq.1) then
         do i=nmulmt,nmulm
            ihasqm(i) = 0
         end do
         if (nmulmt.eq.0) nmulmt = 1
         do i=nmulmt+4,nhmol+1
            ihet(i) = 1
         end do
      endif

      if (hasalt) call inferr('Alternate location(s) detected',0)
      return

100   istat = 0
      if (dall) then
         iatoms = natorg
         ncalf = noff
         istat = -1
      else
         if (islu(1).lt.ianf(1)) nchain = 0
      endif
      if (hasalt) call inferr('Alternate location(s) detected',0)
      return
      end

      subroutine conpdd(ianz,iconn,iresid)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      common /athlp/ iatoms, mxnat
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension iconn(mxcon+1,*),ianz(*),iresid(*)

      namatm = 0

      do i=1,iatoms
         iconn(1,i) = 0
         if (iresid(i).le.0.and.namatm.eq.0) namatm = i-1
      end do

      if (namatm.eq.0) namatm = iatoms

      do i=1,ncalf
         call getpdb(i,ipdb,ihpdb)
         call mkcon(ipdb,iamino(i),i,ihpdb,1,1)
      end do

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm

      do ii=1,nhet

         i = namatm + ii
         ir1 = iresid(i)

         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (.not.(ir1.gt.0.and.ir2.gt.0)) then
               call connij(idum,i,j,1)
            endif
         end do

      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idcon,ii,jj,1)
                     if (idcon.eq.1) then
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      return
      end

      subroutine convpdd(ianz,iconn,iresid)
c same as conpdb, only before conversion to angstrom
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      common /athlp/ iatoms, mxnat
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      common /cllab/ iclon,iclpnt(4)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension iconn(mxcon+1,*),ianz(*),iresid(*)

      namatm = 0
      do i=1,iatoms
         iconn(1,i) = 0
         if (iresid(i).le.0.and.namatm.eq.0) namatm = i-1
      end do
      if (namatm.eq.0) namatm = iatoms

      do i=1,ncalf
         call getpdb(i,ipdb,ihpdb)
         call mkcon(ipdb,iamino(i),i,ihpdb,1,1)
      end do

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         ir1 = iresid(i)
         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (ir1.eq.ir2.and..not.(ir1.gt.0.and.ir2.gt.0)) then
               call connij(idum,i,j,0)
            endif
         end do
      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idcon,ii,jj,0)
                     if (idcon.eq.1) then
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      return
      end

      subroutine consld(iconn,iresid)
c same as conpdb, only before conversion to angstrom, non residue
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (numcal=5000)
      common /athlp/ iatoms, mxnat
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      dimension iconn(mxcon+1,*),iresid(*)

      namatm = 0
      do i=1,iatoms
         if (iresid(i).lt.-3) then
            iconn(1,i) = 0
         endif
         if (iresid(i).lt.-3.and.namatm.eq.0) namatm = i-1
      end do
      if (namatm.eq.0) namatm = iatoms

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         ir1 = iresid(i)
         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (ir1.eq.ir2) then
               call connij(idcon,i,j,0)
            endif
         end do
      end do

      return
      end
c
      subroutine connid(idcon,i,j,idoconv,iconn,ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      logical coni,conj
      dimension ctemp(3),iconn(mxcon+1,*),ianz(*),coo(3,*)

      toang = 0.52917706d0
      toang2 = toang*toang

      idcon = 0
      coni = .true.
      conj = .true.

      k = iconn(1,i)
      m = iconn(1,j)

      do l=1,k
         if (iconn(1+l,i).eq.j) coni = .false.
      end do

      do l=1,m
         if (iconn(1+l,j).eq.i) conj = .false.
      end do

      if (.not.coni.and..not.conj) return

      dmaxsq = vdwr(ianz(i)) + vdwr(ianz(j))
      dmaxsq = dmaxsq * dmaxsq

      do l=1,3
         ctemp(l) = coo(l,i) - coo(l,j)
      end do

      dijsq = ctemp(1)*ctemp(1) + ctemp(2)*ctemp(2) 
     &             + ctemp(3)*ctemp(3)

      if (idoconv.eq.1) dmaxsq = dmaxsq / toang2
      if (dijsq.lt.dmaxsq) then
          idocon = 1
          k = k + 1
          m = m + 1
          if (k.le.mxcon.and.coni) then
             iconn(1,i) = k
             iconn(k+1,i) = j
          else
             write(iun3,*)'more than mxconn connections found'
          endif
          if (m.le.mxcon.and.conj) then
             iconn(1,j) = m
             iconn(m+1,j) = i
          else
             write(iun3,*)'more than mxconn connections found'
          endif
      endif

      return
      end

      subroutine mkcon(ipdb,jres,icres,ihpdb,ihashy,idoconv)
      implicit double precision (a-h,o-z)
      dimension ipdb(*), ihpdb(*)

      if (jres.gt.23) then
         call mknbck(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      else
         call mkback(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      endif
          
      goto (10,10,30,40,50,60,70,80,90,100,110,120,130,140,150,
     &      160,170,180,190,200,100,140,150,210,220,230,240,250,
     &      210,220,220,230,230,230,230,230,230,230,250,250,250,
     &      250) jres
      return
c
c glycine, alanine
c
10    goto 1000
c
c serine
c
30    call conat(ipdb,5,31,0)
      if (ihashy.eq.1) call conath(ipdb,ihpdb,31,10)
      goto 1000
c
c cysteine
c
40    call conat(ipdb,5,37,0)
c this H is dubious
      if (ihashy.eq.1) call conath(ipdb,ihpdb,37,10)
      goto 1000
c
c threonine
c
50    call conat(ipdb,5,32,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,32,10)
          call conath(ipdb,ihpdb,32,13)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c isoleucine
c
60    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      call conat(ipdb,7,10,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
          call conath(ipdb,ihpdb,10,22)
          call conath(ipdb,ihpdb,10,23)
          call conath(ipdb,ihpdb,10,24)
      endif
      goto 1000
c
c valine
c
70    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,7,15)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c methionine
c
80    call conat(ipdb,5,6,0)
      call conat(ipdb,6,36,0)
      call conat(ipdb,36,12,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,6,10)
          call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
          call conath(ipdb,ihpdb,6,13)
          call conath(ipdb,ihpdb,6,16)
          call conath(ipdb,ihpdb,12,28)
          call conath(ipdb,ihpdb,12,29)
          call conath(ipdb,ihpdb,12,30)
          call conath(ipdb,ihpdb,12,31)
          call conath(ipdb,ihpdb,12,34)
          call conath(ipdb,ihpdb,12,37)
      endif
      goto 1000
c
c aspartic acid
c
90    call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,30,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,29,22)
         call conath(ipdb,ihpdb,30,25)
      endif
      goto 1000
c
c asparagine
c
100   call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,21,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,21,25)
         call conath(ipdb,ihpdb,21,26)
      endif
      goto 1000
c
c leucine
c
110   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,10,23)
         call conath(ipdb,ihpdb,10,24)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,11,26)
         call conath(ipdb,ihpdb,11,27)
      endif
      goto 1000
c
c lysine
c
120   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,12,0)
      call conat(ipdb,12,27,0)
      if (ihashy.eq.1) then

         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)

         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)

         call conath(ipdb,ihpdb,12,28)
         call conath(ipdb,ihpdb,12,29)
c        try HE1 and HE2 too
         call conath(ipdb,ihpdb,12,31)
         call conath(ipdb,ihpdb,12,34)

         call conath(ipdb,ihpdb,27,40)
         call conath(ipdb,ihpdb,27,41)
         call conath(ipdb,ihpdb,27,42)
         call conath(ipdb,ihpdb,27,43)
         call conath(ipdb,ihpdb,27,46)
         call conath(ipdb,ihpdb,27,49)
      endif
      goto 1000
c
c glutamic acid
c
130   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,35,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,34,31)
         call conath(ipdb,ihpdb,35,34)
      endif
      goto 1000
c
c glutamine
c
140   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,24,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,24,34)
         call conath(ipdb,ihpdb,24,35)
      endif
      goto 1000
c
c proline
c 
150   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
c     bit tricky here
      call conat(ipdb,9,1,1)
      if (ipdb(28).ne.0) call conat(ipdb,6,28,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
      endif
      goto 1000
c
c arginine
c
160   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,22,0)
      call conat(ipdb,22,17,0)
      call conat(ipdb,17,25,0)
      call conat(ipdb,17,26,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
         call conath(ipdb,ihpdb,22,28)
         call conath(ipdb,ihpdb,25,55)
         call conath(ipdb,ihpdb,25,56)
         call conath(ipdb,ihpdb,26,58)
         call conath(ipdb,ihpdb,26,59)
      endif
      goto 1000
c
c histidine
c
170   call conat(ipdb,5,6,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,6,20,0)
      call conat(ipdb,11,24,0)
      call conat(ipdb,20,13,0)
c tricky
      call conat(ipdb,13,24,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,20,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,24,34)
      endif
      goto 1000
c
c phenylalanine
c
180   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,17,40)
      endif
      goto 1000
c
c tyrosine
c
190   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      call conat(ipdb,17,33,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,33,52)
      endif
      goto 1000
c
c tryptophan
c
200   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,23,0)
      call conat(ipdb,23,14,0)
      call conat(ipdb,14,11,1)
      call conat(ipdb,11,15,0)
      call conat(ipdb,14,18,0)
      call conat(ipdb,15,19,0)
      call conat(ipdb,18,16,0)
      call conat(ipdb,16,19,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,23,31)
         call conath(ipdb,ihpdb,15,37)
         call conath(ipdb,ihpdb,18,46)
         call conath(ipdb,ihpdb,19,49)
         call conath(ipdb,ihpdb,16,58)
      endif
      goto 1000
c
c adenosine
c
210   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,64,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.29) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,55,82)
         call conath(ipdb,ihpdb,59,112)
         call conath(ipdb,ihpdb,64,106)
         call flagh(ihpdb,106)
         call conath(ipdb,ihpdb,64,109)
         call flagh(ihpdb,109)
         call conath(ipdb,ihpdb,64,136)
         call flagh(ihpdb,136)
         call conath(ipdb,ihpdb,64,137)
         call flagh(ihpdb,137)
         call conath(ipdb,ihpdb,64,103)
         call flagh(ihpdb,103)
         call conath(ipdb,ihpdb,64,104)
         call flagh(ihpdb,104)
         if (jres.eq.29) then
             call conath(ipdb,ihpdb,79,148)
             call conath(ipdb,ihpdb,79,149)
             call conath(ipdb,ihpdb,79,150)
             call conath(ipdb,ihpdb,58,103)
         endif
      endif
      goto 1000
c
c cytidine
c
220   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,63,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.30) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,63,94)
         call flagh(ihpdb,94)
         call conath(ipdb,ihpdb,63,97)
         call flagh(ihpdb,97)
         call conath(ipdb,ihpdb,63,130)
         call flagh(ihpdb,130)
         call conath(ipdb,ihpdb,63,131)
         call flagh(ihpdb,131)
         call conath(ipdb,ihpdb,58,103)
         if (jres.eq.30) then
             call conath(ipdb,ihpdb,83,160)
             call conath(ipdb,ihpdb,83,161)
             call conath(ipdb,ihpdb,83,162)
         else
             call conath(ipdb,ihpdb,57,100)
         endif
      endif
      goto 1000
c
c guanosine
c
230   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,69,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      if (jres.ne.38) call conat(ipdb,55,61,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.32) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (jres.eq.33.or.jres.eq.34) then
          call conat(ipdb,61,73,0)
          call conat(ipdb,61,80,0)
      endif
      if (jres.eq.34) then
          call conat(ipdb,61,74,0)
          call conat(ipdb,61,79,0)
      endif
      if (jres.eq.35) then
          call conat(ipdb,65,75,0)
          call conat(ipdb,65,85,0)
      endif
      if (jres.eq.37) then
          call conat(ipdb,61,90,0)
          call conat(ipdb,62,88,0)
          call conat(ipdb,90,89,0)
          call conat(ipdb,90,91,0)
          call conat(ipdb,91,60,1)
          call conat(ipdb,91,92,0)
          call conat(ipdb,92,93,0)
          call conat(ipdb,93,94,0)
          call conat(ipdb,94,95,0)
          call conat(ipdb,95,96,0)
          call conat(ipdb,95,97,0)
          call conat(ipdb,97,98,0)
          call conat(ipdb,94,99,0)
          call conat(ipdb,99,100,0)
          call conat(ipdb,100,101,0)
          call conat(ipdb,100,102,0)
          call conat(ipdb,102,103,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,59,112)
         if (jres.ne.32.and.jres.ne.37) then
            call conath(ipdb,ihpdb,60,79)
            call flagh(ihpdb,79)
            call conath(ipdb,ihpdb,60,121)
            call flagh(ihpdb,121)
         endif
         if (jres.ne.33.and.jres.ne.34.and.jres.ne.37
     &       .and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,85)
            call flagh(ihpdb,85)
            call conath(ipdb,ihpdb,61,125)
            call flagh(ihpdb,125)
            call conath(ipdb,ihpdb,61,82)
            call flagh(ihpdb,82)
            call conath(ipdb,ihpdb,61,83)
            call flagh(ihpdb,83)
         endif
         if (jres.ne.34.and.jres.ne.37.and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,88)
            call flagh(ihpdb,88)
            call conath(ipdb,ihpdb,61,124)
            call flagh(ihpdb,124)
         endif
         if (jres.eq.33.or.jres.eq.34) then
            call conath(ipdb,ihpdb,80,151)
            call conath(ipdb,ihpdb,80,152)
            call conath(ipdb,ihpdb,80,153)
         endif
         if (jres.eq.31.or.jres.eq.34) then
            call conath(ipdb,ihpdb,79,148)
            call conath(ipdb,ihpdb,79,149)
            call conath(ipdb,ihpdb,79,150)
         endif
         if (jres.eq.35) then
            call conath(ipdb,ihpdb,85,166)
            call conath(ipdb,ihpdb,85,167)
            call conath(ipdb,ihpdb,85,168)
            call conath(ipdb,ihpdb,59,113)
         endif
         if (jres.eq.37) then
            call conath(ipdb,ihpdb,88,91)
            call conath(ipdb,ihpdb,88,92)
            call conath(ipdb,ihpdb,88,93)
            call conath(ipdb,ihpdb,89,175)
            call conath(ipdb,ihpdb,89,176)
            call conath(ipdb,ihpdb,89,177)
            call conath(ipdb,ihpdb,92,178)
            call conath(ipdb,ihpdb,92,179)
            call conath(ipdb,ihpdb,93,181)
            call conath(ipdb,ihpdb,93,182)
            call conath(ipdb,ihpdb,94,184)
            call conath(ipdb,ihpdb,98,187)
            call conath(ipdb,ihpdb,98,188)
            call conath(ipdb,ihpdb,98,189)
            call conath(ipdb,ihpdb,99,124)
            call conath(ipdb,ihpdb,103,190)
            call conath(ipdb,ihpdb,103,191)
            call conath(ipdb,ihpdb,103,192)
         endif
      endif
      goto 1000
c
c thymidine
c
240   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      call conat(ipdb,57,70,1)
      call conat(ipdb,57,83,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         call conath(ipdb,ihpdb,83,160)
         call conath(ipdb,ihpdb,83,161)
         call conath(ipdb,ihpdb,83,162)
         call conath(ipdb,ihpdb,70,160)
         call conath(ipdb,ihpdb,70,161)
         call conath(ipdb,ihpdb,70,162)
      endif
      goto 1000
c
c uridine
c
250   if (jres.eq.42) then
         call conat(ipdb,54,57,0)
      else
         call conat(ipdb,54,60,0)
      endif
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,1)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.41) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         if (jres.ne.41.and.jres.ne.42) call conath(ipdb,ihpdb,57,100)
         if (jres.eq.40) then
            call conath(ipdb,ihpdb,58,104)
            call conath(ipdb,ihpdb,57,101)
         endif
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         if (jres.eq.41) then
            call conath(ipdb,ihpdb,83,160)
            call conath(ipdb,ihpdb,83,161)
            call conath(ipdb,ihpdb,83,162)
         endif
         if (jres.eq.42) call conath(ipdb,ihpdb,60,121)
      endif

1000  continue

      return
      end

      subroutine pdbtyd(ipdb,ihpdb,jres,ihashy,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      integer*2 ipdbt
      dimension ipdb(mxsym), ihpdb(mxhsym*3), ipdbt(*)

      do i=1,mxsym
         it = i
         if (i.eq.70) it = 83
         if (i.eq.71) it = 79
         if (i.eq.72) it = 83
         if (i.eq.73) it = 80
         if (i.eq.74) it = 79
         if (i.eq.75) it = 85
         if (jres.gt.23.and.i.eq.38) it = 76
         if (ipdb(i).gt.0) ipdbt(ipdb(i)) = it
      end do

      if (ihashy.eq.1) then
         do i=1,mxhsym*3
            it = i
            if (i.eq.85) it = 124
            if (i.eq.88) it = 125
            if (i.eq.94) it = 130
            if (i.eq.97) it = 131
            if (i.eq.106) it = 136
            if (i.eq.109) it = 137
            if (ihpdb(i).gt.0) ipdbt(ihpdb(i)) = it
         end do
      endif

      return
      end

      subroutine typeid(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxrss=20)
      parameter (mxatt=10)
      parameter (mxath=8)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical nterm
      integer*2 ityp
      common /types/ iff
      common /chmtyp/ ncc(mxrss),icc(2,mxatt,mxrss),
     &                nhh(mxrss),ihh(2,mxath,mxrss)
      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 2

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20)

c     Backbone, no N-Term, C-Term yet
c               (Pro,Gly N-Term) CYS, sulfur bridged

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
      end do

      if (jres.le.0.or.jres.gt.mxrss) return

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      call settyp(ityp,ipdb(1),63)
      call settyp(ityp,ipdb(2),23)
      call settyp(ityp,ipdb(3),20)
      call settyp(ityp,ipdb(4),74)

      if (ipdb(38).ne.0) then
          ityp(ipdb(38)) = 79
          call settyp(ityp,ipdb(4),79)
          call settyp(ityp,ipdb(3),22)
      endif

      do i=1,ncc(jres)
         call settyp(ityp,ipdb(icc(1,i,jres)),icc(2,i,jres))
      end do

      if (jres.eq.4) then
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          call settyp(ityp,ipdb(37),82)
         end do
      endif

      if (jres.eq.17) then
         if (ihis.eq.2) then
             call settyp(ityp,ipdb(6),43)
             call settyp(ityp,ipdb(11),44)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),69)
             call settyp(ityp,ipdb(24),68)
         endif
         if (ihis.eq.3) then
             call settyp(ityp,ipdb(6),44)
             call settyp(ityp,ipdb(11),43)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),68)
             call settyp(ityp,ipdb(24),69)
         endif
      endif
      
      if (ihashy.eq.1) then

         n = 0
         do i=1,3
            if (ihpdb(i).ne.0) n = n + 1
         end do
         nterm = .false.
         if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.

         if (nterm) then
c H
            nt = 6
            if (jres.eq.15) nt = 7
            do i=1,n
               call settyp(ityp,ihpdb(i),nt)
            end do

c N
            nt = 65
            if (jres.eq.15.and.n.eq.2) nt = 67
            call settyp(ityp,ipdb(1),nt)

c CA
            nt = 23
            if (jres.eq.1) nt = 29
            if (jres.eq.15) nt = 33
            call settyp(ityp,ipdb(2),nt)

c CD
            if (jres.eq.15) call settyp(ityp,ipdb(9),34)

         else
            call settyp(ityp,ihpdb(1),3)
         endif
c HA
         nt = 4
         if (nterm.and.jres.ne.1) nt = 5
         call settyp(ityp,ihpdb(4),nt)
         call settyp(ityp,ihpdb(5),nt)

c HB, HG
         do i=1,3
            call settyp(ityp,ihpdb(6+i),1)
            call settyp(ityp,ihpdb(9+i),1)
         end do

         do i=1,nhh(jres)
            call settyp(ityp,ihpdb(ihh(1,i,jres)),ihh(2,i,jres))
         end do

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

         if (jres.eq.12) then
            call settyp(ityp,ihpdb(43),6)
            call settyp(ityp,ihpdb(46),6)
            call settyp(ityp,ihpdb(49),6)
         endif

         if (jres.eq.17) then
            if (ihis.eq.2) then
                call settyp(ityp,ihpdb(22),11)
                call settyp(ityp,ihpdb(25),14)
                call settyp(ityp,ihpdb(31),12)
            endif
            if (ihis.eq.3) then
                call settyp(ityp,ihpdb(25),15)
                call settyp(ityp,ihpdb(31),12)
                call settyp(ityp,ihpdb(34),11)
            endif
         endif
      endif

      return
      end

      subroutine typamd(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxrss=20)
      parameter (mxrsa=23)
      parameter (mxata=9)
      parameter (mxatha=9)
      parameter (mxrso=24)
      parameter (mxato=10)
      parameter (mxatho=11)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=701)
      parameter (mxambc=49)
      logical nterm,cterm
      integer*2 ityp
      common /types/ iff
      common /athlp/ iatoms, mxnat
      integer amboff,ntca,ctca
      common /ambtyp/ amboff(mxrss*3),ntca(mxrss),ctca(mxrss),
     &                ncca(mxrsa),icca(2,mxata,mxrsa),
     &                nhha(mxrsa),ihha(2,mxatha,mxrsa),
     &                ncco(mxrso),icco(2,mxato,mxrso),
     &                nhho(mxrso),ihho(2,mxatho,mxrso)
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                ambvdt(mxamb)

      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 3

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20) (HIP,HID,HIE and sulfer bridge covered)
c                (ORN, mALA and pyroglut not covered)


      if (jres.le.0.or.jres.gt.mxrss) return

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
         call setchg(ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
         call setchg(ihpdb(i),0)
      end do

      nterm = .false.
      n = 0
      do i=1,3
         if (ihpdb(i).ne.0) n = n + 1
      end do
      if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.
      cterm = .false.
      if (ipdb(38).ne.0) cterm = .true.

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      if (jres.eq.4) then
c iss = 0 (cysteine -SH), iss = 1 (cystine -SS-)
         iss = 0
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          iss = 1
         end do
      endif

      if(nterm) then
          ioff = amboff(jres+20)
      else if(cterm) then
          ioff = amboff(jres+40)
      else
        ioff = amboff(jres)
      endif
      if (jres.eq.17) then
         if (ihis.eq.2) ioff = 178
         if (ihis.eq.3) ioff = 194
      endif
      if (jres.eq.4.and.iss.eq.1) ioff = 87
      if (jres.eq.9.and.(ihpdb(22).ne.0.or.ihpdb(25).ne.0)) ioff = 660
      if (jres.eq.13.and.(ihpdb(31).ne.0.or.ihpdb(34).ne.0)) ioff = 672

      ihtot = 0
      do i=0,2
         if (ihpdb(40+i).ne.0) ihtot = ihtot + 1
      end do

      if (jres.eq.12.and.ihtot.eq.2) ioff = 686

      if (nterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 436
         if (jres.eq.17 .and. ihis.eq.3) ioff = 442
         if (jres.eq.4 .and. iss.eq.1) ioff = 398
      endif
      if (cterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 584
         if (jres.eq.17 .and. ihis.eq.3) ioff = 590
         if (jres.eq.4 .and. iss.eq.1) ioff = 549
      endif

      call settyp(ityp,ipdb(1),ioff)
      call settyp(ityp,ipdb(2),ioff+1)
      call settyp(ityp,ipdb(3),ioff+2)
      if (jres.eq.15.and..not.nterm) then
         call settyp(ityp,ipdb(4),ioff+3)
         if (cterm) call settyp(ityp,ipdb(38),ioff+3)
      else
         call settyp(ityp,ipdb(4),ioff+4)
         if (cterm) call settyp(ityp,ipdb(38),ioff+4)
      endif

      call settyp(ityp,ihpdb(1),ioff+3)
      call settyp(ityp,ihpdb(2),ioff+3)
      call settyp(ityp,ihpdb(3),ioff+3)

      if (jres.eq.15) then
         call settyp(ityp,ihpdb(4),ioff+4)
         call settyp(ityp,ihpdb(5),ioff+4)
      else
         call settyp(ityp,ihpdb(4),ioff+5)
         call settyp(ityp,ihpdb(5),ioff+5)
      endif

      if (nterm.or.cterm) then
         ioff = amboff(jres)
         if (jres.eq.17) then
            if (ihis.eq.2) ioff = 178
            if (ihis.eq.3) ioff = 194
         endif
         if (jres.eq.4.and.iss.eq.1) ioff = 87
      endif

      if (jres.eq.15) then
         call settyp(ityp,ipdb(5),ioff+5)
         call settyp(ityp,ihpdb(7),ioff+6)
         call settyp(ityp,ihpdb(8),ioff+6)
         call settyp(ityp,ihpdb(9),ioff+6)
      else
         call settyp(ityp,ipdb(5),ioff+6)
         call settyp(ityp,ihpdb(7),ioff+7)
         call settyp(ityp,ihpdb(8),ioff+7)
         call settyp(ityp,ihpdb(9),ioff+7)
      endif

      jtmp = jres
      if (jres.eq.17) then
         if (ihis.eq.2) jtmp = 22
         if (ihis.eq.3) jtmp = 23
      endif
      if (jres.eq.4.and.iss.eq.1) jtmp = 21
    
      do i=1,ncca(jtmp)
         call settyp(ityp,ipdb(icca(1,i,jtmp)),icca(2,i,jtmp))
      end do

      do i=1,nhha(jtmp)
         call settyp(ityp,ihpdb(ihha(1,i,jtmp)),ihha(2,i,jtmp))
      end do

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ipdb(9),410)
            call settyp(ityp,ihpdb(19),411)
            call settyp(ityp,ihpdb(20),411)
         endif
CNF  Nothing different between PRO and other residues for the C-Term case
CNF         if (cterm) then
CNF            call settyp(ityp,ipdb(9),412)
CNF            call settyp(ityp,ihpdb(19),413)
CNF            call settyp(ityp,ihpdb(20),413)
CNF         endif
      endif

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

      if (jres.eq.12) then
         call settyp(ityp,ihpdb(43),286)
         call settyp(ityp,ihpdb(46),286)
         call settyp(ityp,ihpdb(49),286)
      endif

c check asph, RECTIFICATION: asph, gluh neutral lys, neg cys
c are not in the tinker amber set.
c we could add our own, but it has not been done yet
c Original AMBER itself does not work with so many atom types.
c Tinker creates the extra atom types to incrporate the charges
c in there as well. Charges deviate slightly between
c cterm,nterm and regular residues
c see ~schaft/compile/linux/molden4.6/
c     forf/amber9.ffparms/dat/leap/prep/all_amino94.in
c for the charges
c we should add our own extra types for these residues

      if (jres.eq.9) then
         if (ihpdb(22).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),670)
            call settyp(ityp,ipdb(30),669)
            call settyp(ityp,ihpdb(22),671)
         endif
         if (ihpdb(25).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),669)
            call settyp(ityp,ipdb(30),670)
            call settyp(ityp,ihpdb(25),671)
         endif
      endif

      if (jres.eq.13) then
         if (ihpdb(31).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),684)
            call settyp(ityp,ipdb(35),683)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(31),685)
         endif
         if (ihpdb(34).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),683)
            call settyp(ityp,ipdb(35),684)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(34),685)
         endif
      endif

      if (jres.eq.12.and.ihtot.eq.2) then
            call settyp(ityp,ipdb(6),694)
            call settyp(ityp,ipdb(9),696)
            call settyp(ityp,ipdb(12),698)
            call settyp(ityp,ipdb(27),700)
            call settyp(ityp,ihpdb(10),695)
            call settyp(ityp,ihpdb(11),695)
            call settyp(ityp,ihpdb(19),697)
            call settyp(ityp,ihpdb(20),697)
            call settyp(ityp,ihpdb(28),699)
            call settyp(ityp,ihpdb(29),699)
            call settyp(ityp,ihpdb(40),701)
            call settyp(ityp,ihpdb(41),701)
            call settyp(ityp,ihpdb(42),701)
            call settyp(ityp,ihpdb(43),701)
            call settyp(ityp,ihpdb(46),701)
            call settyp(ityp,ihpdb(49),701)
      endif

      do i=1,mxsym
         call setchg(ipdb(i),1)
      end do
      do i=1,mxhsym*3
         call setchg(ihpdb(i),1)
      end do

      return
      end

      subroutine typado(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxrss=20)
      parameter (mxrsa=23)
      parameter (mxata=9)
      parameter (mxatha=9)
      parameter (mxrso=24)
      parameter (mxato=10)
      parameter (mxatho=11)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=701)
      parameter (mxambc=49)
      logical nterm,cterm
      integer*2 ityp
      common /types/ iff
      integer amboff,ntca,ctca
      common /ambtyp/ amboff(mxrss*3),ntca(mxrss),ctca(mxrss),
     &                ncca(mxrsa),icca(2,mxata,mxrsa),
     &                nhha(mxrsa),ihha(2,mxatha,mxrsa),
     &                ncco(mxrso),icco(2,mxato,mxrso),
     &                nhho(mxrso),ihho(2,mxatho,mxrso)

      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                ambvdt(mxamb)

      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 4

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20) (HIP,HID,HIE and sulfer bridge covered)
c                (ORN, mALA and pyroglut not covered)


      if (jres.le.0.or.jres.gt.mxrss) return

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
         call setchg(ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
         call setchg(ihpdb(i),0)
      end do

      nterm = .false.
      n = 0
      do i=1,3
         if (ihpdb(i).ne.0) n = n + 1
      end do
      if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.
      cterm = .false.
      if (ipdb(38).ne.0) cterm = .true.

      ihis = 0
      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      iss = 0
      if (jres.eq.4) then
c iss = 0 (cysteine -SH), iss = 1 (cystine -SS-)
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          iss = 1
         end do
      endif

      iasph = 0
      iasphh = 0
      if (jres.eq.9) then
c iasph is it aspartate or aspartic acid
         if (ipdb(28).ne.0) then
            do i=1,iconn(1,ipdb(28))
               if (ianz(abs(iconn(1+i,ipdb(28)))).eq.1) then
                   iasph = 28
                   iasphh = iabs(iconn(1+i,ipdb(28)))
               endif
            end do
         endif
         if (ipdb(29).ne.0) then
            do i=1,iconn(1,ipdb(29))
               if (ianz(abs(iconn(1+i,ipdb(29)))).eq.1) then
                   iasph = 29
                   iasphh = iabs(iconn(1+i,ipdb(29)))
               endif
            end do
         endif
         if (ipdb(30).ne.0) then
            do i=1,iconn(1,ipdb(30))
               if (ianz(abs(iconn(1+i,ipdb(30)))).eq.1) then
                   iasph = 30
                   iasphh = iabs(iconn(1+i,ipdb(30)))
               endif
            end do
         endif
      endif

      ioff = 7

      if (jres.eq.1) ioff = 1
      if (jres.eq.15) ioff = 50

c N
      if (nterm) then
         if (jres.eq.15) then
            call settyp(ityp,ipdb(1),194)
         else
            call settyp(ityp,ipdb(1),190)
         endif
      else
         call settyp(ityp,ipdb(1),ioff)
      endif
c CA
      if (jres.eq.3) then
         call settyp(ityp,ipdb(2),33)
      elseif (jres.eq.4) then
         call settyp(ityp,ipdb(2),44)
      elseif (jres.eq.15.and.nterm) then
         call settyp(ityp,ipdb(2),196)
      else
         call settyp(ityp,ipdb(2),ioff+1)
      endif
         
c C
      call settyp(ityp,ipdb(3),ioff+2)
      if (cterm) call settyp(ityp,ipdb(3),192)
      if (jres.eq.15.and.nterm) call settyp(ityp,ipdb(3),197)

c HN
      if (nterm) then
         if (jres.eq.15) then
            call settyp(ityp,ihpdb(1),195)
            call settyp(ityp,ihpdb(2),195)
            call settyp(ityp,ihpdb(3),195)
         else
            call settyp(ityp,ihpdb(1),191)
            call settyp(ityp,ihpdb(2),191)
            call settyp(ityp,ihpdb(3),191)
         endif
         
      else
         call settyp(ityp,ihpdb(1),ioff+3)
         call settyp(ityp,ihpdb(2),ioff+3)
         call settyp(ityp,ihpdb(3),ioff+3)
      endif

c O
      if (jres.eq.15.and..not.cterm) then
         if (nterm) then
            call settyp(ityp,ipdb(4),198)
         else
            call settyp(ityp,ipdb(4),ioff+3)
         endif
      else
         if (cterm) then
            call settyp(ityp,ipdb(4),193)
            call settyp(ityp,ipdb(38),193)
         else
            call settyp(ityp,ipdb(4),ioff+4)
         endif
      endif


c HA
      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ihpdb(4),199)
            call settyp(ityp,ihpdb(5),199)
         else
            call settyp(ityp,ihpdb(4),ioff+4)
            call settyp(ityp,ihpdb(5),ioff+4)
         endif
      else
         call settyp(ityp,ihpdb(4),ioff+5)
         call settyp(ityp,ihpdb(5),ioff+5)
      endif

      jtmp = jres
      if (jres.eq.17) then
         if (ihis.eq.2) jtmp = 22
         if (ihis.eq.3) jtmp = 23
      endif
      if (jres.eq.4.and.iss.eq.1) jtmp = 21
      if (jres.eq.9.and.iasph.ne.0) jtmp = 24
    
      do i=1,ncco(jtmp)
         call settyp(ityp,ipdb(icco(1,i,jtmp)),icco(2,i,jtmp))
      end do

      do i=1,nhho(jtmp)
         call settyp(ityp,ihpdb(ihho(1,i,jtmp)),ihho(2,i,jtmp))
      end do

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ipdb(9),200)
            call settyp(ityp,ihpdb(19),201)
            call settyp(ityp,ihpdb(20),201)
         endif
      endif

      if (jres.eq.9.and.iasph.ne.0) then
         call settyp(ityp,ipdb(iasph),136)
         if (iasphh.ne.0) call settyp(ityp,iasphh,137)
c         call settyp(ityp,ihpdb(19),137)
c         call settyp(ityp,ihpdb(20),137)
c         call settyp(ityp,ihpdb(21),137)
      endif

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

      if (jres.eq.12) then
         call settyp(ityp,ihpdb(43),168)
         call settyp(ityp,ihpdb(46),168)
         call settyp(ityp,ihpdb(49),168)
      endif

c      do i=1,mxsym
c         call setchg(ipdb(i),1)
c      end do
c      do i=1,mxhsym*3
c         call setchg(ihpdb(i),1)
c      end do

      return
      end

      subroutine settyp(itypa,iat,ityp)
      implicit double precision (a-h,o-z)
      integer*2 itypa
      dimension itypa(*)
      common /typoni/ ioniad

      if (iat.gt.0) then
         if (ioniad.gt.0) then
            itypa(iat) =  itypa(iat) + ityp
         else
            itypa(iat) =  ityp
         endif
      endif

      return
      end

      subroutine setchd(iat,iopt,qat,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxamb=701)
      parameter (mxambc=49)
      integer*2 ityp,it,it10000
      common /typoni/ ioniad
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                ambvdt(mxamb)
      dimension qat(*),ityp(*)

      it10000=10000


      if (iat.gt.0) then
         if (iopt.eq.1) then
            if (ioniad.gt.0) then
               it = mod(ityp(iat),it10000)
            else
               it = ityp(iat)
            endif
            if (it.gt.0) then
               qat(iat) = ambchg(int(it))
            endif
            ihasq = 1
         else
            qat(iat) = 0.0d0
         endif
      endif

      return
      end

      subroutine flagd(ihpdb,iat,isurf)
      implicit double precision (a-h,o-z)
      dimension ihpdb(*),isurf(*)

      if (ihpdb(iat).ne.0) isurf(ihpdb(iat)) = 1

      return
      end

      subroutine conad(ipdb,iat1,iat2,iop,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*),iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ipdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         if (iop.eq.0) then
            iconn(1,ia2) = 1
            iconn(2,ia2) = ia1
         else
            if (iconn(1,ia2).lt.mxcon) then
               iconn(1,ia2) = iconn(1,ia2) + 1
               iconn(iconn(1,ia2)+1,ia2) = ia1
            endif
         endif
      endif

      return
      end

      subroutine conatd(ipdb,ihpdb,iat1,iat2,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*), ihpdb(*), iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ihpdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         iconn(1,ia2) = 1
         iconn(2,ia2) = ia1
      endif

      return
      end

      subroutine mkbacd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo)
      implicit double precision (a-h,o-z)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxcon=10)
      logical newch
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

c N-CA
      if (ipdb(1).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(1)) = 1
         iconn(2,ipdb(1)) = ipdb(2)
      endif

c CA-N, CA-C
      if (ipdb(2).ne.0) then
         iconn(1,ipdb(2)) = 0
         if (ipdb(1).ne.0) then
            iconn(2,ipdb(2)) = ipdb(1)
            iconn(1,ipdb(2)) = 1
            if (ipdb(3).ne.0) then
               iconn(3,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 2
            endif
         else
            if (ipdb(3).ne.0) then
               iconn(2,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 1
            endif
         endif
      endif

c C-CA,C-O
      if (ipdb(4).ne.0.and.ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
         if (ipdb(2).ne.0) then
            iconn(2,ipdb(3)) = ipdb(2)
            iconn(3,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 2
         else
            iconn(2,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 1
         endif
c O-C
         iconn(1,ipdb(4)) = 1
         iconn(2,ipdb(4)) = ipdb(3)

      elseif (ipdb(3).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(3)) = 1
         iconn(2,ipdb(3)) = ipdb(2)
      elseif (ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
      elseif (ipdb(4).ne.0) then
         iconn(1,ipdb(4)) = 0
      endif


c Possible OXT
      if (ipdb(38).ne.0.or.ipdb(76).ne.0) then
         if (ipdb(38).ne.0) then
            iox = ipdb(38)
         else
            iox = ipdb(76)
         endif
         iconn(1,ipdb(3)) = iconn(1,ipdb(3)) + 1
         iconn(iconn(1,ipdb(3))+1,ipdb(3)) = iox
         iconn(1,iox) = 1
         iconn(2,iox) = ipdb(3)
      endif
c C beta
      if (jres.gt.1.and.ipdb(5).ne.0) then
         iconn(1,ipdb(2)) = 3
         iconn(4,ipdb(2)) = ipdb(5)
         iconn(1,ipdb(5)) = 1
         iconn(2,ipdb(5)) = ipdb(2)
      endif
 
      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(2)
         icalf(2,icres) = ipdb(1)
         icalf(3,icres) = ipdb(3)
         icalf(4,icres) = 0
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         if (iamino(icres-1).le.23) then
            in = ipdb(1)
            ic = icalf(3,icres-1)
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect N current residue to C previous
c
               iconn(1,in) = iconn(1,in) + 1 
               iconn(iconn(1,in)+1,in) = ic
c
c connect C previous to N current residue 
c
               iconn(1,ic) = iconn(1,ic) + 1 
               iconn(iconn(1,ic)+1,ic) = in
            else
               newch = .true.
            endif
         else 
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      if (ihashy.eq.1) then
          do i=1,3
             call conath(ipdb,ihpdb,1,i)
             call conath(ipdb,ihpdb,2,3+i)
             call conath(ipdb,ihpdb,5,6+i)
          end do
      endif

      return
      end

      subroutine mknbcd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo)
      implicit double precision (a-h,o-z)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      parameter (mxcon=10)
      logical newch
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

      nconn = 0
      if (ipdb(44).gt.0) then
         nconn = nconn + 1
         iconn(1+nconn,ipdb(43)) = ipdb(44)
      endif
      if (ipdb(45).gt.0) then
         nconn = nconn + 1
         iconn(1+nconn,ipdb(43)) = ipdb(45)
      endif
      if (ipdb(46).gt.0) then
         nconn = nconn + 1
         iconn(1+nconn,ipdb(43)) = ipdb(46)
      endif
      iconn(1,ipdb(43)) = nconn

      iconn(1,ipdb(44)) = 0
      iconn(1,ipdb(45)) = 0
      iconn(1,ipdb(46)) = 0
      if (ipdb(43).gt.0) then
         iconn(2,ipdb(44)) = ipdb(43)
         iconn(2,ipdb(45)) = ipdb(43)
         iconn(2,ipdb(46)) = ipdb(43)
         iconn(1,ipdb(44)) = 1
         iconn(1,ipdb(45)) = 1
         iconn(1,ipdb(46)) = 1
      endif


      if (ipdb(47).gt.0) then
         iconn(1,ipdb(46)) = iconn(1,ipdb(46)) + 1
         iconn(1+iconn(1,ipdb(46)),ipdb(46)) = ipdb(47)
      endif

      iconn(1,ipdb(47)) = 2
      iconn(2,ipdb(47)) = ipdb(46)
      iconn(3,ipdb(47)) = ipdb(48)
      iconn(1,ipdb(48)) = 3
      iconn(2,ipdb(48)) = ipdb(47)
      iconn(3,ipdb(48)) = ipdb(49)
      iconn(4,ipdb(48)) = ipdb(50)
      iconn(1,ipdb(49)) = 2
      iconn(2,ipdb(49)) = ipdb(48)
      iconn(3,ipdb(49)) = ipdb(54)
      iconn(1,ipdb(50)) = 3
      iconn(2,ipdb(50)) = ipdb(48)
      iconn(3,ipdb(50)) = ipdb(51)
      iconn(4,ipdb(50)) = ipdb(52)
      iconn(1,ipdb(51)) = 1
      iconn(2,ipdb(51)) = ipdb(50)
      iconn(1,ipdb(52)) = 2
      iconn(2,ipdb(52)) = ipdb(50)
      iconn(3,ipdb(52)) = ipdb(54)
      if (ipdb(53).ne.0) then
         iconn(1,ipdb(52)) = 3
         iconn(4,ipdb(52)) = ipdb(53)
         iconn(1,ipdb(53)) = 1
         iconn(2,ipdb(53)) = ipdb(52)
      endif
      iconn(1,ipdb(54)) = 2
      iconn(2,ipdb(54)) = ipdb(49)
      iconn(3,ipdb(54)) = ipdb(52)

c Possible OXT
      if (ipdb(38).ne.0.and.ipdb(43).ne.0) then
         iconn(1,ipdb(43)) = 4
         iconn(5,ipdb(43)) = ipdb(38)
         iconn(1,ipdb(38)) = 1
         iconn(2,ipdb(38)) = ipdb(43)
      endif
c Possible O3P (OXT is old O3P new)
      if (ipdb(76).ne.0.and.ipdb(43).ne.0) then
         iconn(1,ipdb(43)) = 4
         iconn(5,ipdb(43)) = ipdb(76)
         iconn(1,ipdb(76)) = 1
         iconn(2,ipdb(76)) = ipdb(43)
      endif

      if (jres.eq.36.or.jres.eq.31) then
          call conat(ipdb,53,73,0)
          call conat(ipdb,53,80,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,47,61)
         call conath(ipdb,ihpdb,47,62)
         call conath(ipdb,ihpdb,48,64)
         call conath(ipdb,ihpdb,50,67)
         call conath(ipdb,ihpdb,52,70)
         call conath(ipdb,ihpdb,52,71)
         call conath(ipdb,ihpdb,54,73)
         if (ipdb(53).ne.0) call conath(ipdb,ihpdb,53,76)
         if ((jres.eq.36.or.jres.eq.31).and.ipdb(80).ne.0) then
             call conath(ipdb,ihpdb,80,151)
             call conath(ipdb,ihpdb,80,152)
             call conath(ipdb,ihpdb,80,153)
         endif
         call conath(ipdb,ihpdb,51,115)
         call conath(ipdb,ihpdb,46,118)
      endif

      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(43)
         icalf(2,icres) = ipdb(46)
         icalf(3,icres) = ipdb(47)
         icalf(4,icres) = ipdb(48)
         icalf(5,icres) = ipdb(50)
         icalf(6,icres) = ipdb(51)
      endif

      if (ipdb(43).eq.0.and.ipdb(46).ne.0.and.icres.le.numcal) 
     &    icalf(1,icres) = ipdb(46)

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         if (iamino(icres-1).gt.23) then
            ip = ipdb(43)
            io = icalf(6,icres-1)
            do i=1,3
               tmp(i) = coo(i,ip) - coo(i,io)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect P current residue to O previous
c
               iconn(1,ip) = iconn(1,ip) + 1 
               iconn(iconn(1,ip)+1,ip) = io
c
c connect O previous to P current residue 
c
               iconn(1,io) = iconn(1,io) + 1 
               iconn(iconn(1,io)+1,io) = ip
            else
               newch = .true.
            endif
         else
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      return
      end

      subroutine addhd(ires,jres,ipdb,ihpdb,nterm,
     &                 ianz,iaton,iatclr,iresid,iconn,isurf,ipdbt,coo)
c
c Add hydrogens
c Only the Hydrogens attached to the backbone N are not covered
c This is done by routine hcoord
c
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxhs=15)
      parameter (mxyg=26)
      common /hcom/  iat(4,mxhs,mxres),nrs(mxres),rint(3,mxhs,mxres),
     &               iatyg(4,mxyg),rintyg(3,mxyg)
      integer*2 ipdbt
      logical addat
      dimension ipdb(*), ihpdb(*), it(4), rt(4)
      dimension ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),
     &          iresid(*),coo(3,*),ipdbt(*),isurf(*)
      data nrs /2,4,4,4,6,10,8,8,3,5,10,12,5,7,7,12,7,8,8,9,3*0,
     &          11,11,11,12,10,15,13,13,13,13,15,15,13,0,10,0,12,
     &          12,10/
c gly
      data ((iat(i,j,1),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,1,2,5, 52*0/  
      data ((rint(i,j,1),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.9779d0,107.66d0,-118.0d0, 
     &     39*0.0d0/  
c ala
      data ((iat(i,j,2),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,2,5,7, 3,2,5,8, 3,2,5,9,
     &     44*0/  
      data ((rint(i,j,2),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     33*0.0d0/  
c ser
      data ((iat(i,j,3),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,31,10, 31,2,5,7, 31,2,5,8,
     &     44*0/  
      data ((rint(i,j,3),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     33*0.0d0/  
c cys
      data ((iat(i,j,4),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,37,10, 37,2,5,7, 37,2,5,8,
     &     44*0/  
      data ((rint(i,j,4),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,120.0d0, 0.990d0,112.5d0,-120.0d0,
     &     33*0.0d0/  
c thr
      data ((iat(i,j,5),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 32,8,5,7, 2,5,32,13, 
     &     2,5,8,16, 2,5,8,17, 2,5,8,18,
     &     36*0/  
      data ((rint(i,j,5),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     27*0.0d0/  
c ile
      data ((iat(i,j,6),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     10,5,7,13, 10,5,7,14, 5,7,10,22, 5,7,10,23, 5,7,10,24,
     &     20*0/  
      data ((rint(i,j,6),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c val
      data ((iat(i,j,7),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     8,5,7,13, 8,5,7,14, 8,5,7,15,
     &     28*0/  
      data ((rint(i,j,7),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c met
      data ((iat(i,j,8),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7,  6,2,5,8,
     &     36,5,6,10, 36,5,6,11, 
     &     6,36,12,28, 6,36,12,29, 6,36,12,30,
     &     28*0/  
      data ((rint(i,j,8),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.990d0,109.08d0,-120.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c asp
      data ((iat(i,j,9),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     48*0/  
      data ((rint(i,j,9),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     36*0.0d0/  
c asn
      data ((iat(i,j,10),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     29,6,21,25, 29,6,21,26,
     &     40*0/  
      data ((rint(i,j,10),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     30*0.0d0/  
c leu
      data ((iat(i,j,11),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     5,10,6,10, 5,6,10,22, 5,6,10,23, 5,6,10,24,
     &     5,6,11,25, 5,6,11,26, 5,6,11,27,
     &     20*0/  
      data ((rint(i,j,11),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.9779d0,107.63d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c lys
      data ((iat(i,j,12),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     12,6,9,19, 12,6,9,20, 27,9,12,28, 27,9,12,29,
     &     9,12,27,40, 9,12,27,41, 9,12,27,42,
     &     12*0/
      data ((rint(i,j,12),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     9*0/
c glu
      data ((iat(i,j,13),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     40*0/
      data ((rint(i,j,13),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     30*0/
c gln
      data ((iat(i,j,14),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     34,9,24,34, 34,9,24,35,
     &     32*0/
      data ((rint(i,j,14),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     24*0/
c pro
      data ((iat(i,j,15),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     1,6,9,19, 1,6,9,20,
     &     32*0/
      data ((rint(i,j,15),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     24*0/
c arg
      data ((iat(i,j,16),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     22,6,9,19, 22,6,9,20, 9,17,22,28,
     &     22,17,25,55, 22,17,25,56, 22,17,26,58, 22,17,26,59,
     &     12*0/
      data ((rint(i,j,16),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     9*0/
c his
      data ((iat(i,j,17),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,20,22, 20,24,13,31, 13,11,24,34, 24,6,11,25,
     &     32*0/
      data ((rint(i,j,17),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     24*0/
c phe
      data ((iat(i,j,18),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,14,17,40, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,18),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c tyr
      data ((iat(i,j,19),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,17,33,52, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,19),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     0.970d0,108.0d0,0.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c trp
      data ((iat(i,j,20),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,23,10,22, 10,14,23,31, 14,16,18,46, 18,19,16,58,
     &     16,15,19,49, 11,19,15,37,
     &     24*0/
      data ((rint(i,j,20),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,124.0d0,180.0d0, 1.050d0,124.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     18*0/

c asx,glx,hyp not yet

      data (((iat(i,j,k),i=1,4),j=1,mxhs),k=21,23) /180*0/
      data (((rint(i,j,k),i=1,3),j=1,mxhs),k=21,23) /135*0.0d0/

c adenosine

      data ((iat(i,j,24),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 60,58,64,-136, 60,58,64,-137,
     &     16*0/
      data ((rint(i,j,24),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.080d0,116.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c cytidine

      data ((iat(i,j,25),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     16*0/
      data ((rint(i,j,25),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c guanosine

      data ((iat(i,j,26),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     16*0/
      data ((rint(i,j,26),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     12*0/

c thimidine

      data ((iat(i,j,27),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,27),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/

c uridine

      data ((iat(i,j,28),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,28),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,119.4d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c 1MA

      data ((iat(i,j,29),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 60,58,64,-136,
     &     60,58,64,-137, 58,60,79,148, 58,60,79,149, 58,60,79,150, 
     &     60,57,58,103/
      data ((rint(i,j,29),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 
     &     1.080d0,120.0d0,180.0d0,1.080d0,120.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0,1.010d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,90.0d0,90.0d0/

c 5MC

      data ((iat(i,j,30),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 57,56,63,-130, 57,56,63,-131, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     8*0/
      data ((rint(i,j,30),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,118.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c OMC

      data ((iat(i,j,31),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     8*0/
      data ((rint(i,j,31),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     6*0/

c 1MG

      data ((iat(i,j,32),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,
     &     58,60,79,148, 58,60,79,149, 58,60,79,150,
     &     60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,32),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,122.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c 2MG

      data ((iat(i,j,33),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 
     &     55,61,80,151, 55,61,80,152, 55,61,80,153,
     &     8*0/
      data ((rint(i,j,33),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,0.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c M2G

      data ((iat(i,j,34),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 
     &     55,61,79,148, 55,61,79,149, 55,61,79,150,
     &     55,61,80,151, 55,61,80,152, 55,61,80,153/
      data ((rint(i,j,34),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c 7MG

      data ((iat(i,j,35),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,66,65,59,113,58,55,60,-121, 60,55,61,-124, 
     &     60,55,61,-125,
     &     57,65,85,166, 57,65,85,167, 57,65,85,168/
      data ((rint(i,j,35),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,120.0d0, 1.080d0,122.0d0,-120.0d0,
     &     1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c OMG

      data ((iat(i,j,36),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,36),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c NO YG

      data ((iat(i,j,37),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,37),i=1,3),j=1,mxhs) /45*0.0d0/

c inosine

      data ((iat(i,j,38),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121,62,60,55,82, 
     &     20*0/
      data ((rint(i,j,38),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.080d0,122.0d0,180.0d0,
     &     15*0/

c NO +U

      data ((iat(i,j,39),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,39),i=1,3),j=1,mxhs) /45*0.0d0/

c H2U

      data ((iat(i,j,40),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,60,57,58,104,58,56,57,100,58,56,57,101,
     &     56,55,62,-127, 
     &     12*0/
      data ((rint(i,j,40),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     9*0/

c 5MU

      data ((iat(i,j,41),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,41),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/


c PSU

      data ((iat(i,j,42),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,55,58,60,-121, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,42),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c YG

      data ((iatyg(i,j),i=1,4),j=1,mxyg) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,56,62,88,91, 56,62,88,92, 56,62,88,93,
     &     61,90,89,175, 61,90,89,176, 61,90,89,177,
     &     91,93,92,178, 91,93,92,179,
     &     92,94,93,181, 92,94,93,182, 93,95,94,184,
     &     95,97,98,187, 95,97,98,188, 95,97,98,189,
     &     94,100,99,-124,
     &     100,102,103,190, 100,102,103,191, 100,102,103,192/
      data ((rintyg(i,j),i=1,3),j=1,mxyg) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.090d0,109.8d0,180.0d0,
     &     1.090d0,109.8d0,60.0d0, 1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0, 1.010d0,120.0d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c
c for nucleotides the H's that make hydrogen bonds are added
c by subroutine mkcon, addhy1 and addhy2, these atoms are flagged
c via array isurf, which is used by dohcon to create hydrogen bonds
c this routine does not do that
c
c OXT = O3P , do we have to add H's to O2P,O3P, at present NO
c

      if (jres.le.0.or.jres.gt.mxres) return

      if (jres.eq.37) then
         nh = mxyg
      else
         nh = nrs(jres)
      endif

      do i=1,nh

          if (jres.eq.37) then
              do j=1,4
                 it(j) = iatyg(j,i)
              end do
              do j=1,3
                 rt(j) = rintyg(j,i)
              end do
          else
              do j=1,4
                 it(j) = iat(j,i,jres)
              end do
              do j=1,3
                 rt(j) = rint(j,i,jres)
              end do
          endif

          ih = abs(it(4))
          ihp = ihpdb(ih)

          if (jres.eq.4.and.i.eq.2) then
              if (iconn(1,ipdb(37)).gt.1) ihp = 1
          endif
          if (jres.eq.12.and.i.ge.10) then
              n = iconn(1,ipdb(27)) - 1
              if (n.gt.2) ihp = 1
          endif
          if (jres.eq.17.and.i.eq.6) then
              if (iconn(1,ipdb(24)).gt.2) ihp = 1
          endif
          if (ihp.eq.0) then
              if (addat(ipdb(it(1)),ipdb(it(2)),
     &        ipdb(it(3)),1,rt(1),rt(2),rt(3),ihpdb(ih),
     &            ianz,iaton,iatclr,iconn,coo)) then
                  iresid(ihpdb(ih)) = ires
                  ipdbt(ihpdb(ih)) = ih
                  if (it(4).lt.0) isurf(ihpdb(ih)) = 1
              endif
          endif
      end do

      if (jres.gt.23) then
c
c deal with DNA as well
c
         if (ipdb(53).eq.0) then
             if (addat(ipdb(50),ipdb(54),ipdb(52),1,
     &        1.090d0,109.8d0,120.0d0,ihpdb(71),
     &            ianz,iaton,iatclr,iconn,coo)) then
                 iresid(ihpdb(71)) = ires
                 ipdbt(ihpdb(71)) = 71
             endif
         endif

c HO3

         if (ipdb(51).ne.0) then
             n = icred(ipdb(51),inoh,ih,ianz,iconn)
             if (inoh.eq.1.and.ih.eq.0) then
                if (addat(ipdb(52),ipdb(50),ipdb(51),1,
     &           0.960d0,109.8d0,120.0d0,ihpdb(115),
     &            ianz,iaton,iatclr,iconn,coo)) then
                    iresid(ihpdb(115)) = ires
                    ipdbt(ihpdb(115)) = 115
                endif
             endif
         endif

      else

         if (nterm.eq.1) then
            n = icred(ipdb(1),inoh,ih,ianz,iconn)
            if (inoh.eq.1.and.ih.eq.1.and.ihpdb(1).ne.0) then
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,120.0d0,ihpdb(2),
     &            ianz,iaton,iatclr,iconn,coo)) then
                   iresid(ihpdb(2)) = ires
                   ipdbt(ihpdb(2)) = 2
               endif
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,-120.0d0,ihpdb(3),
     &            ianz,iaton,iatclr,iconn,coo)) then
                   iresid(ihpdb(3)) = ires
                   ipdbt(ihpdb(3)) = 3
               endif
            endif
         endif

      endif

      return
      end

      subroutine rdprot
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxres=42)
      parameter (maxam=1000)
      character*137 line,string
      common /curlin/ line
      character*3 aminos
      common /amino/  aminos(mxres)
      integer getlin
      dimension iamin(maxam),angs(7,maxam)

      mxam = maxam
      namin = 0
      do while (getlin(0).eq.1)
         iam = 0
         ktype = nxtwrd(string,nstr,itype,rtype)
         if (ktype.eq.1.and.nstr.eq.3) then
             call tocap(string,3)
             do i=1,20
                if (string(1:3).eq.aminos(i)) iam = i
             end do
             if (iam.ne.0) then
                if (namin.lt.maxam) then
                   namin = namin + 1
                   iamin(namin) = iam - 1
                   do i=1,7
                      angs(i,namin) = -1
                      ktype = nxtwrd(string,nstr,itype,rtype)
                      if (ktype.eq.3) angs(i,namin) = rtype
                      if (ktype.eq.2) angs(i,namin) = dble(itype)
                   end do
                else
                   call inferr('To many RESIDUES !',0)
                endif
             endif
         endif
      end do

      call readsq(iamin,angs,namin)

      return
      end

      subroutine numhed(numhet,iresid)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension iresid(*)

      nhmtmp = -3
      do i=1,iatoms
         if (iresid(i).lt.nhmtmp) nhmtmp = iresid(i)
      end do
      numhet = iabs(nhmtmp)

      return
      end

      logical function chkpdb(ipdb,jres,icres)
      implicit double precision (a-h,o-z)
      parameter (mxres=42)
      parameter (mxares=20)
      parameter (mxaat=13)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=701)
      parameter (mxgff=71)
      parameter (mxamo=201)
      parameter (numcal=5000)
      character*3 aminos
      common /amino/aminos(mxres)
      integer resn,resat
      common /resa/ resat(mxares,mxaat),resn(mxares)
      character*3 pdbsym,hsym,chtnk,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      character*1 achain
      common /helix/ isal(numcal),irsnr(numcal),ibck(4),achain(numcal),
     &               ihashb,ishoh
      dimension ipdb(*)

      data resn/4,4,6,6,7,8,7,8,8,8,8,9,9,9,8,11,10,11,12,13/
c glycine
      data (resat(1,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c alanine
      data (resat(2,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c serine
      data (resat(3,i),i=1,mxaat)/
     &          1,2,3,4,5,31,0,0,0,0,0,0,0/
c cysteine
      data (resat(4,i),i=1,mxaat)/
     &          1,2,3,4,5,37,0,0,0,0,0,0,0/
c threonine
      data (resat(5,i),i=1,mxaat)/
     &          1,2,3,4,5,32,8,0,0,0,0,0,0/
c isoleucine
      data (resat(6,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,10,0,0,0,0,0/
c valine
      data (resat(7,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,0,0,0,0,0,0/
c methionine
      data (resat(8,i),i=1,mxaat)/
     &          1,2,3,4,5,6,36,12,0,0,0,0,0/
c aspartic acid
      data (resat(9,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,30,0,0,0,0,0/
c asparagine
      data (resat(10,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,21,0,0,0,0,0/
c leucine
      data (resat(11,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,0,0,0,0,0/
c lysine
      data (resat(12,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,12,27,0,0,0,0/
c glutamic acid
      data (resat(13,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,34,35,0,0,0,0/
c glutamine
      data (resat(14,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,24,34,0,0,0,0/
c proline 28 ?
      data (resat(15,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,1,0,0,0,0,0/
c arginine
      data (resat(16,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,17,22,25,26,0,0/
c histidine 
      data (resat(17,i),i=1,mxaat)/
     &          1,2,3,4,5,6,11,13,20,24,0,0,0/
c phenylalanine
      data (resat(18,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,0,0/
c tyrosine
      data (resat(19,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,33,0/
c tryptophan
      data (resat(20,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,14,15,16,18,23/

      iresa = -1
      if (jres.le.20) then
         do i=1,resn(jres)
            if (ipdb(resat(jres,i)).le.0) then
               chkpdb = .false.
               print*,'incomplete residue ',irsnr(icres),' ',
     &                 aminos(jres),' ',pdbsym(resat(jres,i))
               return
            endif
         end do
      endif

      chkpdb = .true.
      return
      end
          
      subroutine detanz(resi,tstr,lstr,ifnd,ish,ianz,ihashy)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*3 resi, atmp
      character*4 tstr
      character*2 tocapf

          ifnd = 1
          ish = 0
          atmp = tstr(2:4)
c
c Take care of ambiguity; asx->asn ,glx->gln ,his
c
          if (resi.eq.'ASX') then
              if (atmp.eq.'AD1') then
                  atmp = 'OD1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'ND2'
              endif
          elseif (resi.eq.'GLX') then
              if (atmp.eq.'AE1') then
                  atmp = 'OE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'HIS') then
              if (atmp.eq.'AD1') then
                  atmp = 'ND1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'CD2'
              elseif (atmp.eq.'AE1') then
                  atmp = 'CE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'ILE') then
              if (atmp.eq.'CD ') then
                  atmp = 'CD1'
              elseif (atmp.eq.'HD1') then
                  atmp = 'HD1'
                  tstr(1:4) = '1HD1'
              elseif (atmp.eq.'HD2') then
                  atmp = 'HD1'
                  tstr(1:4) = '2HD1'
              elseif (atmp.eq.'HD3') then
                  atmp = 'HD1'
                  tstr(1:4) = '3HD1'
              endif
          elseif (resi.eq.'SER'.or.resi.eq.'CYS') then
              if (atmp.eq.'HG1') atmp = 'HG '
          endif
          if (atmp.ne.tstr(2:4)) tstr(2:4) = atmp


          if (tstr(1:2).eq.'HH'.or.tstr(1:2).eq.'HD'.or.
     &        tstr(1:2).eq.'HE'.or.tstr(1:2).eq.'HG') then
              atmp = tstr(1:3)
              tstr = ' '//atmp
          endif

c to unscrew whatif specific types

          if (tstr(2:4).eq.'O**') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'O* ') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'H5M') tstr(2:4) = 'HM5'
          if (tstr(2:4).eq.'H3T') tstr(2:4) = 'HO3'
          if (tstr(1:4).eq.'1H4 ') tstr(1:4) = ' H41'
          if (tstr(1:4).eq.'2H4 ') tstr(1:4) = ' H42'

          if (tstr(2:4).eq.'OT1') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'OT2') tstr(2:4) = 'OXT'

          it = ichar(tstr(2:2))
          it4 = ichar(tstr(4:4))
          if (it.eq.67) then
             ianz = 6
          elseif (it.eq.78) then
             ianz = 7
          elseif (it.eq.79) then
             ianz = 8
          elseif (it.eq.80) then
             ianz = 15
          elseif (it.eq.83) then
             ianz = 16
          elseif (it.eq.72.or.it.eq.68) then
             ianz = 1
             if (it.eq.68) tstr(2:2) = 'H'
             if (tstr(2:4).eq.'HN ') tstr(2:4) = 'H  '
             if ((tstr(2:3).eq.'HA'.or.tstr(2:3).eq.'HB').and.
     &           (tstr(4:4).ne.' ')) tstr(4:4) = ' '
             if (tstr(2:3).eq.'HT'.and.(it4.ge.49.and.it4.le.51))
     &       then
                tstr(3:4) = '  '
                tstr(1:1) = tstr(4:4)
             endif
             ihashy = 1
             ish = 1
c Below convert 1H8 to H81, which not recognized by molden
c it probably served to read in force field H label variant
c             if (tstr(4:4).eq.' ') then
c                it1 = ichar(tstr(1:1))
c                it3 = ichar(tstr(3:3))
c                if ((it1.ge.49.and.it1.le.57).and.
c     &              (it3.ge.49.and.it3.le.57)) tstr(4:4) = tstr(1:1)
c             endif
          else
             ifnd = 0 
          endif
          
          if (ifnd.eq.0) then
            it = ichar(tstr(1:1))
            if (.not.(it.ge.65.and.it.le.90).and..not.
     &             (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
            do j=1,99
             if (tstr(1:2).eq.tocapf(elemnt(j))) ianz = j
            end do
            if (ianz.eq.0.and.tstr(1:1).ne.' ') then
               tstr(1:1) = ' '
               do j=1,99
                  if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &                ianz = j
               end do
            endif
            if (ianz.le.0) then
               if (tstr(2:2).eq.'D'.and.tstr(2:3).ne.'DY') then
                  ianz = 1
               else
                  write(iun3,*) 'Unclassified atom =',tstr
                  write(iun3,*) lstr
                  ianz = 99
               endif
            endif
          endif

      return
      end

      subroutine getfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr,str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      character*4 frsym
      common /frstr/ frsym(maxfrq)
      integer getlin
      logical g94,dosym
      dimension coo(3,*)

      istat = 1

      g94 = .false.
      dosym = .true.
      ihasi = 2
      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0

      rewind iun2

      call iatnox(natoms)

      do i=1,natoms
         do j=1,3
             fcoo(j,i) = coo(j,i)
         end do
      end do

c     Read in Gaussian Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

13    call search(lstr,'Frequencies --',istat)
      if (istat.eq.0) goto 100
      if (ivibs.gt.nvibs) goto 100
      g94 = (index(lstr,'Frequencies --').eq.2)

      if (dosym) then
         backspace iun2
         backspace iun2
         idum = getlin(0)
         if (g94) then
            nv = 3
         else
            nv = 5
         endif
         do i=1,nv
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               ns = nstr
               if (ns.gt.3) ns = 3
               frsym(ivibs+i) = '   '
               frsym(ivibs+i) = str(1:ns)
            else
            endif
         end do
         call readel(lstr,1)
      endif

      if (g94) then
         indfr = index(lstr,'Frequencies --')
         lstr = lstr(indfr+14:)
         read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (freq(i),i=ivibs+1,ivibs+3)
         call readel(lstr,3)
         lstr = lstr(indfr+14:)
         read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (frint(i),i=ivibs+1,ivibs+3)
         call readel(lstr,1)
         if (index(lstr,'Raman').eq.0) then
            ihasi = 1
         else
            lstr = lstr(indfr+14:)
            read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (ramint(i),i=ivibs+1,ivibs+3)
         endif
         ivibs = ivibs + 3
      else
         indfr = index(lstr,'Frequencies --')
         lstr = lstr(indfr+16:)
         read(lstr,'(5f10.4)',err=100,end=100) 
     &          (freq(i),i=ivibs+1,ivibs+5)
         call readel(lstr,3)
         lstr = lstr(indfr+16:)
         read(lstr,'(5f10.4)',err=100,end=100) 
     &          (frint(i),i=ivibs+1,ivibs+5)
         call readel(lstr,1)
         if (index(lstr,'Raman').eq.0) then
            ihasi = 1
         else
            lstr = lstr(indfr+16:)
            read(lstr,'(5f10.4)',err=100,end=100) 
     &          (ramint(i),i=ivibs+1,ivibs+5)
         endif
         ivibs = ivibs + 5
      endif
      goto 13

100   if (ivibs.eq.0) istat = 0
200   if (freq(ivibs).eq.0.0d0.and.ivibs.ne.0) then
         ivibs = ivibs - 1
         goto 200
      endif
      nfreq = ivibs
      ihasi = 2
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)
      
      if (dosym) then
         ihasi = -ihasi
         do i=1,ivibs
            call parsfn(frsym(i),3,12)
         end do
      endif

      return
      end 

      subroutine ncoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
c      character*2 gstr
      character*5 tstr
      real freqt
      dimension freqt(5),frtt(3,3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      logical g94

c     Get ifreq 'th Norm. Cordinates from Gaussian Output

      istat = 1
      g94 = .false.

      rewind iun2
      ilegnd = 3
      call iatnox(iatoms)
      nvibs = nfreq
      call search(lstr,'Frequencies -- ',istat)
      if (istat.eq.0) goto 100
      g94 = (index(lstr,'Frequencies --').eq.2)

c Find out length of legend

      if (g94) then
         do i=1,8
             read(iun2,'(a)',end=100,err=100) lstr
             if (index(lstr,'Atom AN      X').ne.0) goto 15
             ilegnd = ilegnd + 1
         end do
15       continue
      else
          ilegnd = 8
      endif

      call scback(lstr,'and normal coordinates:',istat)
      call readel(lstr,1)
      if (istat.eq.0) goto 100
      if (g94) then
         ioff = ifreq - ((ifreq-1)/3)*3
      else
         ioff = ifreq - ((ifreq-1)/5)*5
      endif


      ivibs = 0
10    read(iun2,'(a)',end=100,err=100) lstr
      if (ivibs.ge.nvibs) goto 20
      if (index(lstr,'and normal coordinates:').ne.0) goto 20
      tstr = '     '
      write(tstr,'(1a,i3,1a)') ' ',ifreq,' '
c      tstr = ' '//gstr(ifreq)//' '

      if (index(lstr,tstr).ne.0) then
         call readel(lstr,ilegnd)
         if (g94) then
            do i=1,iatoms
               read(iun2,'(8x,3(2x,3f7.2))',err=100,end=100) 
     &             ((frtt(j,k),j=1,3),k=1,3)
               do j=1,3
                   a(j,i) = frtt(j,ioff)
               end do
            end do
         else
            do i=1,iatoms
               do j=1,3
                   read(iun2,'(23x,5f10.5)',err=100,end=100) 
     &                  (freqt(k),k=1,5)
                   a(j,i) = freqt(ioff)
               end do
            end do
         endif
      else
         if (g94) then
            call readel(lstr,iatoms+ilegnd)
         else
            call readel(lstr,iatoms*3+ilegnd)
         endif
      endif
      if (g94) then
         ivibs = ivibs + 3
      else
         ivibs = ivibs + 5
      endif
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine ggetfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      dimension coo(3,*)

cd     write(iun3,'(a)')'enter subroutine ggetfr'
      istat = 1

      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0
      rewind iun2

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in Gamess Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1
      call search(line,'cartesians to normal mode',istat)
      if (istat.eq.0) goto 10

c...  This is a Hessian run
      call readel(line,6)
50    call readel(line,1)
      if (ivibs.lt.nvibs+6) then
         read(line,'(15x,8f11.2)',end=100,err=100)
     &        (freq(i),i=ivibs+1,ivibs+8)
         ivibs = ivibs + 8
         call readel(line,3*iatoms+7)
         goto 50
      endif
      n = ivibs
      ivibs = 0
      do i=1,n
         if (freq(i).ne.0.0d0) then
            ivibs=ivibs+1
            freq(ivibs)=freq(i)
         endif
      enddo
      goto 200

10    continue
c...  This is a Force run
      call search(line,'frequencies ----',istat)
      if (istat.eq.0) goto 100
      if (ivibs.gt.nvibs) goto 100
      line = line(index(line,'frequencies ----')+22:)
      read(line,'(9f10.4)',err=100,end=100) 
     &     (freq(i),i=ivibs+1,ivibs+9)
      ivibs = ivibs + 9
      goto 10

100   if (ivibs.eq.0) istat = 0
200   if (freq(ivibs).eq.0.0d0.and.ivibs.ne.0) then
         ivibs = ivibs - 1
         goto 200
      endif
      nfreq = ivibs
      ihasi = 0
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)
cd     write(iun3,'(a)')'leave subroutine ggetfr'
      return
      end 

      subroutine ncoorg(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
      character*2 gstr
      character*4 tstr
      real freqt
      dimension freqt(9)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi

c     Get ifreq 'th Norm. Cordinates from Gamess Output
cd     write(iun3,'(a)')'enter subroutine ncoorg'

      istat = 1

      rewind iun2
      call iatnox(iatoms)
      nvibs = nfreq

      call search(lstr,'cartesians to normal mode',istat)
      if (istat.eq.0) goto 30
c
c...  This is a Hessian run
c
      if (freq(ifreq).lt.0.0d0) then
         ifreq1 = ifreq
      else
         ifreq1 = ifreq+6
      endif
      ioff = ifreq1 - ((ifreq1-1)/8)*8
      ivibs = 0
      tstr = ' '//gstr(ifreq1)//' '
      call readel(lstr,3)
40    read(iun2,'(a)',end=100,err=100) lstr
      if (ivibs.lt.nvibs+6) then
         if (index(lstr,tstr).ne.0) then
            call readel(lstr,5)
            do i=1,iatoms
               do j=1,3
                  read(iun2,'(15x,8f11.6)',err=100,end=100)
     &                 (freqt(k),k=1,8)
                  a(j,i) = freqt(ioff)
               end do
            end do
            call readel(lstr,2)
         else
            call readel(lstr,iatoms*3+7)
         endif
         ivibs = ivibs+8
         goto 40
      endif
      goto 20

30    continue
c
c...  This is a Force run
c
      ioff = ifreq - ((ifreq-1)/9)*9
      call search(lstr,'and normalised normal coordinates',istat)
      if (istat.eq.0) goto 100
      call readel(lstr,3)

      ivibs = 0
10    read(iun2,'(a)',end=100,err=100) lstr
      if (ivibs.gt.nvibs) goto 20
      if (index(lstr,'===========================').ne.0) goto 20
      tstr = ' '//gstr(ifreq)//' '

      if (index(lstr,tstr).ne.0) then
          call readel(lstr,7)
          do i=1,iatoms
             do j=1,3
                 read(iun2,'(23x,9f10.5)',err=100,end=100) 
     &                (freqt(k),k=1,9)
                 a(j,i) = freqt(ioff)
             end do
          end do
          call readel(lstr,2)
      else
          call readel(lstr,iatoms*3+9)
      endif
      ivibs = ivibs + 9
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
cd     write(iun3,'(a)')'leave subroutine ncoorg'
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
cd     write(iun3,'(a)')'leave subroutine ncoorg'
      return
      end

      subroutine getfrd(istat,coo,ianz)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr, str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      common /frmop/ imop6
      character*4 frsym
      common /frstr/ frsym(maxfrq)
      integer getlin
      logical dosym
      character*2 iel,catomt,catom,tolowf
      dimension iel(100),xyz(3)
      dimension coo(3,*),ianz(*)
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x '/

      istat = 1

      imop6 = 0
      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0
      ihasi = 0
      toau = 0.52917706d0
      dosym = .true.

      rewind iun2

      call search(lstr,'ORIENTATION OF MOLECULE IN FORCE',istat)
      if (istat.eq.0) goto 1000

      icoord = 0
      iatoms = 0
      do while (getlin(0).eq.1)
         if (nxtwrd(str,nstr,itype,rtype).ne.2) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
             if (nstr.eq.1) then
                 catomt(1:1) = str(1:1)
                 catomt(2:2) = ' '
             else
                 catomt = str(1:2)
             endif
             catom = tolowf(catomt)
         else
             if (ktype.eq.2) then
                 imop6 = 1
                 ianzt = itype
             else
                 goto 100
             endif
         endif
         do j=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
                xyz(j) = rtype
            else
                goto 100
            endif
         end do
         if (icoord.eq.0) icoord = 1
         iatoms = iatoms + 1
         if (imop6.eq.1) then
            ianz(iatoms) = ianzt
         else
            do i=1,100
               if ( catom .eq. iel(i) ) ianz(iatoms) = i - 1
            end do
         endif
         do j=1,3
            coo(j,iatoms) = xyz(j) / toau
         end do
         goto 150
100      if (icoord.eq.1) goto 200
150      continue
      end do

200   continue


      do i=1,iatoms
         do j=1,3
             fcoo(j,i) = coo(j,i)
         end do
      end do


c     Read in Mopac Frequencies

      nvibs = 3*iatoms - 6
      if (iatoms.eq.1) nvibs = 0
      if (iatoms.eq.2) nvibs = 1

c      call search(lstr,'NORMAL COORDINATE ANALYSIS',istat)
      call search(lstr,'MASS-WEIGHTED COORDINATE ANALYSIS',istat)
13    call search(lstr,'Root No.',istat)
      if (istat.eq.0) goto 1000
         if (ivibs.eq.nvibs) goto 1000
         if (imop6.eq.1) then
            call readel(lstr,1)
         else
            if (dosym) then
               call readel(lstr,2)
               read(lstr,'(12x,10(4x,a4))',err=1000,end=1000)
     &               (frsym(ivibs+i),i=1,8)
               call readel(lstr,1)
            else
               call readel(lstr,3)
            endif
         endif
         idum = getlin(0)
         do while (nxtwrd(str,nstr,itype,rtype).eq.3) 
            ivibs = ivibs + 1
            freq(ivibs) = rtype
         end do
      goto 13

1000  if (ivibs.eq.0) istat = 0
      nfreq = ivibs

c find transition dipole moments (T-DIPOLE)

      rewind iun2
      call search(lstr,'DESCRIPTION OF VIBRATIONS',istat)
      if (istat.eq.1) then
         do i=1,nfreq
            do while (getlin(0).eq.1)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1.and.nstr.eq.9) then
                  if (str.eq.'VIBRATION') then
                     call readel(lstr,1)
                     idum = getlin(0)
                     if (idum.eq.1) then
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.1.and.nstr.eq.8) then
                           if (str.eq.'T-DIPOLE') then
                              ktype = nxtwrd(str,nstr,itype,rtype)
                              if (ktype.eq.3) then
                                 frint(i) = rtype
                              else
                                 goto 3000
                              endif
                           else
                              goto 3000
                           endif
                        else
                           goto 3000
                        endif
                     else
                        goto 3000
                     endif
                     goto 2000
                  else
                     goto 3000
                  endif
               endif
            end do

c found frequency T-DIPOLE

2000        continue
         end do
      else
         goto 3000
      endif
      ihasi = 1

      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      if (dosym) then
         ihasi = -ihasi
         do i=1,ivibs
            call parsfn(frsym(i),3,12)
         end do
      endif

      return

3000  ihasi = 0
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)
      return
      end 

      subroutine mcoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr,line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frmop/ imop6
      common /curlin/ line
      integer getlin

c     Get ifreq 'th Norm. Cordinates from Mopac Output

      istat = 1

      rewind iun2
      toau = 0.52917706d0
      if (imop6.eq.1) then
          nvlin = 6
      else
          nvlin = 8
      endif
      call iatnox(iatoms)
      nvibs = nfreq
      ioff = ifreq - ((ifreq-1)/nvlin)*nvlin
c      call search(lstr,'NORMAL COORDINATE ANALYSIS',istat)
c
c      if you choose for the above the algorithm still comes up
c      with the MASS-WEIGHTED set, have to look at this some time
c
      call search(lstr,'MASS-WEIGHTED COORDINATE ANALYSIS',istat)
      if (istat.eq.0) goto 100

      ivibs = 0
10    call search(lstr,'Root No.',istat)
      if (istat.eq.0.or.ivibs.ge.nvibs) goto 20
      backspace iun2
      n = getlin(0)
      do while (.true.)
         n = nxtwrd(lstr,nstr,itype,rtype)
         if (n.eq.0) then
            goto 10
         elseif (n.eq.2.and.itype.eq.ifreq) then
            goto 15
         endif
      end do
15    continue
      if (imop6.eq.1) then
         call readel(lstr,3)
      else
         call readel(lstr,5)
      endif

      do i=1,iatoms
         do j=1,3
             idum = getlin(0)
             if (imop6.eq.1.and.line(1:1).eq.'1') idum = getlin(0)
             do n=1,ioff+1
                ktype = nxtwrd(lstr,nstr,itype,rtype)
             end do
             if (ktype.eq.3) then
                a(j,i) = rtype / toau
             endif
         end do
      end do
      ivibs = ivibs + nvlin
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine getfrad(istat,ianz)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      parameter (mxel=100)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      character*2 elemnt
      common /elem/elemnt(mxel)
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      character*2 tocapf
      dimension r(3)
      dimension ianz(*)

      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      istat =  1

      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0

      call rewmf

      call srchmf(line,'[FREQ]',istats)
      if (istats.eq.0) goto 100
 
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             ivibs = ivibs + 1
             freq(ivibs) = rtype
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          endif

      end do

10    nfreq = ivibs

      call rewmf
      call srchmf(line,'[FR-COORD]',istats)
      if (istats.eq.0) goto 100

      iat = 0
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)

          if (ktype.eq.1) then
              if (str(1:1).eq.'[') goto 20
              if (nstr.eq.1) then
                  str(2:2) = str(1:1)
                  str(1:1) = ' '
                  nstr = 2
              endif

              ifound = 0
              if (nstr.eq.2) then
                 do i=1,mxel
                    if (tocapf(str(1:2)).eq.tocapf(elemnt(i))) 
     &                  ifound = i
                 end do
                 if (ifound.ne.0) then
                    iat = iat + 1
                    ianz(iat) = ifound
                    if (gnreal(r,3,.false.)) then
                       do i=1,3
                          fcoo(i,iat) = r(i)
                       end do
                    endif
                 endif
              endif

          endif

      end do

20    iatoms = iat

      call resfr

      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine getint(istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      character*137 line,str
      common /curlin/ line
      integer getlin

      istat =  1

      i = 0
      ihsv = 0
      ihsram = 0
      ihasi = 0

      call rewmf

      call srchmf(line,'[INT]',istats)
      if (istats.eq.0) then
          istat = 0
          return
      endif
 
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             i = i + 1
             frint(i) = rtype
             ihsv = 1
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          endif

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             ramint(i) = rtype
             ihsram = 1
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          elseif (ktype.eq.0) then
          endif

      end do

10    ihasi = ihsv + ihsram

      return
      end

      subroutine acoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

      istat = 1
      call rewmf
      call iatnox(iatoms)
      call srchmf(line,'[FR-NORM',istats)
      if (istats.eq.0) goto 100

      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)

          if (ktype.eq.1) then
             if (nstr.ge.3) then
                 if (icdex(str,'vib').ne.0) then
                    ktype = nxtwrd(str,nstr,itype,rtype)
                    if (ktype.eq.2) then
                       if (itype.eq.ifreq) goto 50
                    else
                       goto 100
                    endif
                 endif
             endif
          endif

      end do

      goto 100

50    do i=1,iatoms
         
          if (gnreal(r,3,.true.)) then
             do j=1,3
                a(j,i) = r(j)
             end do
          else
             goto 60
          endif

      end do

60    if (idebug.eq.1) call prtfr(ifreq)

      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine nxtpnd(iopt,fancy,atcol,dolabs,backb,wpnt,
     &                  coo)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      common /athlp/ iatoms, mxnat
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      logical backb,wpnt
      integer dolabs,fancy,atcol
      character*11 movfil
      character*5 hstr,tstr
      dimension coo(3,*)

      call iatnox(natoms)

      if (wpnt) then
         tstr = hstr(ifrq)
         i = index(tstr,')')
         movlen = 4+i-2+4
         movfil = 'freq'//tstr(2:i-1)//'.dat'
         if (iopt.eq.5) movfil(movlen-2:movlen) = 'wrl'
         if (iopt.eq.6) movfil = 'molden.ogl'
      endif

      iframe = iframe + idirct
      if (iframe.ge.nframe.or.iframe.le.-nframe) then
         idirct = -1*idirct
         iloop = iloop + 1
      endif

      do i=1,natoms
        do j=1,3
           coo(j,i) = fcoo(j,i) + iframe*frmul*a(j,i)
        end do
      end do

      if (wpnt.and.iloop.lt.3) then

        if (iloop.eq.1.and.iframe.eq.nframe) then
            call wrpnt(movfil,movlen,iopt,1,nframe*2,
     &                 fancy,atcol,dolabs,backb)
        elseif (iloop.eq.2.and.iframe.eq.nframe-1) then
            ipts = ipoints
            ipoints = nframe*4
            call wrpnt(movfil,movlen,iopt,4,0,
     &                 fancy,atcol,dolabs,backb)
            ipoints = ipts
            call inferr('wrote file: '//movfil,0)
            if (iopt.eq.6) call viewer
        else
            call wrpnt(movfil,movlen,iopt,3,0,
     &                 fancy,atcol,dolabs,backb)
        endif

      endif

      return
      end

      subroutine scalfd(iopt,fancy,atcol,dolabs,backb,wpnt,
     &                  coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      parameter (mxel=100)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      common /thephi/theta1,phi1,rroot,rincr,vdwr(mxel),vrad(mxel),
     &               scal,fscal,scali,smag,ipoints,ipnt,icol(mxel)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)
      logical backb,wpnt
      integer dolabs,fancy,atcol
      dimension coo(3,*)

      idirct = 1
      iframe = nframe - 1
      call nxtpnt(iopt,fancy,atcol,dolabs,backb,wpnt)

      call iatnox(natoms)

      scali = 0.0d0
      do i=1,natoms
         dist = 0.0d0
         do j=1,3
             dt = coo(j,i)-t(j)
             dist = dist + dt*dt
         end do
         if (dist.gt.scali) scali = dist
      end do
      scali = dsqrt(scali)
      scal = scali * 2.4d0 * smag

      return
      end

      subroutine resfd(coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      dimension coo(3,*)

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           coo(j,i) = fcoo(j,i)
        end do
      end do

      return
      end

      subroutine tofcod(coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq
      dimension coo(3,*)

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

      return
      end

      subroutine prtfr(ifreq)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      call iatnox(iatoms)

      write(iun3,*) ' '
      write(iun3,*) 'Coordinates used in frequency calculation (au)'
      write(iun3,*) '============='
      do i=1,iatoms
         write(iun3,*) (fcoo(j,i),j=1,3)
      end do

      write(iun3,*) ' '
      write(iun3,*) 'Norm. Mode ',ifreq,' (au)'
      write(iun3,*) '============='

      do i=1,iatoms
         write(iun3,*) (a(j,i),j=1,3)
      end do

      return
      end

      logical function negfrq(ifreq)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi

      negfrq = .false.

      if (freq(ifreq).lt.0.0e0) negfrq = .true.

      return
      end

      subroutine iatnod(iatnox,ianz)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension ianz(*)

      iatnox = 0
      do i=1,iatoms
         if (ianz(i).ne.99) iatnox = iatnox + 1
      end do

      return
      end

      subroutine calspc
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      logical opfil

      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      if (opfil(46,'fr.out',6,1,0,0)) then
         do i=1,nfreq
            write(46,'(f10.4,2x,f10.4)') freq(i),frint(i)
         end do
         close(46)
      endif

      return
      end

      subroutine rdcor(idebug,isymm,istat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      ig98 = 0

      if (isymm.eq.0) goto 1000

      if (idebug.eq.1)
     &   call inferr('looking for Standard orientation',0)

      call search(line,'Standard orientation:',istat)
      if (istat.eq.0) then
          if (idebug.eq.1)
     &      call inferr('Standard orientation not found!',0)
          return
      else
          call readel(line,2)
          read(iun2,'(a)',err=20) line
          if (icdex(line,'Type').ne.0) ig98 = 1
          call readel(line,1)
      endif

      natoms = 0
10    read(iun2,'(a)',err=20) line
      if (line(2:5).eq.'----') goto 200
      read(line,'(1x,i4)',err=20) natoms
      if ( natoms .gt. numatm ) then
          call inferr('Exceeding Max Atoms!',0)
          goto 20
      endif
      if (ig98.eq.1) then
          read(line,'(12x,i4,18x,3f12.6)',err=20)
     &      nat(natoms),xyz(1,natoms),xyz(2,natoms),xyz(3,natoms)
      else
          read(line,'(12x,i4,7x,3f12.6)',err=20)
     &      nat(natoms),xyz(1,natoms),xyz(2,natoms),xyz(3,natoms)
      endif
      goto 10

c
c===== Z-Matrix/ Input orientation
c
1000  if (idebug.eq.1) call inferr(
     &    'looking for Z-Matrix/Input orientation',0)

      call searchd(line,'Z-Matrix orientation:',
     &             'Input orientation:',istat)
      if (istat.eq.0) then
          if (idebug.eq.1) call inferr(
     &    'Z-Matrix/Input orientation not found!',0)
          return
      else
          call readel(line,2)
          read(iun2,'(a)',err=20) line
          if (icdex(line,'Type').ne.0) ig98 = 1
          call readel(line,1)
      endif

      natoms = 0
      do while ( .true. )
         read(iun2,'(a)',err=20) line
         if (line(2:4).eq.'---') goto 100
         natoms = natoms + 1
         if (ig98.eq.1) then
            read(line,'(12x,i4,18x,3(f12.6))',err=20)
     &      nat(natoms),(xyz(j,natoms),j=1,3)
         else
            read(line,'(12x,i4,7x,3(f12.6))',err=20) nat(natoms),
     &       (xyz(j,natoms),j=1,3)
         endif
      end do

100   continue
c
c get rid off dummy atoms
c
200   continue
      do i=1,natoms
         if (nat(i).lt.0) then
            do j=i+1,natoms
               nat(j-1) = nat(j)
               do k=1,3
                  xyz(k,j-1) = xyz(k,j)
               end do
            end do
            natoms = natoms - 1
            goto 200
         endif
      end do

      toang = 0.52917706d0
c
c convert to atomic units
c
      do i=1,natoms
         do j=1,3
            xyz(j,i) = xyz(j,i) / toang
         end do
      end do

      istat = 1
      return

20    call inferr('Error reading Standard orientation!',1)
      istat = 0
      return
      end

      subroutine gtbpar(istat,i1,i2,bl,bk)
      implicit double precision (a-h,o-z), integer (i-n)
      integer*2 i1, i2
      parameter (mxbnd=82)
      integer bndcon
      common /bndpar/ bndcon(2,mxbnd),bnd(2,mxbnd)
      parameter (mxamb=701)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=49)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      logical doamb, dogaff
      parameter (mxgff=71)
      parameter (mxgbnd=746)
      integer gfbcon
      common /gfbpar/ gfbnd(2,mxgbnd),gfbcon(2,mxgbnd)
      
      istat = 0
      doamb = .false.
      dogaff = .false.

      if (i1.gt.0.and.i2.gt.0) then
         doamb = .true.
      elseif (i1.lt.0.or.i2.lt.0) then
         dogaff = .true.
      endif

      if (doamb) then
         iac = ambcls(i1)
         ibc = ambcls(i2)

         do k=1,mxbnd 
            if (
     &       (iac.eq.bndcon(1,k).and.ibc.eq.bndcon(2,k))
     &          .or.
     &       (ibc.eq.bndcon(1,k).and.iac.eq.bndcon(2,k))
     &      ) then
               istat = 1
               bl = bnd(2,k)
               bk = bnd(1,k)
            endif
         end do
      endif

      if (dogaff) then

         if (i1.gt.0) then
            iac = mapagf(ambcls(i1))
         else
            iac = abs(i1)
         endif
         if (i2.gt.0) then
            ibc = mapagf(ambcls(i2))
         else
            ibc = abs(i2)
         endif

         do k=1,mxgbnd 
            if (
     &       (iac.eq.gfbcon(1,k).and.ibc.eq.gfbcon(2,k))
     &          .or.
     &       (ibc.eq.gfbcon(1,k).and.iac.eq.gfbcon(2,k))
     &      ) then
               istat = 1
               bl = gfbnd(2,k)
               bk = gfbnd(1,k)
            endif
         end do
      endif

      return
      end

      subroutine bndard(istat,nbnd,ibnd,bl,bk,maxbnd,iconn,ityp)
c
c     create bond list from the connection array and assign parameters
c
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      parameter (mxbnd=82)
      integer bndcon
      common /bndpar/ bndcon(2,mxbnd),bnd(2,mxbnd)
      parameter (mxamb=701)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),
     &          ibnd(2,*),bl(*),bk(*)

      nbnd = 0
      istat = 1

      do i=1,iatoms
         do j=1,iconn(1,i)
            jj = iconn(j+1,i)
            if (jj.gt.0) then
               if (i.lt.jj) then
                  if (nbnd.lt.maxbnd) then
                     nbnd = nbnd + 1
                     ibnd(1,nbnd) = i
                     ibnd(2,nbnd) = jj
                     call gtbpar(istat,
     &                    ityp(i),ityp(jj),bl(nbnd),bk(nbnd))
                     if (istat.eq.0) write(iun5,*) 
     &                       'Missing Bond parameter: ',
     &                               abs(ityp(i)),abs(ityp(jj))
                  else
                     istat = 0
                  endif
               endif
            endif
         end do
      end do

      return
      end

      subroutine bond(eb,nbnd,ibnd,bl,bk,coo,forces)
      implicit double precision (a-h,o-z), integer (i-n)
      common /athlp/  iatoms, mxnat
      dimension ibnd(2,*), bl(*), bk(*), coo(3,*), forces(3,*)
      dimension vab(3)

      eb = 0.0d0

      do i = 1, nbnd
         ia = ibnd(1,i)
         ib = ibnd(2,i)
         bopt = bl(i)
         fk = bk(i)

            do j=1,3
               vab(j) = coo(j,ia) - coo(j,ib)
            end do

            rab = vlen(vab)
            dt = rab - bopt

            dt2 = dt * dt
            e = fk * dt2 
            deddt = 2.0d0 * fk * dt

            de = deddt / rab

            call vscal(vab,3,de)

            eb = eb + e
          
            do j=1,3
               forces(j,ia) = forces(j,ia) + vab(j)
               forces(j,ib) = forces(j,ib) - vab(j)
            end do

      end do

      return
      end

      subroutine espod(x,y,z,epot,idebug,
     &                 p)
c THIS IS REALLY espot
      implicit double precision(a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (numtmp=4000)
      logical oeerst
      integer shella,shelln,shellt,shellc,shladf,aos
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /bounds/ ilow(5,5),iupp(5)
      common /indxe/  jx(35),jy(35),jz(35),ix(20),iy(20),iz(20)
      common /strt/   oeerst
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /pseudo / ipseud,ivale(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      dimension tt(4),zz(4),pre(45),ca(35),cb(35),
     &          coeffx(192),coeffy(192),coeffz(192)
      dimension h(numtmp),f(numtmp),h2x(9),h2y(9),h2z(9),
     &          h3x(16),h3y(16),h3z(16)
      dimension p(*)
      data jx/1,2,1,1,3,1,1,2,2,1,4,1,1,2,3,3,2,1,1,2,
     &           5,1,1,4,4,2,1,2,1,3,3,1,3,2,2/
      data jy/1,1,2,1,1,3,1,2,1,2,1,4,1,3,2,1,1,2,3,2,
     &           1,5,1,2,1,4,4,1,2,3,1,3,2,3,2/
      data jz/1,1,1,2,1,1,3,1,2,2,1,1,4,1,1,2,3,3,2,2,
     &           1,1,5,1,2,1,2,4,4,1,3,3,2,2,3/
      data ix/0,4,0,0,8,0,0,4,4,0,12,0,0,4,8,8,4,0,0,4/
      data iy/0,0,4,0,0,8,0,4,0,4,0,12,0,8,4,0,0,4,8,4/
      data iz/0,0,0,4,0,0,8,0,4,4,0,0,12,0,0,4,8,8,4,4/
c iupp 1  4  10 20 35
c      s  3p 6d 10f 15g
c 
c ilow 0    1       2        3      4    <- shellt
c---------------------------------------
c 0    1(s) 1 (sp)  1 (spd)  1      1
c 1    1    2 (p)   5       11     21
c 2    1    1       5 (d)   11     21
c 3    1    1       5       11 (f) 21
c 4    1    1       5       11     21 (g)
c---------------------------------------
c ^
c | shellc
c
      data iupp/1,4,10,20,35/
      data ilow/5*1,1,2,5,11,21,1,1,5,11,21,1,1,5,11,21,
     &          1,1,5,11,21/

      if (oeerst) then
         call epint
         call setcon
         oeerst = .false.
      endif

      epot = 0.0d0
      pi = 4.d0*datan(1.d0)
c
c     loop over shell pairs.
c
      do ishell = 1, nshell
        xa = gx(ishell)
        ya = gy(ishell)
        za = gz(ishell)
        ifrst = shella(ishell)
        ilast = ifrst + shelln(ishell) - 1
        itype = shellt(ishell)
        itype1 = itype + 1
        istart = ilow(itype1,shellc(ishell)+1)
        iend = iupp(itype1)
        iendt = iend

        do jshell = 1,ishell
          xb = gx(jshell)
          yb = gy(jshell)
          zb = gz(jshell)
          jfsrt = shella(jshell)
          jlast = jfsrt + shelln(jshell) - 1
          jtype = shellt(jshell)
          jtype1 = jtype + 1
          jstart = ilow(jtype1,shellc(jshell)+1)
          jend = iupp(jtype1)
          ijtyp = itype1 + jtype1 - 1
          ndim = (iend-istart+1)*(jend-jstart+1)
          iminj = iabs(ishell - jshell)
          n = (itype + jtype) / 2 + 1
          xt = xb - xa
          yt = yb - ya
          zt = zb - za
          rsq = xt*xt + yt*yt + zt*zt
          if (ndim.gt.numtmp) 
     &       print*,'WARNING: exceding array limit in espot'
          do ii=1,ndim
             h(ii) = 0.0d0
          end do
          jendt = jend
c
c         loop over primitive gaussians.
c
          do igauss = ifrst, ilast
            ei = exx(igauss)
            call fcij(itype,ifrst,igauss,shladf(ishell),ca)
            do jgauss = jfsrt,jlast
              iend = iendt
              jend = jendt
              ej = exx(jgauss)
              call fcij(jtype,jfsrt,jgauss,shladf(jshell),cb)
              ep = ei + ej
              exptmp = ej*ei*rsq / ep
              if (exptmp.ge.600.0d0) goto 100
              expp = 2.0d0*dexp(-exptmp)
              tx = (ei*xa + ej*xb) / ep
              ty = (ei*ya + ej*yb) / ep
              tz = (ei*za + ej*zb) / ep
              xta = tx - xa
              yta = ty - ya
              zta = tz - za
              xtb = tx - xb
              ytb = ty - yb
              ztb = tz - zb
              call coeffs(coeffx,xta,xtb,itype1,jtype1)
              call coeffs(coeffy,yta,ytb,itype1,jtype1)
              call coeffs(coeffz,zta,ztb,itype1,jtype1)
              if (ndim.gt.numtmp) 
     &           print*,'WARNING: exceding array limit in espot'
              do ii=1,ndim
                  f(ii) = 0.0d0
              end do
              xct = x - tx
              yct = y - ty
              zct = z - tz
              expont = ep * (xct * xct + yct * yct + zct * zct)
              call rys(n,expont,tt,zz)
              epp = 0.5d0 / ep
              call calct(pre,epp,ijtyp)
              do ii = 1, n
                fac1 = (ep + ep)*tt(ii)
                zf = pi * expp * zz(ii) / ep
                call twocen(h2x,xct,1.d0,pre,fac1,ijtyp)
                call twocen(h2y,yct,1.d0,pre,fac1,ijtyp)
                call twocen(h2z,zct,zf,pre,fac1,ijtyp)
                call thrcen(h3x,h2x,coeffx,itype1,jtype1)
                call thrcen(h3y,h2y,coeffy,itype1,jtype1)
                call thrcen(h3z,h2z,coeffz,itype1,jtype1)

                k = 0
                do i = istart, iend
                  do j = jstart, jend
                    k = k + 1
                    if (k.gt.numtmp) 
     &                print*,'WARNING: exceding array limit in espot'
                    f(k) = f(k)-
     &           (h3x(jx(j)+ix(i))*h3y(jy(j)+iy(i))*h3z(jz(j)+iz(i)))
                  end do
                end do
              end do

              k = 0
              do i = istart, iend
                do j = jstart,jend
                  k = k + 1
                  if (k.gt.numtmp) 
     &              print*,'WARNING: exceding array limit in espot'
                  h(k) = h(k) + f(k)*ca(i)*cb(j)
                end do
              end do
              kend = k

100           continue
              end do
            end do

            call purdf(itype,jtype,istart,jstart,iend,jend,h)
c
c Density matrix contribution
c

            ii = 0
            ist = aos(ishell) - 1
            jst = aos(jshell) - 1
            do i = istart,iend
               do j = jstart,jend
                  ii = ii + 1
                  if (iminj.eq.0) then
                     a1or2 = 1.0d0
                     if (i-j.lt.0) then
                        pt = p((ist+i-1)*mxorb + (jst+j))
                     else
                        pt = p((jst+j-1)*mxorb + (ist+i))
                     endif
                  else
                     a1or2 = 2.0d0
                     pt = p((jst+j-1)*mxorb + (ist+i))
                  endif
                  phelp = pt*a1or2
                  epot = epot + phelp*h(ii)
            if (idebug.eq.1) print*,'v(',ist+i,',',jst+j,')=',h(ii)
               end do
            end do

            jend = jendt
            iend = iendt
        end do
      end do

c sum in nuclear contribution

c
      do ii = 1 ,natoms
          xt = xyz(1,ii) - x
          yt = xyz(2,ii) - y
          zt = xyz(3,ii) - z
          rsq = xt*xt + yt*yt + zt*zt
          if (rsq.ge.1.0d-8) then
             if (ipseud.eq.1) then
                epot = epot + dfloat(ivale(ii))*dsqrt(1.0d0 / rsq)
             else
                epot = epot + dfloat(nat(ii))*dsqrt(1.0d0 / rsq)
             endif
          endif
      end do

      return
      end

      subroutine purdf(itype,jtype,istart,jstart,iend,jend,h)
c
c only iend and jend are really nescessary to return
c
c iupp 1  4  10 20 35
c      s  3p 6d 10f 15g
c 
c ilow 0    1       2        3      4    <- shellt
c---------------------------------------
c 0    1(s) 1 (sp)  1 (spd)  1      1
c 1    1    2 (p)   5       11     21
c 2    1    1       5 (d)   11     21
c 3    1    1       5       11 (f) 21
c 4    1    1       5       11     21 (g)
c---------------------------------------
c ^
c | shellc
c
c question does h come filled in shell form ?, eg d is really spd
c with start at 5 (instead of 1) (we treat d such but not f?)
c
c xxxx,yyyy,zzzz *1
c xxxy ...       *d7
c xxyy ...       *d5*d7/d3
c xxyz ...       *d5*d7
c
c via fcij ca and cb have these, and therfor h() has them 
c
      implicit double precision (a-h,o-z)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /intcon/ d3,d5,d7,r1,r2,r3,r4,r3ov2,z1,z2,z3,
     &                g1,g2,g3,g4,g5,g6
      logical debug
      dimension h(*),inc(14)
      debug = .false.
c
c     convert  gaussians to pure angular functions.
c     (6D -> 5D, 10F -> 7F, 15G -> 9G)
c

      b1 = 1.0d0/d7
      b2 = d3/(d5*d7)
      b3 = 1.0d0/(d5*d7)

      idim = iend - istart + 1
      jdim = jend - jstart + 1

      if (ido5d.eq.1.and.jtype.eq.2) then
c
c     The row side of the matrix: pure d
c     

         i1 = 5 - jstart + 1

c     when d   shell jstart = 5 , i1 = 1, jend = 10, jdim = 6
c     when spd shell jstart = 1 , i1 = 5, jend = 10, jdim = 10
c     single d shell is stored in H() as:
c
c     d1 d2 d3 d4 d5 d6 NOT s px py pz d1 d2 etc

         do i=1,idim
            dz2 = h(i1+2) - 0.5d0*(h(i1) + h(i1+1))
            dx2y2 = r3ov2*(h(i1) - h(i1+1))
            h(i1  ) = dz2
            h(i1+1) = h(i1+4)
            h(i1+2) = h(i1+5)
            h(i1+4) = h(i1+3)
            h(i1+3) = dx2y2
            i1 = i1 + jdim
         end do

      endif
 
      if (ido7f.eq.1.and.jtype.eq.3) then
c
c     The row side af the matrix: pure f
c     
c     when f  shell jstart = 11 , jend = 20, jdim = 10
c
         i1 = 0
         do i=1,idim
 
            f0  = h(i1+3) - r2*(h(i1+6) + h(i1+9))
            f1p = r4*(z1*h(i1+7) - h(i1+1) - z2*h(i1+4))
            f1m = r4*(z1*h(i1+8) - h(i1+2) - z2*h(i1+5))
            f2p = r3ov2*(h(i1+6) - h(i1+9))
            f2m = h(i1+10)
            f3p = r1*(h(i1+1) - z3*h(i1+4))
            f3m = r1*(z3*h(i1+5) - h(i1+2))
 
            h(i1+1) = f0
            h(i1+2) = f1p
            h(i1+3) = f1m
            h(i1+4) = f2p
            h(i1+5) = f2m
            h(i1+6) = f3p
            h(i1+7) = f3m
 
            i1 = i1 + jdim

         end do
      endif

      if (ido9g.eq.1.and.jtype.eq.4) then
c
c     The row side af the matrix: pure g
c     
c     when g  shell jstart = 21 , jend = 35, jdim = 15
c
         i1 = 0
         do i=1,idim
 
          g0  = 
     &       0.375d0*h(i1+1)  + 0.375d0*  h(i1+2) +           h(i1+3) 
     &     -3.0d0*b2*h(i1+11) - 3.0d0*b2*h(i1+12) + 0.75d0*b2*h(i1+10)

          g1p = 
     &  g1*(4.0d0*b1*h(i1+8)  - 3.0d0*b3*h(i1+14) - 3.0d0*b1* h(i1+5))

          g1m = 
     &  g1*(4.0d0*b1*h(i1+9)  - 3.0d0*b3*h(i1+13) - 3.0d0*b1* h(i1+7))

          g2p = 
     &  g2*(6.0d0*b2*h(i1+11) - 6.0d0*b2*h(i1+12) -           h(i1+1) 
     &    +          h(i1+2))

          g2m = 
     &  g3*(6.0d0*b3*h(i1+15) - b1*      h(i1+4)  - b1*       h(i1+6))

          g3p = 
     &  g4*(   b1*   h(i1+5)  - 3.0d0*b3*h(i1+14))

          g3m = 
     &  g4*(3.0d0*b3*h(i1+13) -  b1*     h(i1+7))
 
          g4p = 
     &  g5*(         h(i1+1)  - 6.0d0*b2*h(i1+10) +           h(i1+2))

          g4m = 
     &  g6*b1*(      h(i1+4)  -          h(i1+6))

            h(i1+1) = g0
            h(i1+2) = g1p
            h(i1+3) = g1m
            h(i1+4) = g2p
            h(i1+5) = g2m
            h(i1+6) = g3p
            h(i1+7) = g3m
            h(i1+8) = g4p
            h(i1+9) = g4m
 
            i1 = i1 + jdim

         end do
      endif
c
c     the row size of the matrix has changed, so get rid of
c     the superflous functions.
c
      if ((ido5d.eq.1.and.jtype.eq.2).or.
     &    (ido7f.eq.1.and.jtype.eq.3).or.
     &    (ido9g.eq.1.and.jtype.eq.4)) then

         if (jtype.eq.2) then
            jendp = 9
         else if (jtype.eq.3) then
c     when f   shell jstart = 11 , jend = 17, jpure = jdim = 7, jend = 17
            jendp = 17
         else if (jtype.eq.4) then
c     when g   shell jstart = 21 , jendp = 29, jpure = jdim = 9, jend = 29
            jendp = 29
         endif
         if (debug) print*,'row.old.new ',itype,jtype,jend,jendp
         jrpure = jendp - jstart + 1
 
         i1 = 0
         i2 = 0
 
         do i=1,idim
            do j=1,jrpure
               h(i2+j) = h(i1+j)
            end do
            i1 = i1 + jdim
            i2 = i2 + jrpure
         end do
         jend = jendp
         jdim = jrpure

      endif
c
c     transformation at row side complete, start of column side
c

      if (ido5d.eq.1.and.itype.eq.2) then
c
c     The column side of the matrix: pure d
c
         i1 = (5-istart)*jdim + 1
         do i=1,5
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
            dz2 = h(i1+inc(2)) - 0.5d0*(h(i1) + h(i1+inc(1)))
            dx2y2 = r3ov2*(h(i1) - h(i1+inc(1)))
            h(i1       ) = dz2
            h(i1+inc(1)) = h(i1+inc(4))
            h(i1+inc(2)) = h(i1+inc(5))
            h(i1+inc(4)) = h(i1+inc(3))
            h(i1+inc(3)) = dx2y2
            i1 = i1 + 1
         end do

      endif
 
      if (ido7f.eq.1.and.itype.eq.3) then
c
c     The column side af the matrix: pure F
c
         i1 = 1
         do i=1,9
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
 
            f0  = h(i1+inc(2)) - r2*(h(i1+inc(5)) + h(i1+inc(8)))
            f1p = r4*(z1*h(i1+inc(6)) - h(i1) - z2*h(i1+inc(3)))
            f1m = r4*(z1*h(i1+inc(7)) - h(i1+inc(1))-z2*h(i1+inc(4)))
            f2p = r3ov2*(h(i1+inc(5)) - h(i1+inc(8)))
            f2m = h(i1+inc(9))
            f3p = r1*(h(i1) - z3*h(i1+inc(3)))
            f3m = r1*(z3*h(i1+inc(4)) - h(i1+inc(1)))
    
            h(i1       ) = f0
            h(i1+inc(1)) = f1p
            h(i1+inc(2)) = f1m
            h(i1+inc(3)) = f2p
            h(i1+inc(4)) = f2m
            h(i1+inc(5)) = f3p
            h(i1+inc(6)) = f3m
    
            i1 = i1 + 1
         end do

      endif
 
      if (ido9g.eq.1.and.itype.eq.4) then
c
c     The column side af the matrix: pure G
c
         i1 = 1
         do i=1,14
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
 
          g0  = 
     &          0.375d0*h(i1)         + 0.375d0*  h(i1+inc(1))  +
     &                  h(i1+inc(2))  - 3.0d0*b2* h(i1+inc(10)) - 
     &         3.0d0*b2*h(i1+inc(11)) + 0.75d0*b2*h(i1+inc(9))

          g1p = 
     &     g1*(4.0d0*b1*h(i1+inc(7))  - 3.0d0*b3* h(i1+inc(13)) - 
     &         3.0d0*b1*h(i1+inc(4)))

          g1m = 
     &     g1*(4.0d0*b1*h(i1+inc(8))  - 3.0d0*b3* h(i1+inc(12)) - 
     &         3.0d0*b1*h(i1+inc(6)))

          g2p = 
     &     g2*(6.0d0*b2*h(i1+inc(10)) - 6.0d0*b2* h(i1+inc(11)) -
     &                  h(i1)         +           h(i1+inc(1)))

          g2m = 
     &     g3*(6.0d0*b3*h(i1+inc(14)) - b1*       h(i1+inc(3))  -
     &               b1*h(i1+inc(5)))

          g3p = 
     &     g4*(b1*      h(i1+inc(4))  - 3.0d0*b3* h(i1+inc(13)))

          g3m = 
     &     g4*(3.0d0*b3*h(i1+inc(12)) - b1*       h(i1+inc(6)))
 
          g4p = 
     &      g5*(        h(i1)         - 6.0d0*b2* h(i1+inc(9))  + 
     &                  h(i1+inc(1)))

          g4m = 
     &      g6*b1*(     h(i1+inc(3))  -           h(i1+inc(5)) )

            h(i1       ) = g0
            h(i1+inc(1)) = g1p
            h(i1+inc(2)) = g1m
            h(i1+inc(3)) = g2p
            h(i1+inc(4)) = g2m
            h(i1+inc(5)) = g3p
            h(i1+inc(6)) = g3m
            h(i1+inc(7)) = g4p
            h(i1+inc(8)) = g4m
 
            i1 = i1 + 1
         end do

      endif
      if ((ido5d.eq.1.and.itype.eq.2) .or.
     &    (ido7f.eq.1.and.itype.eq.3) .or.
     &    (ido9g.eq.1.and.itype.eq.4)) then

         if (debug) print*,'colm.old ',itype,jtype,iend
         if (itype.eq.2) then
            iend = 9
         else if (itype.eq.3) then
            iend = 17
         else if (itype.eq.4) then
            iend = 29
         endif
         if (debug) print*,'colm.new ',itype,jtype,iend

      endif
 
      return
      end

      subroutine setcon
      implicit double precision (a-h,o-z)
      common /intcon/ d3,d5,d7,r1,r2,r3,r4,r3ov2,z1,z2,z3,
     &                g1,g2,g3,g4,g5,g6
      d3 = dsqrt(3.0d0)
      d5 = dsqrt(5.0d0)
      d7 = dsqrt(7.0d0)
      z1 = 4.0d0/d5
      z2 = 1.0d0/d5
      z3 = 3.0d0/d5
      r1 = 0.5d0*dsqrt(5.0d0/2.0d0)
      r2 = 1.5d0/d5
      r3ov2 = 0.5d0*dsqrt(3.0d0)
      r3 = r3ov2
      r4 = 0.5d0*dsqrt(3.0d0/2.0d0)

      g1 = dsqrt(5.0d0/8.0d0)
      g2 = dsqrt(5.0d0/16.0d0)
      g3 = dsqrt(5.0d0/4.0d0)
      g4 = dsqrt(35.0d0/8.0d0)
      g5 = dsqrt(35.0d0/64.0d0)
      g6 = dsqrt(35.0d0/4.0d0)

      return
      end

      subroutine pargeo
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)

      mxpnt = MAXPNT
      call parptr(3,fmaxt,fdum,idum)
      call parptr(151,formax,fdum,idum)

      return
      end

      subroutine proged(ipoints,iff,istat,
     &                  formax,forrms,dismax,disrms,epoints,isav,
     &                  coo,ianz)
C this is really progeo
      implicit double precision ( a-h,o-z )
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      integer xmol
      logical favail,oxyz,doconv,dozme,gusirc
      common /getpnt/ irtype,ipdbon,ipdbgro,xmol,favail,oxyz,
     &                doconv,dozme,gusirc
      logical gamess,gauss,mopac,molpot,elpot,chemx,oisbin,cpmd
     &        ,gamus,ctoz,adfin,chpot,qchem,orca
      common /choic/  mopac,gamess,gauss,molpot,elpot,chemx,cpmd,
     &                oisbin,gamus,ctoz,adfin,chpot,qchem,orca
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /xyzopt/ ixyz,ichx,icrtp,ipdbwh,iambch
      common /mopver/ mopopt
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*),coo(3,*),ianz(*)

      istat = -1
      if (gamess) then
          if (gamus) then
             call geogus(formax,forrms,dismax,disrms,epoints,isav)
          else
             call geogam(formax,forrms,dismax,disrms,epoints,isav)
          endif
      elseif (cpmd) then
          call geocpmd(formax,forrms,dismax,disrms,epoints,isav,
     &                 needm)
          if (needm.ne.-1) istat = needm
      elseif (gauss) then
          call geogau(formax,forrms,dismax,disrms,epoints,isav)
      elseif (qchem) then
          call geoqcm(formax,forrms,dismax,disrms,epoints,isav)
      elseif (orca) then
          call geoorc(formax,forrms,dismax,disrms,epoints,isav)
      elseif (mopac.and..not.doconv) then
          call geomop(
     &            formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
      elseif (xmol.eq.1) then
          call geoxyz(0,iff,
     &            formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
      elseif (xmol.eq.4) then
          ngeoms = 1
      elseif (xmol.eq.3) then
          call geoxyz(0,iff,
     &            formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
      elseif (xmol.eq.2) then
          call geoxyz(-1,iff,
     &            formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
      elseif (adfin) then
          if (ihasg.gt.0) then
             call geoxyz(ihasg,iff,
     &             formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
             call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
          else
             ngeoms = 0
          endif
      elseif (icrtp.eq.5) then
          call geoxdt(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.3) then
          call geobio(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.2) then
          call geofdt(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.1) then
          call geochx(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (ipdbgro.eq.1) then
c done this already
          idum = 1
      elseif (mopac.and.mopopt.eq.4) then
          idum = 1
      else
          igcvav = 0
      endif

      if (cpmd.or.gamess.or.gauss.or.qchem.or.orca.or.
     &    (mopac.and..not.doconv).or.(mopac.and.mopopt.eq.4)) 
     &     call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)


      ipoints = ngeoms

      return
      end

      subroutine rdbad(idebug,dfree,istats,ityp)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxonh=100)
      character*3 cnam
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp,dfree
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      integer*2 ityp
      equivalence (nshell,i)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(4),ityp(*)


      istats = 1
      ig03 = 0

      if (idebug.eq.1)
     &    call inferr('looking for gaussian basis-set',0)

1030  format(4d18.10)
1040  format(4x,4d18.10)
      if (dfree.ne.0) then
         if (dfree.eq.1) then
            call searchu(line,'[GTO]',istat)
         elseif (dfree.eq.2) then
            call srchmf(line,'$BASIS',istat)
         endif
      else
         call seardu(line,'Basis set in the form',
     &                    'AO basis set:',istat)
         if (istat.eq.0) then
             call inferr(
     &       'Use keyword gfinput in gaussian inputfile',1)
             goto 1000
         endif
         if (index(line,'AO basis set').ne.0) ig03 = 1
         if (index(line,'AO basis set:').ne.0) ig03 = 2
      endif

      i = 0
      k = 0
      if (ioni.eq.1) then
         do m=1,numatm
            iomap(m) = 0
            ityp(m) = 20000
         end do
      endif
      mm = 1
      mmdf = 1
      jann = 0
      jmode = 1

10    if (dfree.ne.0) then
         if (getlin(0).eq.1) idum = 0
      else
         read(iun2,'(a)',err=1000) line
      endif

      if (dfree.ne.0) then

         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.eq.1) then
            if (nstr.ge.1) then
               if (index(str,'[').ne.0) return
               if (dfree.eq.2) then
                  if (icdex(str,'$END').ne.0) return
               endif
               if (str(1:1).eq.'#'.or.str(1:1).eq.'*') then
                  if (dfree.eq.2) jmode = 1
                  goto 10
               endif
               if (jmode.eq.1.and.dfree.eq.2) then
                  jann = jann + 1
                  jmode = 0
                  goto 10
               endif
            endif
         elseif (ktype.eq.2) then
            jann = itype
            goto 10
         elseif (ktype.eq.0) then
            goto 10
         endif

      else
         if (ig03.eq.2.and.line(2:5).ne.'Atom') return
         if (i.eq.0.or.line(2:5).eq.'****'.or.line(2:5).eq.'Atom') then
            if (line(2:5).eq.'Atom') then
               ig03 = 2
c example: Atom B3       Shell     8 SP   2    bf   20 -    23
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
c            break up string and extract jann
               do kk=1,nstr
                  ik = ichar(str(kk:kk))
                  if (ik.lt.48.or.ik.gt.57) str(kk:kk) = ' '
               end do
               do kk=1,nstr
                  if (str(kk:kk).ne.' ') istrt = kk
               end do
               jann = reada(str,1,nstr)
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1) then
                  cnam = '   '
                  if (nstr.gt.3) nstr = 3
                  cnam(1:nstr) = str(1:nstr)
                  call tocap(cnam,3)
               else
                  goto 1000
               endif
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  nsh = itype
               else
                  goto 1000
               endif
            else
               if (line(2:5).eq.'****') then
                   read(iun2,'(a)',err=1000) line
                   if (linlen(line).eq.0) return
               endif
               if (line(7:7).ne.' ') then
                  read(line,'(i7)',err=1000) jann
               elseif (line(4:4).ne.' ') then
                  read(line,'(i4)',err=1000) jann
               else
                  read(line,'(i3)',err=1000) jann
               endif
               if (ioni.eq.1) then
                  k = k + 1
                  iomap(k) = jann
                  nat(k) = nat(jann)
                  ityp(jann) = ityp(jann) - 20000
                  do ll=1,3
                     xyz(ll,k) = xyz(ll,jann)
                  end do
                  do jj=1,nion
                      if (jann.eq.ionih(jj)) then
                         nat(k) = natonh(jj)
                         do ll=1,3
                            xyz(ll,k) = xyzi(ll,jj)
                         end do
                      endif
                  end do
               endif
               read(iun2,'(a)',err=1000) line
            endif
         endif
      endif

      if (dfree.eq.0.and.ig03.eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
      endif

      if (dfree.ne.0.or.ig03.eq.1) then
      
         cnam = '   '
         if (nstr.gt.3) nstr = 3
         cnam(1:nstr) = str(1:nstr)
         call tocap(cnam,3)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            nsh = itype
         endif
      else
c         if (ig03.gt.0) then
c            read(line,'(1x,a3,1x,i3)',err=1000) cnam, nsh
c         else
c            read(line,'(1x,a3,1x,i2)',err=1000) cnam, nsh
c         endif
         if (ig03.eq.0) then
            read(line,'(1x,a3,1x,i2)',err=1000) cnam, nsh
         endif
      endif

      i = i + 1
      shelln(i)  = nsh
      if (ioni.eq.1) then
         jan(i)     = k
         gx(i)      = xyz(1,k)
         gy(i)      = xyz(2,k)
         gz(i)      = xyz(3,k)
      else
         jan(i)     = jann
         gx(i)      = xyz(1,jann)
         gy(i)      = xyz(2,jann)
         gz(i)      = xyz(3,jann)
      endif
      call settc(cnam,shellt(i),shellc(i))
      shella(i)  = mm
      shladf(i)  = mmdf
         do 20 j = 1, shelln(i)
           if (shellt(i).eq.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c1(mm)
                  else
                     read(iun2,1030,err=1000) exx(mm), c1(mm)
                  endif
               endif
           endif
           if (shellt(i).eq.1.and.shellc(i).eq.1) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c2(mm)  = r(2)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c2(mm)
                  else
                     read(iun2,1030,err=1000) exx(mm), c2(mm)
                  endif
               endif
           endif
           if (shellt(i).eq.1.and.shellc(i).ne.1) then
               if (dfree.ne.0) then
                  if (gnreal(r,3,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                     c2(mm)  = r(3)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c1(mm), c2(mm)
                  else
                     read(iun2,1030,err=1000) exx(mm), c1(mm), c2(mm)
                  endif
               endif
           endif
           if (shellt(i).eq.2.and.shellc(i).eq.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,4,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                     c2(mm)  = r(3)
                     c3(mmdf)= r(4)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) 
     &                        exx(mm), c1(mm), c2(mm), c3(mmdf)
                  else
                     read(iun2,1030,err=1000) 
     &                        exx(mm), c1(mm), c2(mm), c3(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif
           if (shellt(i).eq.2.and.shellc(i).ne.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c3(mmdf)= r(2)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c3(mmdf)
                  else
                     read(iun2,1030,err=1000) exx(mm), c3(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif
           if (shellt(i).eq.3) then 
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c4(mmdf)= r(2)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c4(mmdf)
                  else
                     read(iun2,1030,err=1000) exx(mm), c4(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif
           if (shellt(i).eq.4) then 
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c5(mmdf)= r(2)
                  endif
               else
                  if (ig03.gt.0) then
                     read(iun2,1040,err=1000) exx(mm), c5(mmdf)
                  else
                     read(iun2,1030,err=1000) exx(mm), c5(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif
   20      mm = mm + 1
      goto 10

1000  call inferr('error While reading Basis set!',1)
      istats = 0
      return
      end

      subroutine fndcal(itarg,isel,indx,istat)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=5000)
      parameter (mxchai=50)
      parameter (mxheta=50)
      parameter (mxres=42)
      integer reson
      common /calf/ icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),iamicl(mxres),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon

      istat = 1
      do i=1,ncalf
         if (icalf(isel,i).eq.itarg) then
            indx = i
            return
         endif
      end do
      istat = 0
      return
      end

      subroutine files(oempty,idocub)
      implicit double precision (a-h,o-z)
      character keywrd*160, keyori*160
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical oempty
      character fniun*256
c      character temps*80
      common /fnunit/ fniun
      common /keywrd/ keywrd,keyori

c
c----- process FILE or CUBE directive --------------------
c
      idocub = 0
      i = index(keywrd,'FILE')
      if (i.eq.0) then
         i = index(keywrd,'GAUCUB')
         idocub = 1
      endif
      if (i.ne.0) then
         ind = i + 4
         i   = index(keywrd(ind:160),'=')
         do j=i+ind,160
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j
         do j=ind1,160
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1
         open(unit=iun2,form='formatted',file=keyori(ind1:ind2),
     &        status='old',err=2200)
         fniun = keyori(ind1:ind2)
      else
         call inferr('Keyword FILE not supplied !!',1)
         oempty = .true.
      endif

      return

2200  write(iun3,*) 
     &   'File '//keyori(ind1:ind2)//' does not exist !!!!!!!'
c      call inferr(temps,1)
      oempty = .true.
      return
      end

      subroutine filmap(mapit)
      implicit double precision (a-h,o-z)
      character keywrd*160, keyori*160
      common /keywrd/ keywrd,keyori
      character*80 mapfil
      common /maphlp/ mapfil

c
c----- process MAPFIL directive --------------------
c
      mapit = 0
      i = index(keywrd,'MAPFIL')
      if (i.ne.0) then
         mapit = 1
         ind = i + 4
         i   = index(keywrd(ind:160),'=')
         do j=i+ind,160
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j
         do j=ind1,160
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1
         mapfil = keyori(ind1:ind2)
      endif

      return
      end

      program ambfor
c
c  AMBER General Force Field for organic mol. (June, 2003)
c  The AMBFOR implementation:
c  
c   1 X   Placeholder for wildcard
c   2 c   Sp2 C carbonyl group 
c   3 c1  Sp C
c   4 c2  Sp2 C  
c   5 c3  Sp3 C
c   6 ca  Sp2 C in pure aromatic systems
c   7 cp  Head Sp2 C that connect two rings in biphenyl sys. 
c   8 cq  Head Sp2 C that connect two rings in biphenyl sys. identical to cp 
c   9 cc  Sp2 carbons in non-pure aromatic systems
c  10 cd  Sp2 carbons in non-pure aromatic systems, identical to cc
c  11 ce  Inner Sp2 carbons in conjugated systems
c  12 cf  Inner Sp2 carbons in conjugated systems, identical to ce
c  13 cg  Inner Sp carbons in conjugated systems
c  14 ch  Inner Sp carbons in conjugated systems, identical to cg
c  15 cx  Sp3 carbons in triangle systems
c  16 cy  Sp3 carbons in square systems
c  17 cu  Sp2 carbons in triangle systems
c  18 cv  Sp2 carbons in square systems
c  19 h1  H bonded to aliphatic carbon with 1 electrwd. group  
c  20 h2  H bonded to aliphatic carbon with 2 electrwd. group 
c  21 h3  H bonded to aliphatic carbon with 3 electrwd. group 
c  22 h4  H bonded to non-sp3 carbon with 1 electrwd. group 
c  23 h5  H bonded to non-sp3 carbon with 2 electrwd. group 
c  24 ha  H bonded to aromatic carbon  
c  25 hc  H bonded to aliphatic carbon without electrwd. group 
c  26 hn  H bonded to nitrogen atoms
c  27 ho  Hydroxyl group
c  28 hp  H bonded to phosphate 
c  29 hs  Hydrogen bonded to sulphur 
c  30 hw  Hydrogen in water 
c  31 hx  H bonded to C next to positively charged group  
c  32 f   Fluorine
c  33 cl  Chlorine 
c  34 br  Bromine 
c  35 i   Iodine 
c  36 n   Sp2 nitrogen in amide groups
c  37 n1  Sp N  
c  38 n2  aliphatic Sp2 N with two connected atoms 
c  39 n3  Sp3 N with three connected atoms
c  40 n4  Sp3 N with four connected atoms 
c  41 na  Sp2 N with three connected atoms 
c  42 nb  Sp2 N in pure aromatic systems 
c  43 nc  Sp2 N in non-pure aromatic systems
c  44 nd  Sp2 N in non-pure aromatic systems, identical to nc
c  45 ne  Inner Sp2 N in conjugated systems
c  46 nf  Inner Sp2 N in conjugated systems, identical to ne
c  47 nh  Amine N connected one or more aromatic rings 
c  48 no  Nitro N  
c  49 o   Oxygen with one connected atom
c  50 oh  Oxygen in hydroxyl group
c  51 os  Ether and ester oxygen
c  52 ow  Oxygen in water 
c  53 p2  Phosphate with two connected atoms 
c  54 p3  Phosphate with three connected atoms, such as PH3
c  55 p4  Phosphate with three connected atoms, such as O=P(CH3)2
c  56 p5  Phosphate with four connected atoms, such as O=P(OH)3
c  57 pb  Sp2 P in pure aromatic systems 
c  58 pc  Sp2 P in non-pure aromatic systems
c  59 pd  Sp2 P in non-pure aromatic systems, identical to pc
c  60 pe  Inner Sp2 P in conjugated systems
c  61 pf  Inner Sp2 P in conjugated systems, identical to pe
c  62 px  Special p4 in conjugated systems
c  63 py  Special p5 in conjugated systems
c  64 s   S with one connected atom 
c  65 s2  S with two connected atom, involved at least one double bond  
c  66 s4  S with three connected atoms 
c  67 s6  S with four connected atoms 
c  68 sh  Sp3 S connected with hydrogen 
c  69 ss  Sp3 S in thio-ester and thio-ether
c  70 sx  Special s4 in conjugated systems
c  71 sy  Special s6 in conjugated systems
c
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxamb=701)
      parameter (mxgff=71)
      character line*132,fniun*132
      character argstr*75
      logical opfil,gargpl,osingl
      common /fnam/ fniun, lenf
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /opts/ idebug,imon,iarc,ilog,osingl
      character*3 ambstr
      character*2 gffstr
      common /ffstr/ ambstr(mxamb), gffstr(mxgff)
      data (ambstr(i),i=1,100) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','HC ','CT ','HC ','CT ','HC ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CT ','HC ','CT ','HC ','CT ','HC ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ','HC ',
     & 'CT ','HC ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','H1 ','OH ','HO ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','H1 ','OH ','HO ','CT ','HC ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','H1 ','SH ','HS ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','H1 ','S  ','N  ','CT ','C  ','O  ','H1 '/
      data (ambstr(i),i=101,200) /
     & 'CT ','HC ','CT ','HC ','CT ','H1 ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CA ','CA ','HA ','CA ','HA ','CA ',
     & 'HA ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CA ',
     & 'CA ','HA ','CA ','HA ','C  ','OH ','HO ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','C* ','CW ','H4 ','CB ','NA ',
     & 'H  ','CN ','CA ','HA ','CA ','HA ','CA ','HA ','CA ','HA ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CC ','NA ',
     & 'H  ','CW ','H4 ','CR ','H5 ','NA ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','CC ','NA ','H  ','CV ','H4 ',
     & 'CR ','H5 ','NB ','N  ','CT ','C  ','H  ','O  ','H1 ','CT '/
      data (ambstr(i),i=201,300) /
     & 'HC ','CC ','NB ','CW ','H4 ','CR ','H5 ','NA ','H  ','N  ',
     & 'CT ','C  ','H  ','O  ','H1 ','CT ','HC ','C  ','O2 ','N  ',
     & 'CT ','C  ','H  ','O  ','H1 ','CT ','HC ','C  ','O  ','N  ',
     & 'H  ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ',
     & 'HC ','C  ','O2 ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HC ','CT ','HC ','C  ','O  ','N  ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','CT ','H1 ','S  ','CT ','H1 ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ','HC ',
     & 'CT ','HC ','CT ','HP ','N3 ','H  ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CT ','HC ','CT ','H1 ','N2 ','H  '/
      data (ambstr(i),i=301,400) /
     & 'CA ','N2 ','H  ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HC ','CT ','HC ','CT ','HP ','N3 ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','HC ','CT ','HC ','C  ','O  ','C  ','H  ','O  ','CT ',
     & 'HC ','C  ','O  ','N  ','H  ','N  ','H  ','CT ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  '/
      data (ambstr(i),i=401,500) /
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HP ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  '/
      data (ambstr(i),i=501,600) /
     & 'N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ',
     & 'O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ',
     & 'C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ',
     & 'N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ',
     & 'O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ',
     & 'C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ',
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 '/
      data (ambstr(i),i=601,659) /
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ',
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','OW ','HW ',
     & 'Li+','Na+','K+ ','Rb+','Cs+','Mg+','Ca+','Zn+','Cl-'/

c     some neutral residues

      data (ambstr(i),i=660,671) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'C  ','O  ','OH ','HO '/ 
      data (ambstr(i),i=672,685) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'CT ','HC ','C  ','O  ','OH ','HO '/ 
      data (ambstr(i),i=686,701) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'CT ','HC ','CT ','HC ','CT ','HP ','N3 ','H  '/ 

c GAFF
      data gffstr /
     &  'x ', 'c ', 'c1', 'c2', 'c3', 'ca', 'cp', 'cq', 'cc', 'cd',
     &  'ce', 'cf', 'cg', 'ch', 'cx', 'cy', 'cu', 'cv', 'h1', 'h2',
     &  'h3', 'h4', 'h5', 'ha', 'hc', 'hn', 'ho', 'hp', 'hs', 'hw',
     &  'hx', 'f ', 'cl', 'br', 'i ', 'n ', 'n1', 'n2', 'n3', 'n4',
     &  'na', 'nb', 'nc', 'nd', 'ne', 'nf', 'nh', 'no', 'o ', 'oh',
     &  'os', 'ow', 'p2', 'p3', 'p4', 'p5', 'pb', 'pc', 'pd', 'pe',
     &  'pf', 'px', 'py', 's ', 's2', 's4', 's6', 'sh', 'ss', 'sx',
     &  'sy'/

      idebug = 0
      osingl = .false.
      imon = 0
      iarc = 0
      ilog = 0
      gtol = 0.01d0
      nsd  = 100000
  
      n = iargc()

      if (idebug.eq.1) then
         if (.not.opfil(61,"log",5,1,0,0)) then
            stop
         endif
      endif

      icnt = 1
      do while (icnt.le.n)
         call getarg(icnt,line)
         if (idebug.eq.1) write(61,*) "=",line,"="
         if (line(1:1).eq.'-') then

            if (line(1:2).eq.'-v') then
               idebug = 1
            elseif (line(1:2).eq.'-m') then
               imon = 1
            elseif (line(1:2).eq.'-n') then
               ilog = 1
            elseif (line(1:2).eq.'-a') then
               iarc = 1
            elseif (line(1:2).eq.'-s') then
               osingl = .true.
            elseif (line(1:2).eq.'-g') then
               if (gargpl('-g',icnt,line,argstr)) then
                  gtol = reada(argstr,1,len(argstr))
               endif
            elseif (line(1:2).eq.'-c') then
               if (gargpl('-c',icnt,line,argstr)) then
                  read(argstr,*) nsd
               endif
            else 
               if (idebug.eq.1) then
                 write(61,*) 'Unknown commandline option '//line(1:2)
               else
                 print*, 'Unknown commandline option '//line(1:2)
                 print*, 
     &           'Usage: ambfor [commandline options] ambfor_file[.xyz]'
                 print*, ' '
                 print*, '  Commandline options:'
                 print*, '    -m     - used in conjuction with molden'
                 print*, '             produces a file per iteration:'
                 print*, '             ambfor_file.001 etc.'
                 print*, '    -n     - write optimisation details to '
                 print*, '             ambfor_file.log'
                 print*, 
     &             '    -a     - concatenate intermediate structures'
                 print*, 
     &             '             into an archive file : ambfor_file.arc'
                 print*, ' '
                 print*, 
     &             'Optimised structure in file ambfor_file_opt.xyz' 
               endif
               stop
            endif

         else

            lenf = index(line,' ')-1
            if (linlen(line).gt.lenf) lenf = linlen(line)
            call fndchr(line(1:lenf),lenf,'.',idot)
            call fndchr(line(1:lenf),lenf,'/',isl)
            if (idot.gt.0.and.idot.gt.isl) then
               fniun = line(1:idot-1)
            else
               fniun = line(1:linlen(line))
            endif
            lenf = linlen(fniun)
            if (idebug.eq.1) 
     &         write(61,*) fniun(1:lenf),lenf
            call opfiles
            icnt = n

         endif

         icnt = icnt + 1

      end do

      if (idebug.eq.1) then
         write(61,*) "end of argument parsing"
         write(61,*) "gtol=",gtol," nsd=",nsd
         close(61)
      endif

      call param

      call getinp(istat)

      call conn34(istat)

      call bndarr(istat)
      call angarr(istat)
      call itrarr(istat)
      call torarr(istat)
      call asschg

      call optimise(emin,gtol,nsd)

      call wrtout(iun3,emin)
      close(iun3)

      if (iarc.eq.1) close(iun4)
      if (ilog.eq.1) close(iun5)

      end

      subroutine opfiles
      implicit double precision (a-h,o-z)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character fniun*132
      common /fnam/ fniun, lenf
      common /opts/ idebug,imon,iarc,ilog,osingl
      character fniunt*132
      logical opfil, osingl

      fniunt = fniun(1:lenf)//'.xyz'
      lenft = lenf + 4

      if (opfil(48,fniunt,lenft,1,1,0)) then
         iun2 = 48
         fniunt = fniun(1:lenf)//'_opt.xyz'
         lenft = lenf + 7
         if (opfil(50,fniunt,lenft,1,0,0)) then
            iun3 = 50
         else
            print*,'Cant open output file !'//fniunt(1:lenft)
            stop
         endif

         if (iarc.eq.1) then
            fniunt = fniun(1:lenf)//'.arc'
            lenft = lenf + 4
            if (opfil(60,fniunt,lenft,1,0,0)) then
               iun4 = 60
            else
               print*,'Cant find/open arc file !'//fniunt(1:lenft)
               stop
            endif
         endif

         if (ilog.eq.1) then
            fniunt = fniun(1:lenf)//'.log'
            lenft = lenf + 4
            if (opfil(70,fniunt,lenft,1,0,0)) then
               iun5 = 70
            else
               print*,'Cant find/open log file !'//fniunt(1:lenft)
               stop
            endif
         else
            iun5 = 6
         endif

      else
         print*,'Cant find/open file !'//fniunt(1:lenft)
         stop
      endif

      return
      end

      logical function opfil(iun,filenm,lenfn,iform,iold,isil)
      implicit double precision (a-h,o-z)
      character*(*) filenm
      character*7 stat

      opfil = .true.

      if (iold.eq.1) then
          stat = 'old'
      else
          stat = 'unknown'
      endif

      if (lenfn.eq.0.or.filenm.eq.' ') then
          print*, 'Invalid Filename !'
          opfil = .false.
      else
          close(iun)
          if (iform.eq.1) then
             open(unit=iun,form='formatted',file=filenm,
     &               status=stat,err=100)
          else
             open(unit=iun,form='unformatted',file=filenm,
     &               status=stat,err=100)
          endif
      endif

      return

100   print*,'Error Opening File !'

      opfil = .false.
      return
      end

      subroutine crprod(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit double precision (a-h,o-z)
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end
      subroutine crpros(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit double precision (a-h,o-z)
      real b
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end

      subroutine wrtoud(iun,emin,iconn,ityp,coo,q)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxamb=701)
      parameter (mxgff=71)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      character*3 chtmp,ambstr
      character*2 gffstr
      common /ffstr/ ambstr(mxamb), gffstr(mxgff)
      dimension icnn(mxcon)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),ityp(*)

c write tinker .xyz file

      write(iun,*) '[AMBFOR]'
      write(iun,'(i5,a,f9.3,a)') iatoms,' emin ',emin,
     &   ' molden generated AMBFOR .xyz (amber/gaff param.)'

      do i=1,iatoms

            ibnds = 0
            do j=1,iconn(1,i)
               if (iconn(j+1,i).gt.0) then
                  ibnds = ibnds + 1
                  icnn(ibnds) = iconn(j+1,i)
               endif
            end do

            iopt = 1
            itypi = ityp(i)

            if (itypi.gt.0) then

c Amber
                if (itypi.le.mxamb) then
                  chtmp = ambstr(itypi)
                  if (itypi.gt.mxamb) itypi = itypi + (2000-mxamb)
                endif

                write(iun,'(i6,2x,a3,1x,3(f9.3),1x,i3,1x,8i5)')
     &            iopt,chtmp,(coo(j,i),j=1,3),
     &            itypi,(icnn(j),j=1,ibnds)

            elseif (ityp(i).lt.0) then

c GAFF
                if (iabs(itypi).le.mxgff) then
                  chtmp = gffstr(iabs(itypi))//' '
                endif

                write(iun,'(i6,2x,a3,1x,3(f9.3),1x,i3,1x,f6.3,1x,8i5)')
     &            iopt,chtmp,(coo(j,i),j=1,3),
     &            itypi,q(i),(icnn(j),j=1,ibnds)
            endif


      end do

      return
      end

      subroutine getxyd(igetxy,heat,iaddprv,
     &                        coo,ianz,iaton,iatclr,iconn,qat)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*2 catom, catomt, tolowf,iel
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (maxsym=108)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /cllab/  iclon,iclpnt(4)
      common /surf/   natorg,noscnd
      common /cell/ nat,norg,icent,inorm,ico(3,8),icn(4,8),icol(32),ncon
      character*137 line
      common /curlin/ line
      logical favail,oxyz,doconv,dozme,gusirc
      integer xmol
      common /getpnt/ irtype,ipdbon,ipdbgro,xmol,favail,oxyz,
     &                doconv,dozme,gusirc
      logical mopac,gamess,gauss,molpot,elpot,chemx,oisbin,cpmd,
     &        gamus,ctoz,adfin,chpot,qchem,orca
      common /choic/  mopac,gamess,gauss,molpot,elpot,chemx,cpmd,
     &                oisbin,gamus,ctoz,adfin,chpot,qchem,orca
      common /xyzopt/ ixyz,ichx,icrtp,ipdbwh,iambch
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /celpar/ xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,nspg,kz
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      logical addcel,gnreal,dall
      dimension iel(maxsym),icel(8),rr(3,3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),
     &          qat(*)
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x ','oo','oa','ob','oc','ab','bc','ac','zz'/

      igetxy = 1
      addcel = .false.
      dall = .false.
      ncell = 0
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)

c get number of atoms

      if (gusirc) then
         call searcht(line,'***** BEGIN IRC',
     &      'TIME                Q          P',
     &      'KINETIC       POTENTIAL       TOTAL',istat)
         if (istat.eq.0) goto 100
         igust = 0
         if (index(line,'KINETIC').ne.0.or.
     &       index(line,'TIME').ne.0) then
            igust = 1
            call readel(line,1)
         endif
      else
         if (getlin(0).eq.1) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               if (iaddprv.eq.1) then
                   iscst = iatoms
                   nscnd = itype
                   natoms = nscnd
                   if (iatoms+nscnd.gt.mxnat) then
                       dall = .true.
                       goto 100
                   endif
               else
                   iscst = 0
                   iatoms = itype
                   natoms = iatoms
                   if (iatoms.gt.mxnat) then
                       dall = .true.
                       goto 100
                   endif
               endif
            else
               goto 100
            endif
         else
            goto 100
         endif
      endif

c get Heat of formation

      heat = 0.0d0
      heato = 0.0d0
      iefnd = 0
      if (getlin(1).eq.1) then
          do while(.true.)
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (gusirc) then
                if (ktype.eq.1) then
                    if (nstr.eq.2) then
                       if (str.eq.'E=') iefnd = 1
                    endif
                endif
             endif
             if (ktype.eq.3) then
                heato = heat
                heat = rtype
             endif
             if (gusirc) then
                if (ktype.eq.0.or.(ktype.eq.3.and.iefnd.eq.1)) then
                   if (igust.eq.1) heat = heato
                   goto 110
                endif
             else
                if (ktype.eq.0.or.ktype.eq.3) goto 110
             endif
          end do
      else
         goto 100
      endif
      
110   continue

      if (gusirc) then
         if (igust.eq.1) then
            call search(line,'CARTESIAN COORDINATES',istat)
         endif
         call readel(line,1)
         iatoms = 0
         do while (getlin(0).eq.1)

            if (line(1:4).eq.' ---') goto 120
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               if (nstr.ge.4) then
                  if (str(1:4).eq.'****') goto 120
                  if (str(1:4).eq.'MASS') goto 120
               endif
            endif
            iatoms = iatoms + 1

            if (igust.eq.0) ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               ianz(iatoms) = int(rtype)
            else
               goto 100
            endif

            if (.not.gnreal(coo(1,iatoms),3,.false.)) goto 100
c            print*,(coo(i,iatoms),i=1,3)
         end do

120      continue
         backspace iun2
         call doconn
         ihaszm = 0
         return
      endif

      do iat=iscst+1,iscst+natoms
         if (getlin(0).eq.1) then
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.1) then
                 iatmp = 0
                 if (nstr.eq.1) then
                    catomt(1:1) = str(1:1)
                    catomt(2:2) = ' '
                 else
                    catomt = str(1:2)
                 endif
                 catom = tolowf(catomt)
                 do j=1,maxsym
                    if (catom .eq. iel(j)) iatmp = j - 1
                 end do
                 if (catom.eq.'xx') iatmp = 99
                 if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100
                 if (iatmp.eq.106.and.ncell.eq.0) iatmp = 89
                 if (iatmp.gt.99) then
                    icel(iatmp-99) = iat
                    addcel = .true.
                    ncell = ncell + 1
                 else
                    if (addcel) then
                        call inferr('Cell points before atoms',1)
                        goto 100
                    endif
                 endif
                 ianz(iat) = iatmp
           else
              goto 100
           endif
           do i=1,4
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) then
                 if (i.eq.4) then
                    qat(iat) = rtype
                    ihasq = 1
                 else
                    coo(i,iat) = rtype / toang
                 endif
              else
                 if (i.ne.4) goto 100
              endif
           end do
        else
          goto 100
        endif
      end do

      iatoms = natoms + iscst

c look for cell data

      if (getlin(0).ne.1) goto 130
      if (getlin(0).ne.1) then
         backspace iun2
         goto 130
      endif

      if (icdex(line,'Unit cell').eq.0) then

         backspace iun2
         backspace iun2

      else

         do i=1,3
           if (getlin(0).eq.1) then
              if (.not.gnreal(rr(1,i),3,.false.)) goto 100
           endif
         end do
         nspg = 1
         a = vlen(rr(1,1))
         b = vlen(rr(1,2))
         c = vlen(rr(1,3))
         call impsc(rr(1,2),rr(1,3),csa)
         call impsc(rr(1,1),rr(1,3),csb)
         call impsc(rr(1,1),rr(1,2),csc)
         alpha = dacos(csa)*todeg
         beta = dacos(csb)*todeg
         gamma = dacos(csc)*todeg
         call prcell
         call setop
         call cprot(nspg,.false.)
         call prop
         call cpmol(coo,ianz,iatclr,iconn)

         chemx = .true.
         ichx = 1
         call fdat(1,0,0,0,0,0)

      endif

130   continue

      if (iaddprv.eq.1) then
         do i=iscst+1,iscst+nscnd
             do j=1,3
                iaton(i) = 1
             end do
         end do
      endif

      if (addcel) iatoms = iatoms - 8
      if (iaddprv.eq.1) then
         call convar(coo,iconn,ianz,nscnd,iscst)
      else
         call cooxyz(ianz,iatoms)
         call doconn
      endif
      if (addcel) then
         natorg = iatoms
         iclon = 1
         iclpnt(1) = icel(1)
         iclpnt(2) = icel(2)
         iclpnt(3) = icel(3)
         iclpnt(4) = icel(4)
         do i=1,8
            l = icel(i)
            iconn(1,l) = icn(1,i)
            do j=2,4
               iconn(j,l) = iatoms + icn(j,i)
            end do
            ianz(l) = 100
            iatclr(l) = 11
         end do
         iatoms = iatoms + 8
      endif

      if (iaddprv.eq.0) ihaszm = 0

      return
100   if (dall) then
         rewind iun2
         iatoms = iscst
         igetxy = -1
         return
      endif
      igetxy = 0
      return
      end

      subroutine aln2md(iopt,istat,
     &                  coo,ianz,iaton,iatclr,iresid)
      implicit double precision (a-h,o-z)
      logical fndsnd,ocen
      parameter (mxpsav=100)
      common /athlp/ iatoms, mxnat
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /cllmat/rrx(3),rry(3),rrz(3),tr(3),tz(3),tzorg(3),itz
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)
      common /cllsav/rdum(12,mxpsav),npsav
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension vec1(3),vec2(3),vec3(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*)

      istat = 1
      fndsnd = .false.
      ocen = .true.

      ialtyp = iopt

      if (ialtyp.eq.0) then
         call getxyz(igetxy,heat,1)
         if (igetxy.eq.1) then
             fndsnd = .true.
         else
             fndsnd = .false.
         endif
         if (.not.fndsnd) then
             call rdsrf(iun2,istats,iesp,1,0)
             if (istats.eq.1) fndsnd = .true.
         endif
         if (.not.fndsnd) then
            print*,'This is not an xyz or molden surface file !'
            istat = 0
            return
         endif
      else if (ialtyp.eq.1) then
         ioatms = iatoms
         do i=1,iatoms
            if (iresid(i).le.0.and.iresid(i).ge.-3) then
               ioatms = i - 1
               goto 3000
            endif
         end do
3000     namols = namols + 1
         iatoms = ioatms
         iscst = ioatms
         
         call pdbstd(istat,.true.,1)
         if (istat.eq.-1) then
            call allcoo(50000)
            call pdbstd(istat,.true.,1)
         endif
         if (istat.eq.1) then
            fndsnd = .true.
            call xyzcoo(0,1,1)
c
c commented out calfa because it added hydrogens to structure1 in 
c the space of structure 2: it SHOULD NOT do that
c            call calfa(istat,1,1,ioatms+1,1,1)
c
            call dohcon(2)
            ocen = .false.
            nscnd = iatoms - ioatms
         else
            istat = 0
            print*,'This is not a valid PDB file !'
            return
         endif
      else if (ialtyp.eq.2) then
         namols = namols + 1
         fndsnd = .true.
         ialtyp = 1
         ocen = .false.
      endif

      if (fndsnd) then

         call cntvec(vec1,coo,ianz,iscst)
         call cntvec(vec2,coo(1,iscst+1),ianz(iscst+1),nscnd)

         do i=1,3
             vec3(i) = vec1(i) - vec2(i) 
         end do

         if (ialtyp.ne.1) then

            do i=1,nscnd
               call trcoo(vec3,coo(1,iscst+i))
            end do

            do i=1,3
               tr(i) = vec1(i)
            end do

         else

c set center of mol2  (tr)
c set pos mol2 to center of mol1 (tz)

            do i=1,3
               tr(i) = vec2(i)
               if (iocnt.eq.1) then
                  tz(i) = vec3(i)
               else
                  tz(i) = 0.0d0
               endif
            end do
c
c           copy coordinates of second molecule to the top of the
c           coordinate array
c
            nstrt = mxnat-nscnd
            do i=1,nscnd
               do j=1,3
                  coo(j,nstrt+i) = coo(j,iscst+i)
               end do
               ianz(nstrt+i) = ianz(iscst+i)
            end do
         endif

         if (ocen) call docent


         do i=1,iscst
             if (ianz(i).ne.100) then
                iatclr(i) = 1
             endif
         end do
         do i=iscst+1,iscst+nscnd
             iatclr(i) = 5
             iaton(i) = 1
             iresid(i) = -4
         end do

         if (ialtyp.eq.1) then
c vec1 is just a dummy in this case, doesnt do anything
c            call inirot
            call clini
            call alnrot(vec1,1)
            call ligzmt
            call pmfass(0,0)
            npsav = 0
         endif

         call mtinv3
         call rarbxi
         call rarbyi
         call rarbzi

      endif

      return
      end

      subroutine alnrod(vec,irot,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension vec(3),tzt(3)
      dimension coo(3,*)

      nstrt = mxnat-nscnd

      if (irot.eq.1) then

c do rotation

         if (ialtyp.eq.1) then

            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               coo(1,iscst+i) = 
     &           (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)+t(1)
               coo(2,iscst+i) = 
     &           (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)+t(2)
               coo(3,iscst+i) = 
     &           (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)+t(3)
               do j=1,3
                  coo(j,iscst+i) = coo(j,iscst+i) + tz(j)
               end do
            end do

         else

            do i=iscst+1,iscst+nscnd
               x = coo(1,i)
               y = coo(2,i)
               z = coo(3,i)
               coo(1,i) = 
     &            (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)+t(1)
               coo(2,i) = 
     &            (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)+t(2)
               coo(3,i) = 
     &            (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)+t(3)
            end do

         endif

      else

c do translation

         if (ialtyp.eq.1) then
            do j=1,3
               tz(j) = tz(j) - vec(j)
            end do
            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               coo(1,iscst+i) = 
     &           (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)+t(1)
               coo(2,iscst+i) = 
     &           (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)+t(2)
               coo(3,iscst+i) = 
     &           (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)+t(3)
               do j=1,3
                  coo(j,iscst+i) = coo(j,iscst+i) + tz(j)
               end do
            end do
            do j=1,3
               tzt(j) = tzorg(j) - tz(j)
            end do
            vl = vlen(tzt)
            if (vl.gt.1.0) call updres
         else
            do i=iscst+1,iscst+nscnd
               do j=1,3
                  coo(j,i) = coo(j,i) - vec(j)
               end do
            end do
            do j=1,3
               t(j) = t(j) + vec(j)
            end do
         endif

      endif

      return
      end

      subroutine alnsorg(iatom,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension coo(3,*)

      nstrt = mxnat-nscnd

      if (ialtyp.eq.1) then

         if (iatom.le.iscst) then
             call inferr('This is not an atom of docked molecule !',0)
             return
         endif
         im = iatom - iscst

         x = coo(1,nstrt+im)
         y = coo(2,nstrt+im)
         z = coo(3,nstrt+im)

         xn = 
     &      (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)-(x-t(1))
         yn = 
     &      (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)-(y-t(2))
         zn = 
     &      (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)-(z-t(3))

         t(1) = x
         t(2) = y
         t(3) = z

         tz(1) = tz(1) + xn
         tz(2) = tz(2) + yn
         tz(3) = tz(3) + zn

      else

         do i=1,3
            t(i) = coo(i,iatom)
         end do

      endif


      return
      end

      subroutine alnsav()
      implicit double precision (a-h,o-z)
      parameter (mxpsav=100)
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /cllsav/rxs(3,mxpsav),rys(3,mxpsav),rzs(3,mxpsav),
     &               tzs(3,mxpsav),npsav

      if (npsav.lt.mxpsav) then
         npsav = npsav + 1

         do j=1,3
            rxs(j,npsav) = rx(j)
            rys(j,npsav) = ry(j)
            rzs(j,npsav) = rz(j)
            tzs(j,npsav) = tz(j)
         end do

      endif

      return
      end

      subroutine alnwrd(coo,ianz)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /athlp/ iatoms, mxnat
      parameter (mxpsav=100)
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /cllsav/rxs(3,mxpsav),rys(3,mxpsav),rzs(3,mxpsav),
     &               tzs(3,mxpsav),npsav
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      character*2 ggstr,tocapf, elemnt
      common /elem/elemnt(mxel)
      logical opfil
      dimension xyzt(3)
      dimension coo(3,*),ianz(*)

      toang = 0.52917706d0
      iun = 46
      ires = 1
      nstrt = mxnat-nscnd

      do l=1,npsav
         if (opfil(iun,'pose.'//ggstr(l-1),7,1,0,0)) then
            write(iun,'(a)') 'HEADER'
            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               xyzt(1) = (x-t(1))*rxs(1,l)+(y-t(2))*rxs(2,l)+
     &                   (z-t(3))*rxs(3,l)+t(1)
               xyzt(2) = (x-t(1))*rys(1,l)+(y-t(2))*rys(2,l)+
     &                   (z-t(3))*rys(3,l)+t(2)
               xyzt(3) = (x-t(1))*rzs(1,l)+(y-t(2))*rzs(2,l)+
     &                   (z-t(3))*rzs(3,l)+t(3)
               do j=1,3
                  xyzt(j) = xyzt(j) + tzs(j,l)
               end do
               ian = ianz(nstrt+i)
               write(iun,'(a6,i5,1x,a4,1x,i3,2x,i4,4x,3f8.3)')
     &            'HETATM',i,tocapf(elemnt(ian))//'  ',
     &             ires,ires,(xyzt(j)*toang,j=1,3)
            end do
            close(iun)
         endif
      end do

      return
      end

      subroutine alnsed(isel,coo)
      implicit double precision (a-h,o-z)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      logical fyesno,backb
      integer dolabs,fancy,persp,shade,atcol
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      dimension isel(6),isel1(3),isel2(3),vec(3),coo(3,*)

      do i=1,3
         j = isel((i-1)*2+1)
         if (j.le.iscst) then
            isel1(i) = j
         else
            call inferr('Not atom of molecule 1',0)
            return
         endif
         j = isel((i-1)*2+2)
         if (j.gt.iscst) then
            isel2(i) = j - iscst
         else
            call inferr('Not atom of molecule 2',0)
            return
         endif
      end do

      do i=1,3
          vec(i) = coo(i,isel(1)) - coo(i,isel(2))
      end do

      do i=1,nscnd
         call trcoo(vec,coo(1,iscst+i))
      end do
   
      call alntwo(coo,isel1,coo(1,iscst+1),nscnd,isel2)

      call setorg(isel(2))

      irtcel = 0

      return
      end

      subroutine getchd(igetca,qat)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      integer getlin
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character*137 str
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*137 line
      common /curlin/ line
      logical gnreal
      dimension r(3),qat(*)

      igetca = 1
      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            iatoms = itype
            if (iatoms.ne.natoms) goto 100
         else
            goto 100
         endif
      else
         goto 100
      endif
      call readel(line,1)

      do i=1,iatoms
         if (getlin(0).eq.1) then
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.ne.1) goto 100
           if (.not.gnreal(r,3,.false.)) goto 100
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.3) then
               qat(i) = rtype
           else
               goto 100
           endif
         endif
      end do

      ihasq = 1

      return
100   igetca = 0
      return
      end

      double precision function deter(r)
      implicit double precision (a-h,o-z)
      dimension r(3,3)
c  calculate the determinant of a 3x3 matrix

      deter = r(1,1)*r(2,2)*r(3,3) - r(1,3)*r(2,2)*r(3,1) +
     &        r(2,1)*r(3,2)*r(1,3) - r(2,3)*r(3,2)*r(1,1) +
     &        r(3,1)*r(1,2)*r(2,3) - r(3,3)*r(1,2)*r(2,1)
      return
      end

      subroutine invmat3(r,ri)
      implicit double precision (a-h,o-z)
      dimension r(3,3),ri(3,3)

c  invert matrix M

      det = deter(r)
      ri(1,1) = (r(2,2)*r(3,3)-r(2,3)*r(3,2)) / det
      ri(1,2) = (r(1,3)*r(3,2)-r(1,2)*r(3,3)) / det
      ri(1,3) = (r(1,2)*r(2,3)-r(1,3)*r(2,2)) / det
      ri(2,1) = (r(2,3)*r(3,1)-r(2,1)*r(3,3)) / det
      ri(2,2) = (r(1,1)*r(3,3)-r(1,3)*r(3,1)) / det
      ri(2,3) = (r(1,3)*r(2,1)-r(1,1)*r(2,3)) / det
      ri(3,1) = (r(2,1)*r(3,2)-r(2,2)*r(3,1)) / det
      ri(3,2) = (r(1,2)*r(3,1)-r(1,1)*r(3,2)) / det
      ri(3,3) = (r(1,1)*r(2,2)-r(1,2)*r(2,1)) / det

      return
      end

      subroutine getmod(igetmo,coo,qat,ianz,iconn)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (maxsym=108)
      character*80 title
      character*2 catom, catomt, tolowf,iel
      character*5 vers
      common /athlp/ iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*137 line
      common /curlin/ line
      character*137 cas,nsc
      common /regis/  cas,nsc
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      logical ocorin
      dimension iel(maxsym),ichg(8),iqtmp(8)
      dimension coo(3,*),ianz(*),qat(*),iconn(mxcon+1,*)
      data iel/'lp',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x ','oo','oa','ob','oc','ab','bc','ac','zz'/

      igetmo = 1
      ocorin = .false.

      iatoms = 0
      nbnds = 0

      toang = 0.52917706d0

c get title line

      read (iun2,'(a)',end=100,err=100) title
      if (title(1:4).eq.'$$$$') then
         call readel(line,1)
         read (iun2,'(a)',end=100,err=100) title
      endif

      read (iun2,'(a)',end=100,err=100) line

      read (iun2,'(a)',end=100,err=100) line
      if (line(1:6).eq.'Corina') ocorin = .true.

      read (iun2,'(a)',end=100,err=100) line
      if (linlen(line).ge.39) then
         read (line,'(i3,i3,6x,i1,21x,a5)',end=100,err=100) 
     &   iatoms,nbnds,ister,vers
         if (vers.ne.'V2000'.and.vers.ne.'V3000') goto 100
      else
         if (ocorin) then
            if (linlen(line).ge.6) then
               read (line,'(i3,i3)',end=100,err=100) 
     &            iatoms,nbnds
            endif
         else
            goto 100
         endif
      endif

      do i=1,mxnat
         qat(i) = 0.0d0
      end do
      ichgrec = 0

      do i=1,iatoms
         read (iun2,'(3f10.4,1x,a2,6x,i3)',end=100,err=100) 
     &       (coo(j,i),j=1,3),catomt,itchg
         do j=1,3
            coo(j,i) = coo(j,i) / toang
         end do
         iatmp = 0
         catom = tolowf(catomt)
         do j=1,maxsym
            if (catom .eq. iel(j)) iatmp = j - 1
         end do
         if (catom.eq.'lp') iatmp = 99
         if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100
         ianz(i) = iatmp
         qat(i) = dble(itchg)
         iconn(1,i) = 0
      end do

      do i=1,nbnds
         read (iun2,'(3i3)',end=100,err=100) 
     &      iat1,iat2,ibndtyp
         if (iconn(1,iat1).lt.mxcon) then
            iconn(1,iat1) = iconn(1,iat1) + 1
            iconn(1+iconn(1,iat1),iat1) = iat2
         endif
         if (iconn(1,iat2).lt.mxcon) then
            iconn(1,iat2) = iconn(1,iat2) + 1
            iconn(1+iconn(1,iat2),iat2) = iat1
         endif
      end do


      do while (.true.) 
         read (iun2,'(a)',end=200,err=100) line
         if (linlen(line).ge.1) then
            if (line(1:6).eq.'M  CHG') then
               ihasq = 1
               if (ichgrec.eq.0) then
                  do i=1,iatoms
                     qat(i) = 0.0d0
                  end do
                  ichgrec = 1
               endif
               nchg = 0
               read(line,'(6x,i3)') nchg
               read(line,'(9x,8(1x,i3,1x,i3))') 
     &               (ichg(i),iqtmp(i),i=1,nchg)
               do i=1,nchg
                 qat(ichg(i)) = dble(iqtmp(i))
               end do
            else
               if (index(line,'<NSC>').ne.0) then
                  read (iun2,'(a)',end=200,err=100) nsc
               endif
               if (index(line,'<CAS_RN>').ne.0) then
                  read (iun2,'(a)',end=200,err=100) cas
               endif
            endif
         endif
      end do

      call cooxyz(ianz,iatoms)
200   continue
      ihaszm = 0

      return
100   igetmo = 0
      return
      end

      subroutine outmod(iun,coo,ianz,iconn)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxcon=10)
      parameter (maxsym=108)
      parameter (mxel=100)
      character*2 elemnt,tocapf
      character*3 atom,atomt
      common /athlp/  iatoms, mxnat
      common /elem/   elemnt(mxel)
      character*137 line
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)

      toang = 0.52917706d0
      natoms = iatoms
      nbnds = 0
      idochg = 0

      do i=1,natoms
         do j=1,iconn(1,i)
            if (iconn(1+j,i).gt.0) then
               if (iconn(1+j,i).gt.i) nbnds = nbnds + 1
            endif
         end do
      end do

      write(iun,'(a)') ' '
      write(iun,'(a)') '  -MOLDEN-'
      write(iun,'(a)') 'Molden generated mol file'
      write(iun,'(i3,i3,a)') natoms,nbnds,
     &          '  0  0  0  0  0  0  0  0999 V2000'

      do i=1,natoms
         atomt = '   '
         atomt(1:2) = tocapf(elemnt(ianz(i)))
         call leftj(atomt,atom)
         write(iun,'(3f10.4,a1,a3,a)') (coo(j,i)*toang,j=1,3),' ',
     &      atom, ' 0  0  0  0  0  0  0  0  0  0  0  0'
      end do

      do i=1,natoms
         do j=1,iconn(1,i)
            k = iconn(1+j,i)
            if (k.gt.0) then
               if (k.gt.i) then
                  ibt = ibtyp(i,k,idochg,0,ianz)
                  write(iun,'(3i3,a)') i,k,ibt,
     &               '  0  0  0  0'
               endif
            endif
         end do
      end do

      write(iun,'(a)') 'M  END'

      return
      end
